
RCS file: /cvsroot/fontforge/fontforge/fontforge/stamp.c,v
Working file: stamp.c
head: 1.2016
branch:
locks: strict
access list:
symbolic names:
	by-features: 1.1718.0.2
	features: 1.1716
	nomen: 1.965.0.2
	DirectEncoding: 1.675.0.2
keyword substitution: kv
total revisions: 2091;	selected revisions: 2091
description:
----------------------------
revision 1.2016
date: 2007/08/30 21:57:30;  author: pfaedit;  state: Exp;  lines: +2 -2
Got IUP style interpolation wrong.
If the glyph isn't latin then see if the blue values can provide us with hints as to its bounds.
----------------------------
revision 1.2015
date: 2007/08/30 20:52:11;  author: pfaedit;  state: Exp;  lines: +2 -2
Previous patch that tried to keep interpolated points interpolated when points moved around them, broke selecting all points and moving them (in quadratic mode).
----------------------------
revision 1.2014
date: 2007/08/30 20:39:35;  author: pfaedit;  state: Exp;  lines: +2 -2
Change from "Embolden" to "Change Weight"
Include an option to retain counter sizes in embolden (means we must extend the glyph slightly.
----------------------------
revision 1.2013
date: 2007/08/30 15:39:28;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch by Alexej to improved diagonal & curved stem hinting:
* If the algorithm is going to define a diagonal stem basing on
a point and that point has 'nextline' or 'prevline' properties filled,
then I use the line's vector (instead of that point's own vector)
for the new stem. This gives us more certainty that all points
positioned on the same line will be correctly detected.

* I think I have found a consistent method to calculate "active"
space for curved segments: instead of some "magic" manipulations with
control point coordinates, I use WalkSpline() with a larger allowed
offset. The advantage of this method is that the result depends
solely from the spline configuration (well, unless the spline
segment we are checking is too short), and thus it produces nealy
the same results for cubic and quadratic splines.

* I use more "liberal" checks for curved chunks, if both sides of
the stem are curved at the same direction.

* Probably the most noticeable change: I have moved ghost hint detection
to stemdb.c. There were 2 reasons for which I considered this necessary:
first, I wanted to use winding numbers to check if we are at the correct
side of the spline (the previous algorithm sometimes produced odd
effects due to the lack of this test), and second, it looks an
interesting idea for me to base the autoinstructor directly on the
stem detector output rather than on the PS hints layout. So it is
important that the stem detector now collects really all information
which may be of interest for the autoinstructor.
----------------------------
revision 1.2012
date: 2007/08/30 04:05:41;  author: pfaedit;  state: Exp;  lines: +2 -2
For completeness sake add an Oblique entry to the Styles menu (and move the menu up). Oblique can be done with Transform->Skew, of course, but logically it should be in the Styles menu too.
----------------------------
revision 1.2011
date: 2007/08/30 03:05:00;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. When trying to correct for an italic slant in condense/extend, I made the slant worse. Got the sign backwards.
----------------------------
revision 1.2010
date: 2007/08/30 00:54:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Try a different algorithm for approximating splines by line segments.
This one should show symmetry better.
----------------------------
revision 1.2009
date: 2007/08/29 19:36:16;  author: pfaedit;  state: Exp;  lines: +2 -2
I used to embolden any unknown glyph (when they asked for the lcg method) as if it were latin lower case. Change that to upper case, and make a special check for hebrew to match the height of hebrew letters.
Not sure what to do for other scripts.
----------------------------
revision 1.2008
date: 2007/08/29 19:26:02;  author: pfaedit;  state: Exp;  lines: +2 -2
Even with all my work the fontforge rasterizer has a hard time getting the baseline right. So provide an option to stroke the paths and then call freetype in the Print dlg.
This also will allow people to see unhinted glyphs, a feature someone asked for.
----------------------------
revision 1.2007
date: 2007/08/29 19:18:27;  author: pfaedit;  state: Exp;  lines: +3 -3
Oh dear, rasterizing stroked fonts only worked if multilayer was defined.
----------------------------
revision 1.2006
date: 2007/08/29 03:43:06;  author: pfaedit;  state: Exp;  lines: +2 -2
Try to improve display of stroked fonts.
----------------------------
revision 1.2005
date: 2007/08/29 03:33:59;  author: pfaedit;  state: Exp;  lines: +3 -3
When stroking splines don't let miter joins grow excessively.
If we have points near the top/bottom of embolden which are on hints then
 don't fix those points (normal behavior for hinted points not on the zone)
 but let them be interpolated.
----------------------------
revision 1.2004
date: 2007/08/28 02:25:12;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a Condense/Extend dialog
Rename the "Effects" submenu to be "Styles"
Put Embolden & Condense under Styles.
Get rid of the old MetaFont command.
----------------------------
revision 1.2003
date: 2007/08/27 04:40:03;  author: pfaedit;  state: Exp;  lines: +2 -2
FF would remove instructions from glyphs that had at least two contours the first of which started with a control point.
----------------------------
revision 1.2002
date: 2007/08/27 01:48:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Further improvements on embolden: Make it use horizontal hints. Actually produces fairly reasonable results on tahoma.
----------------------------
revision 1.2001
date: 2007/08/26 15:03:57;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a short cut for Hide Grid in the metrics view.
----------------------------
revision 1.2000
date: 2007/08/26 15:00:54;  author: pfaedit;  state: Exp;  lines: +3 -3
Python 2.5 initializes itself differently from Python 2.[34]. 2.[34] delay the init until an import happens, while 2.5 does it at start up. I just assumed that when I called Py_Initialize that it did so. This led to a crash on 2.[34] when I tried to use my types before the user had tried to import fontforge.
----------------------------
revision 1.1999
date: 2007/08/24 13:40:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Further improvements to tile path.
----------------------------
revision 1.1998
date: 2007/08/23 22:34:06;  author: pfaedit;  state: Exp;  lines: +2 -2
When moving a control point in a ttf font where one side of the cp was a real point, I would allow an implicit point on the far side of the real point to become real.
----------------------------
revision 1.1997
date: 2007/08/23 22:09:37;  author: pfaedit;  state: Exp;  lines: +3 -3
When dragging truetype points around, adjacent implicit points would remain where they were (and not be implicit any longer).
----------------------------
revision 1.1996
date: 2007/08/22 20:35:04;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch from Alexej to auto hint diagonal stems:

* Some straight stems were incorrectly interpreted as curved.
* Asymmetric active zones were generated for symmetric features.
* Projections did not work well.
* SplineFigureOpticalSlope() could distort vertical/horizontal
  vectors, transforming them to slanted.
* StemIsActiveAt() could calculate a wrong winding number if there
  were more than one spline section close enough to the test position.
* Diagonal corner stems could be assigned to point data as next/previous
  stems, thus preventing the adjacent diagonal stem from being correctly
  detected.
* Diagonal corner stems with a flat outer side (stemcheat==3) could be
  considered "too big", if the flat segment was not long enough.
* FF failed to correctly figure out an active space for diagonal corner
  stems of the above (stemcheat==3) type if a stem had its "left" and
  "right" sides swapped.
* Some ratios and "magic" numbers have been adjusted. In particular
  the value of dist_error_diag was too small (in fact it may be too
  small even now).
* I had to rewrite GDFindMismatchedParallelStems() so that it takes
  into account not only stem width, but also the point positions
  relative to each other, since otherwise it sometimes could make
  a really bad choice.
----------------------------
revision 1.1995
date: 2007/08/22 19:55:05;  author: pfaedit;  state: Exp;  lines: +2 -2
FF would randomly crash after removing a lot of glyphs.
----------------------------
revision 1.1994
date: 2007/08/22 19:00:28;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix various bugs in tile path.
----------------------------
revision 1.1993
date: 2007/08/22 18:56:39;  author: pfaedit;  state: Exp;  lines: +2 -2
The knife tool would not cut a contour if it landed on a point.
----------------------------
revision 1.1992
date: 2007/08/22 18:55:29;  author: pfaedit;  state: Exp;  lines: +2 -2
Trying to add a stylename to the size dlg generally caused a crash.
----------------------------
revision 1.1991
date: 2007/08/22 18:51:59;  author: pfaedit;  state: Exp;  lines: +3 -3
All blank lines in the display dlg had the same line spacing as that of the first character displayed in the dlg.
----------------------------
revision 1.1990
date: 2007/08/19 19:46:45;  author: pfaedit;  state: Exp;  lines: +2 -2
I don't think feature files where handling classes defined with '-' properly.
----------------------------
revision 1.1989
date: 2007/08/19 18:23:17;  author: pfaedit;  state: Exp;  lines: +3 -3
Read the "lib" structures from UFO/GLIF files into our python persistant data.
(And write our persistant data out if it's a dict).
----------------------------
revision 1.1988
date: 2007/08/19 01:42:09;  author: pfaedit;  state: Exp;  lines: +2 -2
Back out the patch which brought up a thread to run a validator in the background while the user dawdled over the font save dlg. My allocation routines are not thread safe -- and I have an inexplicable crash to prove it.
----------------------------
revision 1.1987
date: 2007/08/18 23:38:12;  author: pfaedit;  state: Exp;  lines: +3 -3
Add the ability to call hooks (python functions) when various fontforge events take place.
----------------------------
revision 1.1986
date: 2007/08/17 22:45:06;  author: pfaedit;  state: Exp;  lines: +2 -2
Make fontforge's basic types (Point, Contour, and Layer) be picklable so they can now be saved in an sfd file.
----------------------------
revision 1.1985
date: 2007/08/17 19:25:45;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops. With the inclusion of the library check argument, ff would not compile if NODYNAMIC were set.
----------------------------
revision 1.1984
date: 2007/08/17 02:12:32;  author: pfaedit;  state: Exp;  lines: +2 -2
FontForge now stores the "userdata" python members into the sfd file as pickled objects. (FontForge's own types are not currently pickleable).
----------------------------
revision 1.1983
date: 2007/08/16 22:46:54;  author: pfaedit;  state: Exp;  lines: +3 -3
Add the ability to mark a glyph so that just before being saved its references will be unlinked and we will run remove overlap on it. This means the user can work with the references (and get the automatic updating they confer) and still not have a self-intersecting glyph in the output (think Aring, Ccedilla, Eogonek).
----------------------------
revision 1.1982
date: 2007/08/16 03:13:52;  author: pfaedit;  state: Exp;  lines: +2 -2
Create a fontlint script file.
----------------------------
revision 1.1981
date: 2007/08/16 03:09:08;  author: pfaedit;  state: Exp;  lines: +2 -2
A better error message for when validation fails when generating a font.
----------------------------
revision 1.1980
date: 2007/08/15 21:26:23;  author: pfaedit;  state: Exp;  lines: +2 -2
Check ~/.PfaEdit/python for user defined init scripts.
----------------------------
revision 1.1979
date: 2007/08/15 21:23:00;  author: pfaedit;  state: Exp;  lines: +2 -2
Ah. I think this is what I'm supposed to do when a python script I invoke produces an error.
----------------------------
revision 1.1978
date: 2007/08/15 21:16:02;  author: pfaedit;  state: Exp;  lines: +2 -2
Work to make validation more user friendly.
----------------------------
revision 1.1977
date: 2007/08/15 18:00:34;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. Failed to guard the import/export python extensions with ifndef _NO_PYTHON
----------------------------
revision 1.1976
date: 2007/08/15 17:54:34;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops. Forgot to check for scripts that throw errors. Crashed when trying to free a NULL result.
----------------------------
revision 1.1975
date: 2007/08/15 03:45:41;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a validation command. Make the default behavior be to call this before generating fonts.
----------------------------
revision 1.1974
date: 2007/08/13 21:00:22;  author: pfaedit;  state: Exp;  lines: +2 -2
When dumping both apple and opentype bitmap tables if there were a BDF table, then we'd get garbage for 'bloc'/'bhed'.
----------------------------
revision 1.1973
date: 2007/08/13 19:57:20;  author: pfaedit;  state: Exp;  lines: +2 -2
Add some user interface commands to python, and more importantly, add the ability to create menu items which will invoke python scripts, and the ability to add import/export conversion filters (again, python scripts).
----------------------------
revision 1.1972
date: 2007/08/13 19:35:35;  author: pfaedit;  state: Exp;  lines: +3 -3
More diagonal stem work from Alexej.
----------------------------
revision 1.1971
date: 2007/08/12 20:57:33;  author: pfaedit;  state: Exp;  lines: +2 -2
Probably in CJK too.
----------------------------
revision 1.1970
date: 2007/08/12 20:55:22;  author: pfaedit;  state: Exp;  lines: +3 -3
Counter hints for LCG glyphs came out wrong if autohint hand not been applied first.
----------------------------
revision 1.1969
date: 2007/08/10 23:57:36;  author: pfaedit;  state: Exp;  lines: +2 -2
Counter masks were not read out of sfd files properly.
Selecting a counter mask in Glyph Info caused FF to crash.
----------------------------
revision 1.1968
date: 2007/08/10 20:51:13;  author: pfaedit;  state: Exp;  lines: +2 -2
The Execute Script dlg would sometimes complain about invalid scrollbar size when it got closed.
----------------------------
revision 1.1967
date: 2007/08/10 20:43:58;  author: pfaedit;  state: Exp;  lines: +2 -2
AddAnchorPoint (scripting command) should be prepared to cast real args to integers.
----------------------------
revision 1.1966
date: 2007/08/10 20:13:29;  author: pfaedit;  state: Exp;  lines: +3 -3
Just as I needed a special "in use" pass of GSUB when reading from a TTC, so
I also need an "in use" pass of the MATH table.
----------------------------
revision 1.1965
date: 2007/08/10 20:06:27;  author: pfaedit;  state: Exp;  lines: +3 -3
All this time and I've mapped "nonmarkingreturn" (GID=2) to Unicode+000C instead of Unicode+000D. I'm a twit.
----------------------------
revision 1.1964
date: 2007/08/08 20:31:28;  author: pfaedit;  state: Exp;  lines: +2 -2
kerning display is off in a pairwise lookup window if a y position adjustment were requested.
----------------------------
revision 1.1963
date: 2007/08/08 19:25:50;  author: pfaedit;  state: Exp;  lines: +2 -2
Make some effort to retain context when changing encodings.
----------------------------
revision 1.1962
date: 2007/08/08 18:56:19;  author: pfaedit;  state: Exp;  lines: +2 -2
When reverting a compacted font ff thought the font was compacted even when it was not.
----------------------------
revision 1.1961
date: 2007/08/08 18:25:34;  author: pfaedit;  state: Exp;  lines: +2 -2
Metrics View would crash if asked to display a glyph which wasn't in the font.
(introduced by the memory leak fix earlier this week).
----------------------------
revision 1.1960
date: 2007/08/08 18:18:39;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops. The spec does not say that the per-glyph info sub-table may be omitted.
So force a dummy table in even if it will contain nothing.
Similarly for glyph construction.
----------------------------
revision 1.1959
date: 2007/08/06 22:42:39;  author: pfaedit;  state: Exp;  lines: +2 -2
ff scripting command CopyReference() was broken.
----------------------------
revision 1.1958
date: 2007/08/06 22:27:52;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner wants little popup windows in show att. Give him some for substitutions.
----------------------------
revision 1.1957
date: 2007/08/06 21:36:00;  author: pfaedit;  state: Exp;  lines: +2 -2
Warn the user (rather than just silently failing) when we have a freetype version mismatch.
----------------------------
revision 1.1956
date: 2007/08/06 20:34:08;  author: pfaedit;  state: Exp;  lines: +2 -2
If you examined a kerning pair subtable (either with glyph info or from double clicking on the subtable in the lookup pane) and then pressed [OK], and then generated an afm (tfm, old-style kern table, etc.) you would lose all the kern pairs you examined.
----------------------------
revision 1.1955
date: 2007/08/06 19:59:17;  author: pfaedit;  state: Exp;  lines: +2 -2
The math dlg failed to parse italic correction properly in glyph construction.
----------------------------
revision 1.1954
date: 2007/08/06 14:29:02;  author: pfaedit;  state: Exp;  lines: +2 -2
Yesterdays ft2.3.5 patch broke compiling with earlier freetypes.
----------------------------
revision 1.1953
date: 2007/08/06 13:55:38;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch by Barry SCHWARTZ to feature file output on 64bit machines.
----------------------------
revision 1.1952
date: 2007/08/06 04:42:08;  author: pfaedit;  state: Exp;  lines: +2 -2
In freetype 2.3.5 the binary layout of the execution context changed.
This means that if ff is compiled against a 2.3.4 library it can't debug truetype if linked with a 2.3.5 library (and vice versa).
So put in checks to see that the library version matches what we expect.

Also the contents of one of the structures has changed a bit, and a value that used to live in one field has moved to another (the ppem value moved from (exc)->size->metrics.x_ppem to (exc)->size->root.metrics.x_ppem.

Well, David warned me that this might happen.
----------------------------
revision 1.1951
date: 2007/08/05 23:28:45;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch from Barry SCHWARTZ. python fontforge.font.addPosSub was expecting its args inside a redundant tuple.
----------------------------
revision 1.1950
date: 2007/08/05 23:10:03;  author: pfaedit;  state: Exp;  lines: +2 -2
New Vietnamese translation from Clytie.
Also some spelling corrections in the original messages.
----------------------------
revision 1.1949
date: 2007/08/05 22:21:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch by Barry SCHWARTZ to lookup/subtable comparison.
----------------------------
revision 1.1948
date: 2007/08/05 21:52:50;  author: pfaedit;  state: Exp;  lines: +2 -2
More dstem work from Alexej.
----------------------------
revision 1.1947
date: 2007/08/05 21:38:23;  author: pfaedit;  state: Exp;  lines: +2 -2
If a metricsview was open, then creating a new glyph slot would potentially screw up memory and sometimes crashed.
----------------------------
revision 1.1946
date: 2007/08/05 21:27:28;  author: pfaedit;  state: Exp;  lines: +2 -2
Merge (and simplify) still have bugs.
----------------------------
revision 1.1945
date: 2007/08/05 18:48:43;  author: pfaedit;  state: Exp;  lines: +3 -3
Fix two memory leaks in the metrics view (one was huge).
----------------------------
revision 1.1944
date: 2007/08/04 22:30:22;  author: pfaedit;  state: Exp;  lines: +3 -3
Allow editing of math kern device tables (in a textual fashion).
----------------------------
revision 1.1943
date: 2007/08/04 03:38:04;  author: pfaedit;  state: Exp;  lines: +2 -2
Math kerning bug fix.
----------------------------
revision 1.1942
date: 2007/08/04 03:20:49;  author: pfaedit;  state: Exp;  lines: +3 -3
Provide a mechanism for editing math kerning info. Graphical. But with no control over device tables.
----------------------------
revision 1.1941
date: 2007/08/03 02:57:42;  author: pfaedit;  state: Exp;  lines: +2 -2
More diagonal stem hint work from Alexej Kryukov.
----------------------------
revision 1.1940
date: 2007/08/03 00:00:33;  author: pfaedit;  state: Exp;  lines: +2 -2
Diagonal hinting stuff from Alexej Kryukov.
----------------------------
revision 1.1939
date: 2007/08/02 13:58:06;  author: pfaedit;  state: Exp;  lines: +2 -2
If freetype failed to rasterize a glyph, then we would fall back on returning a bitmap image from our own rasterizer -- even if we asked freetype for a greymap. this caused problems when routines expected byte data rather than bit data.
----------------------------
revision 1.1938
date: 2007/08/02 13:47:39;  author: pfaedit;  state: Exp;  lines: +3 -3
If we were given a cff (otf) font, with a bluevalues array which ended in 0 (as [-20 0]) then we would omit the final zero ([-20]).
----------------------------
revision 1.1937
date: 2007/08/02 04:50:39;  author: pfaedit;  state: Exp;  lines: +2 -2
More MATH table bugs.
----------------------------
revision 1.1936
date: 2007/08/01 21:13:16;  author: pfaedit;  state: Exp;  lines: +2 -2
Another bug.
----------------------------
revision 1.1935
date: 2007/08/01 21:10:29;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix more MATH table bugs.
----------------------------
revision 1.1934
date: 2007/08/01 21:03:46;  author: pfaedit;  state: Exp;  lines: +3 -3
Outputting extension subtables appears to have been broken.
The code which was supposed to detect two glyphs with the same set of kerning
pairs and use the same data for them didn't work (forcing us to get an extension table which also didn't work).
----------------------------
revision 1.1933
date: 2007/08/01 03:10:23;  author: pfaedit;  state: Exp;  lines: +3 -3
Fix a few of the more obvious bugs in the MATH table.
----------------------------
revision 1.1932
date: 2007/07/31 02:11:11;  author: pfaedit;  state: Exp;  lines: +3 -3
Ok, all the dialogs are now coded except for mathkerning.
IO is also coded.
----------------------------
revision 1.1931
date: 2007/07/30 04:21:36;  author: pfaedit;  state: Exp;  lines: +3 -3
Code for reading, editing, storing in sfd, but not writing the new 'MATH' table.
----------------------------
revision 1.1930
date: 2007/07/28 00:40:41;  author: pfaedit;  state: Exp;  lines: +3 -3
Add some more checks against non-BMP characters when drawing text.
----------------------------
revision 1.1929
date: 2007/07/26 23:38:04;  author: pfaedit;  state: Exp;  lines: +2 -2
For first characters in the kern pair dlg, when editing class 0, the [Edit] button was enabled but did nothing. Should work now.
----------------------------
revision 1.1928
date: 2007/07/26 23:09:04;  author: pfaedit;  state: Exp;  lines: +2 -2
ff could crash if it tried to create a popup image of the <New> line in the substitution pane of Glyph Info.
Scrolling in the matrix edit widget sometimes forgot to move the column labels.
Add glyph name completion to lookup subtable dlg and glyph info panes.
----------------------------
revision 1.1927
date: 2007/07/26 19:04:08;  author: pfaedit;  state: Exp;  lines: +2 -2
More bugs related to python kerning classes.
----------------------------
revision 1.1926
date: 2007/07/26 17:56:46;  author: pfaedit;  state: Exp;  lines: +2 -2
Initial structure declarations for 'MATH' table.
----------------------------
revision 1.1925
date: 2007/07/26 13:50:34;  author: pfaedit;  state: Exp;  lines: +3 -3
addKerningClass didn't parse its arguments correctly.
----------------------------
revision 1.1924
date: 2007/07/25 20:06:48;  author: pfaedit;  state: Exp;  lines: +2 -2
Alexej Kryukov has replaced the dstem code and says he will try to make them work.
----------------------------
revision 1.1923
date: 2007/07/25 17:40:41;  author: pfaedit;  state: Exp;  lines: +3 -3
Drat. When printing full page glyphs to a pdf file, the glyph was shifted up by almost the full page and we got a second (and incorrect) title.
----------------------------
revision 1.1922
date: 2007/07/24 21:42:34;  author: pfaedit;  state: Exp;  lines: +3 -3
MS proposes two new feature tags with it's new 'MATH' table.
----------------------------
revision 1.1921
date: 2007/07/23 15:07:50;  author: pfaedit;  state: Exp;  lines: +2 -2
Add shortcuts to the anchor control dlg (Page Up/Page Down) to move to the next/previous glyph.
----------------------------
revision 1.1920
date: 2007/07/23 14:50:59;  author: pfaedit;  state: Exp;  lines: +3 -3
Michal Nowakowski has improved the truetype autoinstructor. He warns that it probably still has bugs (as what does not?) so I am leaving the old code available for now. He says it works best in "a clean (uninstructed) font with well defined blue zones and stems".
----------------------------
revision 1.1919
date: 2007/07/23 04:09:39;  author: pfaedit;  state: Exp;  lines: +2 -2
--usage did not document the --last argument.
----------------------------
revision 1.1918
date: 2007/07/23 03:42:50;  author: pfaedit;  state: Exp;  lines: +2 -2
Pdf printing was broken.
Scripting printing was broken.
----------------------------
revision 1.1917
date: 2007/07/23 00:20:57;  author: pfaedit;  state: Exp;  lines: +2 -2
Drat. A change I made to boxes reordered events and caused the open font dlg to crash.
----------------------------
revision 1.1916
date: 2007/07/23 00:17:31;  author: pfaedit;  state: Exp;  lines: +2 -2
Many more tests of the display/print dlg now work.
----------------------------
revision 1.1915
date: 2007/07/22 20:15:21;  author: pfaedit;  state: Exp;  lines: +3 -3
Allow the user to set the number of ligature carets in a glyph. I realize that my mechanism of counting the components of all ligatures isn't always going to give the right answer. In old type1/afm fonts an "ffi" ligature had to be specified as "ff + i", not as "f + f + i". So my algorithm would count two components when it should find 3.
----------------------------
revision 1.1914
date: 2007/07/22 04:50:46;  author: pfaedit;  state: Exp;  lines: +3 -3
Initial version of the new print sample (it works in one test case and it's bedtime).
----------------------------
revision 1.1913
date: 2007/07/20 22:32:10;  author: pfaedit;  state: Exp;  lines: +2 -2
Rewrite the display fonts dlg so it processes features just as metrics view does.
Rewrite the display fonts dlg so that it incorporates print.
Remove the old print command and rename Display to print.
----------------------------
revision 1.1912
date: 2007/07/20 22:19:24;  author: pfaedit;  state: Exp;  lines: +3 -3
Add minimal support for applying apple state machine lookups in metrics view.
Support is minimal because:
   Apple seems to figure line breaks before doing substitution process but
	I do it afterward so I don't know where the line breaks are and I
	can't enter either the line start or line end state.
   When I delete a glyph I delete it. Apple inserts a deleted glyph mark
	and then removes that later. State machines can respond to deleted
	glyphs, but I can't.
   I don't try to figure out which feature,settings should be on by default.
	So the user must pick them out manually.
----------------------------
revision 1.1911
date: 2007/07/19 18:44:42;  author: pfaedit;  state: Exp;  lines: +2 -2
If we have a glyph with multiple encodings, and the secondary encodings occur after the primary ones, then the backmap will probably contain a secondary encoding, which means that when we go to load the font in we will probably notice the secondary encoding twice and forget the primary.
----------------------------
revision 1.1910
date: 2007/07/19 15:12:38;  author: pfaedit;  state: Exp;  lines: +2 -2
Still fixing bugs left from extracting ligature anchors from normal anchors. This time in scripting.
----------------------------
revision 1.1909
date: 2007/07/19 15:08:32;  author: pfaedit;  state: Exp;  lines: +3 -3
Barry SCHWARTZ complains that font info says "fontnames must" but that the cited adobe tech note only says "should". So change "must" to "should".
----------------------------
revision 1.1908
date: 2007/07/18 16:17:07;  author: pfaedit;  state: Exp;  lines: +2 -2
When processing class-based contextual lookups fontforge could not handle class 0 (the class containing "all glyphs not in another class") add code to do that.
----------------------------
revision 1.1907
date: 2007/07/18 15:51:41;  author: pfaedit;  state: Exp;  lines: +3 -3
The LigIndex field of the create anchor point dlg was incorrectly enabled. I used to treat mark to base and mark to lig as the same anchor class and failed to correct this field when I changed that.
----------------------------
revision 1.1906
date: 2007/07/17 22:01:56;  author: pfaedit;  state: Exp;  lines: +2 -2
If the user did not select a Gasp Version (note: active selection was needed, just seeing that it was correct and leaving it didn't work) then [OK] would leave the font with an invalid version and on some systems caused a crash.
----------------------------
revision 1.1905
date: 2007/07/17 21:35:38;  author: pfaedit;  state: Exp;  lines: +3 -3
View->Insert Glyph After didn't work well on a ligature glyph. It would insert the glyph after the first component of the ligature, not after the last -- which would make more sense.
----------------------------
revision 1.1904
date: 2007/07/17 02:42:22;  author: pfaedit;  state: Exp;  lines: +3 -3
Some fixes to --library-status (didn't work on mac).
----------------------------
revision 1.1903
date: 2007/07/15 23:51:11;  author: pfaedit;  state: Exp;  lines: +2 -2
Misnamed some private dict entries when loading from otf.
----------------------------
revision 1.1902
date: 2007/07/15 23:42:34;  author: pfaedit;  state: Exp;  lines: +2 -2
Make entry of ghost hints better.
----------------------------
revision 1.1901
date: 2007/07/15 23:19:51;  author: pfaedit;  state: Exp;  lines: +3 -3
Add the ability to determine whether a point is selected or not from python.
----------------------------
revision 1.1900
date: 2007/07/14 03:32:08;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a mechanism so the user can ask fontforge to check for the existance of optional libraries.
----------------------------
revision 1.1899
date: 2007/07/13 00:59:30;  author: pfaedit;  state: Exp;  lines: +2 -2
Reference some BMP arrays with codepoints outside bmp. Add range checks. Broken by UCS2->UCS4 change.
----------------------------
revision 1.1898
date: 2007/07/13 00:43:11;  author: pfaedit;  state: Exp;  lines: +2 -2
Add popup graphics to the Glyph Info window (as well as the Lookup dlg) to show substitutions, etc.
----------------------------
revision 1.1897
date: 2007/07/13 00:13:06;  author: pfaedit;  state: Exp;  lines: +3 -3
Werner wants GotoChar to be able to switch sub-fonts in a cid keyed font. This may introduce bugs...
----------------------------
revision 1.1896
date: 2007/07/11 22:16:48;  author: pfaedit;  state: Exp;  lines: +2 -2
Revert glyph still wasn't working.
----------------------------
revision 1.1895
date: 2007/07/11 22:09:30;  author: pfaedit;  state: Exp;  lines: +2 -2
Someone complained that using a negative stroke took a very long time but produced correct results. Um. Ok. It's easy always to use the absolute value.
----------------------------
revision 1.1894
date: 2007/07/11 21:44:39;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. The mac uses UCS2 for filenames, so when I moved to UCS4 I should have changed the mac resource file interface.
----------------------------
revision 1.1893
date: 2007/07/11 21:31:20;  author: pfaedit;  state: Exp;  lines: +2 -2
When creating a mac resource file we only set the type/creator fields and failed to initialize the finderFlags.
----------------------------
revision 1.1892
date: 2007/07/11 20:52:44;  author: pfaedit;  state: Exp;  lines: +3 -3
Crash bug in generating a cursive connection anchor sub-table.
----------------------------
revision 1.1891
date: 2007/07/09 01:29:35;  author: pfaedit;  state: Exp;  lines: +2 -2
In TrueType composite glyphs with the USE_MY_METRICS bit set the lock icon wasn't scrolled properly.
----------------------------
revision 1.1890
date: 2007/07/09 00:56:21;  author: pfaedit;  state: Exp;  lines: +2 -2
The change from UCS2 to UCS4 broke text copy/paste.
We failed to add a terminating NUL of the right size in all cases
We continued to use charset=UCS-2 when it should have been UCS-4
----------------------------
revision 1.1889
date: 2007/07/08 23:52:13;  author: pfaedit;  state: Exp;  lines: +3 -3
FF crashed when trying to View->Show ATT on a font that appears to me to contain an invalid 'kern' sub-table. I have removed the proximate cause of the crash. I have provided a warning that the kern table appears invalid. And I have cleaned up my internals after detecting the bad sub-table (I had a lookup with a feature but no script and this caused problems).
----------------------------
revision 1.1888
date: 2007/07/08 01:44:18;  author: pfaedit;  state: Exp;  lines: +2 -2
Multiple substitutions in the metrics view did not properly update the count of glyphs to be displayed.
----------------------------
revision 1.1887
date: 2007/07/08 01:32:06;  author: pfaedit;  state: Exp;  lines: +3 -3
If nothing changed in the metrics input field and the output contained a ligature (or a mult subs I suspect). FF would complain.
----------------------------
revision 1.1886
date: 2007/07/06 22:50:58;  author: pfaedit;  state: Exp;  lines: +3 -3
A recent patch had problems.
----------------------------
revision 1.1885
date: 2007/07/06 00:20:55;  author: pfaedit;  state: Exp;  lines: +2 -2
in python, font.generate() didn't work. The PyArg_ParseTupleAndKeywords behaves in a way I did not expect.
----------------------------
revision 1.1884
date: 2007/07/06 00:11:31;  author: pfaedit;  state: Exp;  lines: +2 -2
[Bottom] and [Down] still didn't work for lookup subtables.
----------------------------
revision 1.1883
date: 2007/07/06 00:05:10;  author: pfaedit;  state: Exp;  lines: +2 -2
Try to force the text field in the metricsview to a fixed size. In some fonts it seems to be initialized to a huge value.
----------------------------
revision 1.1882
date: 2007/07/05 23:37:48;  author: pfaedit;  state: Exp;  lines: +2 -2
Add ability to display italic side bearings in the char view.
----------------------------
revision 1.1881
date: 2007/07/05 23:08:10;  author: pfaedit;  state: Exp;  lines: +2 -2
The lines drawn for italic fonts to show the italic origin and width were at slightly the wrong angle (I used a sine when I should have used a tangent).
----------------------------
revision 1.1880
date: 2007/07/05 22:36:46;  author: pfaedit;  state: Exp;  lines: +2 -2
If a font did not have any horizontal metrics then ff would not set the em-size.
----------------------------
revision 1.1879
date: 2007/07/05 22:29:36;  author: pfaedit;  state: Exp;  lines: +2 -2
Show Att trampled on memory when display apple contextual substitution state machines.
----------------------------
revision 1.1878
date: 2007/07/05 22:28:01;  author: pfaedit;  state: Exp;  lines: +2 -2
Wasn't parsing apple's 'lcar' table properly.
----------------------------
revision 1.1877
date: 2007/07/05 21:58:18;  author: pfaedit;  state: Exp;  lines: +2 -2
if a font contained a 'post' table but didn't name all names (or something like that), then the attempt to name the glyph based on the encoding was broken after the encoding change.
----------------------------
revision 1.1876
date: 2007/07/05 21:38:43;  author: pfaedit;  state: Exp;  lines: +2 -2
FF did not recognize that a bdf file was greymaped. Broken by the bdf properties work a year ago or so.
----------------------------
revision 1.1875
date: 2007/07/05 20:55:55;  author: pfaedit;  state: Exp;  lines: +2 -2
To the subtable dialogs for single, multiple, alternate and ligature substitutions and single positionings add a popup window displaying the glyphs involved.
----------------------------
revision 1.1874
date: 2007/07/05 20:51:05;  author: pfaedit;  state: Exp;  lines: +2 -2
The import lookups button in fontinfo forgot about the subtables (sort of).
----------------------------
revision 1.1873
date: 2007/07/05 13:37:07;  author: pfaedit;  state: Exp;  lines: +2 -2
The metricsview used the wrong count field to determine whether things changed. It used the glyph count, not the char count (which meant that when we had a ligature and the number of chars was greater than the number of glyphs, things got confused.)
----------------------------
revision 1.1872
date: 2007/07/05 13:29:13;  author: pfaedit;  state: Exp;  lines: +3 -3
In the metrics view, anchored attachments only worked if the base glyph were itself unmoved (that is the mark was placed relative to the unmoved location, not the actual location).
----------------------------
revision 1.1871
date: 2007/07/04 00:35:10;  author: pfaedit;  state: Exp;  lines: +2 -2
Usually there would be some skewing when doing a replace under rotation.
----------------------------
revision 1.1870
date: 2007/07/03 22:55:02;  author: pfaedit;  state: Exp;  lines: +2 -2
The search dialog should provide user with control over the error bound.
The rotate checkbox didn't work if the flip checkbox wasn't checked.
----------------------------
revision 1.1869
date: 2007/07/03 16:26:03;  author: pfaedit;  state: Exp;  lines: +3 -3
If a replace contour added a control point to a point that did not have one (went from a line to a curve) then that control point would get lost.
If a search matched across the start point of a contour then search/replace could go into an infinite loop if the search and replace paths were the same.
----------------------------
revision 1.1868
date: 2007/07/02 21:56:40;  author: pfaedit;  state: Exp;  lines: +2 -2
Find/Replace (replace) didn't work on quadratic splines.
----------------------------
revision 1.1867
date: 2007/07/02 21:53:01;  author: pfaedit;  state: Exp;  lines: +2 -2
Add two python methods:
  Layer.interpolateNewLayer(other-layer,amount)
  Font.createInterpolatedGlyph(glyph1,glyph2,amount)
The first creates a new layer by interpolating between the current layer and the layer in the first argument.
The second creates a new glyph in the font by interpolating between the first two arguments. The glyph's unicodecode point and name will be copied from the first argument (the font must not already contain this glyph).
If amount is 0 the result will look like the first glyph, if 1 then like the second.
----------------------------
revision 1.1866
date: 2007/07/02 20:22:00;  author: pfaedit;  state: Exp;  lines: +2 -2
When recovering from a crash, FF would sometimes complain about a mismatched version number. Don't.
----------------------------
revision 1.1865
date: 2007/07/02 19:23:26;  author: pfaedit;  state: Exp;  lines: +3 -3
Problems parsing 'mort' tables could cause a crash.
----------------------------
revision 1.1864
date: 2007/07/01 23:27:36;  author: pfaedit;  state: Exp;  lines: +2 -2
When building a contextual lookup, don't list that lookup as something that it could invoke (ie. list all lookups in this table (GPOS/GSUB) except for ourselves). Don't want to encourage users to create infinite lookup loops.
----------------------------
revision 1.1863
date: 2007/07/01 20:57:33;  author: pfaedit;  state: Exp;  lines: +2 -2
Point matching didn't work when there were references to references and multiple references within a glyph.
----------------------------
revision 1.1862
date: 2007/07/01 19:32:17;  author: pfaedit;  state: Exp;  lines: +2 -2
FF was having problems with extension lookups with multiple sub tables.
----------------------------
revision 1.1861
date: 2007/07/01 18:17:30;  author: pfaedit;  state: Exp;  lines: +2 -2
We were trying to print a trailing NUL in some strings from the fontview.
----------------------------
revision 1.1860
date: 2007/07/01 18:16:16;  author: pfaedit;  state: Exp;  lines: +3 -3
Kerning by classes got broken in metricsview by the addition of support for device tables.
----------------------------
revision 1.1859
date: 2007/07/01 05:41:07;  author: pfaedit;  state: Exp;  lines: +2 -2
Pressing [Bottom] in the lookups tab of Font Info caused a crash.
A GPOS contextual lookup only listed GSUB lookups in the lookup/sequence dlg
Pressing [OK] in the lookup/sequence dlg caused a crash if no lookup selected.
----------------------------
revision 1.1858
date: 2007/07/01 05:19:00;  author: pfaedit;  state: Exp;  lines: +2 -2
Openfontdlg was looking at the filter listbutton rather than the rename namelist listbutton.
----------------------------
revision 1.1857
date: 2007/07/01 05:12:29;  author: pfaedit;  state: Exp;  lines: +3 -3
Another futile attempt at an embolden command.
----------------------------
revision 1.1856
date: 2007/06/29 14:31:41;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops. Goto dlg bug had two parts.
----------------------------
revision 1.1855
date: 2007/06/29 02:19:17;  author: pfaedit;  state: Exp;  lines: +2 -2
mf2pt1 now uses "glyph_dimensions" rather than "bbox"
----------------------------
revision 1.1854
date: 2007/06/29 02:15:04;  author: pfaedit;  state: Exp;  lines: +2 -2
The metrics view should now handle device tables.
----------------------------
revision 1.1853
date: 2007/06/29 02:01:29;  author: pfaedit;  state: Exp;  lines: +2 -2
Goto could crash when used on small encodings.
----------------------------
revision 1.1852
date: 2007/06/29 01:32:10;  author: pfaedit;  state: Exp;  lines: +2 -2
-lang wasn't permitted before -c.
----------------------------
revision 1.1851
date: 2007/06/29 01:29:12;  author: pfaedit;  state: Exp;  lines: +3 -3
Use numeric text fields for anchor positioning.
----------------------------
revision 1.1850
date: 2007/06/26 21:54:56;  author: pfaedit;  state: Exp;  lines: +3 -3
Graham Asher points out that the meanings of underline position in the 'post' table and the FontInfo dictionary are different. One refers to the top of the underline rectangle and one to the center of it.
----------------------------
revision 1.1849
date: 2007/06/18 23:15:11;  author: pfaedit;  state: Exp;  lines: +3 -3
Start on the superstructure for handling OpenType features in the File->Display dialog (we don't yet, this is merely an initial stage on a journey).
----------------------------
revision 1.1848
date: 2007/06/17 19:31:33;  author: pfaedit;  state: Exp;  lines: +3 -3
Align point would crash if the selected point were the end point of a contour (or if the two points around it were in the same place).
----------------------------
revision 1.1847
date: 2007/06/15 14:31:03;  author: pfaedit;  state: Exp;  lines: +2 -2
The baseline was not properly located when displaying it in the fontview.
----------------------------
revision 1.1846
date: 2007/06/15 13:49:32;  author: pfaedit;  state: Exp;  lines: +2 -2
BitmapsAvail would generally cause FF to crash if done from the UI.
----------------------------
revision 1.1845
date: 2007/06/15 13:35:18;  author: pfaedit;  state: Exp;  lines: +3 -3
We seem to be misimplementing an obsolete convention for having duplicate encodings point to the same glyph. Result was that occasionally a glyph would be removed and a pointer to something it refered to would be put in its place.
----------------------------
revision 1.1844
date: 2007/06/15 00:31:16;  author: pfaedit;  state: Exp;  lines: +3 -3
Change the name of activeFontInUI to activeFont
Add an activeGlyph method.
Add the ability to call a python script from a outline view.
----------------------------
revision 1.1843
date: 2007/06/14 03:20:07;  author: pfaedit;  state: Exp;  lines: +2 -2
Hmmm. If a textfield is shifted right, and then resized so there's now room for all the text, the unshift it.
Further tweeks to name completion.
----------------------------
revision 1.1842
date: 2007/06/13 20:57:50;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner suggests that it would be useful to be able to specify wildcards in the goto dlg.
----------------------------
revision 1.1841
date: 2007/06/13 20:12:19;  author: pfaedit;  state: Exp;  lines: +3 -3
Add filename completion to file choosers.
Add glyphname completion to gotodlg.
----------------------------
revision 1.1840
date: 2007/06/11 20:50:58;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops change for Werner re: bounding box didn't work.
----------------------------
revision 1.1839
date: 2007/06/11 00:43:47;  author: pfaedit;  state: Exp;  lines: +3 -3
Werner tells me that lilypond uses a slightly different syntax for the MF2PT1 bbox comment, so make our parsing slightly more generous.
----------------------------
revision 1.1838
date: 2007/06/09 03:13:33;  author: pfaedit;  state: Exp;  lines: +2 -2
When creating a new lookup subtable for an anchored lookup, it did not get marked as having anchor classes and feature file output failed because of that.
----------------------------
revision 1.1837
date: 2007/06/09 03:08:14;  author: pfaedit;  state: Exp;  lines: +2 -2
When outputing single lookups, the feature, script and language tags all had ^A where they should have had the second letter of the tag.
----------------------------
revision 1.1836
date: 2007/06/08 21:05:59;  author: pfaedit;  state: Exp;  lines: +3 -3
Michael Zedler tells me that glyphs output by mf2pt1 contain a line:
 % MF2PT1: bbox 0 90 834 422
where the third (so called) bounding box entry is actually the glyph's advance width. I was reluctant to use this at first, because that clearly isn't something that belongs in a bounding box...
----------------------------
revision 1.1835
date: 2007/06/07 23:48:30;  author: pfaedit;  state: Exp;  lines: +2 -2
Remove the code to produce the old, broken, 'size' feature.
----------------------------
revision 1.1834
date: 2007/06/07 21:53:53;  author: pfaedit;  state: Exp;  lines: +2 -2
Couple of bugs.
----------------------------
revision 1.1833
date: 2007/06/07 14:34:29;  author: pfaedit;  state: Exp;  lines: +3 -3
Add support for Adobe's feature file syntax.
  Use Merge Kern (now Merge Feature) to read one
  Use Element->Font Info->Lookups->popup menu->Save to generate one
----------------------------
revision 1.1832
date: 2007/06/06 20:21:14;  author: pfaedit;  state: Exp;  lines: +2 -2
An earlier patch, designed to make the tabset work in the charview even if the user changed the name, didn't work.
----------------------------
revision 1.1831
date: 2007/06/06 19:28:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Bug in the selection iterator.

Also Max Rabkin points out the docs say the iterator returns selected glyphs rather than encoding slots. Fix the docs, then add a member (.byGlyphs) which will make the iterator return glyphs.
----------------------------
revision 1.1830
date: 2007/06/06 18:31:24;  author: pfaedit;  state: Exp;  lines: +2 -2
Accept contour += (1,2) rather than forcing people to say contour += fontforge.point(1,2)
----------------------------
revision 1.1829
date: 2007/06/06 18:14:38;  author: pfaedit;  state: Exp;  lines: +3 -3
Was using an error return from two setter functions (contour.set_closed, set_is_quadratic) when I should have returned success.
----------------------------
revision 1.1828
date: 2007/06/05 03:19:05;  author: pfaedit;  state: Exp;  lines: +2 -2
#ifs were in the wrong place.
----------------------------
revision 1.1827
date: 2007/06/05 03:06:30;  author: pfaedit;  state: Exp;  lines: +3 -3
Crash when mistyping a glyph name in Glyph Info possub panes. Probably in the equivalent lookup dlgs too.
----------------------------
revision 1.1826
date: 2007/06/04 00:29:30;  author: pfaedit;  state: Exp;  lines: +2 -2
If a glyph contained two copies of another glyph, and one of those copies was off by enough that ff didn't recognize it, the depending on how the contours were ordered, ff might fail to recognize the first glyph too, even though it did match.
----------------------------
revision 1.1825
date: 2007/06/03 22:30:10;  author: pfaedit;  state: Exp;  lines: +2 -2
Add iterators to contours and layers. Python users seem to expect them even when they aren't documented to exist.
----------------------------
revision 1.1824
date: 2007/06/03 21:58:11;  author: pfaedit;  state: Exp;  lines: +2 -2
layer += contour  didn't work in python. I was examining a bit through the wrong data type.
----------------------------
revision 1.1823
date: 2007/06/03 20:50:12;  author: pfaedit;  state: Exp;  lines: +3 -3
Provide a mechanism for copying lookup information from one glyph to another.
----------------------------
revision 1.1822
date: 2007/06/02 22:58:33;  author: pfaedit;  state: Exp;  lines: +2 -2
Loading kerning info from a mac 'FOND' resource was broken by the lookup change.
----------------------------
revision 1.1821
date: 2007/06/02 22:38:37;  author: pfaedit;  state: Exp;  lines: +3 -3
Python scripting command font.createChar didn't. Partial patch from MaxRabkin.
----------------------------
revision 1.1820
date: 2007/06/01 15:01:11;  author: pfaedit;  state: Exp;  lines: +3 -3
Adding a kerning pair from the metrics view would often add two or three pairs with the same character combination and different values.
----------------------------
revision 1.1819
date: 2007/06/01 00:28:52;  author: pfaedit;  state: Exp;  lines: +2 -2
Another remove overlap bug. Introduced recently.
----------------------------
revision 1.1818
date: 2007/06/01 00:03:15;  author: pfaedit;  state: Exp;  lines: +3 -3
Werner still uses Apply Substitutions so I guess I can't get rid of it.
----------------------------
revision 1.1817
date: 2007/05/31 03:26:26;  author: pfaedit;  state: Exp;  lines: +3 -3
Fixes to feature file generation.
We now seem to be parsing feature files properly (but we don't do any semantics yet).
----------------------------
revision 1.1816
date: 2007/05/28 22:35:04;  author: pfaedit;  state: Exp;  lines: +2 -2
Add some dutch styles.
----------------------------
revision 1.1815
date: 2007/05/28 22:19:09;  author: pfaedit;  state: Exp;  lines: +2 -2
Make yet another attempt to correct for rounding errors when loading a postscript font.
----------------------------
revision 1.1814
date: 2007/05/28 22:03:34;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a way to get a fonts filename to python.
----------------------------
revision 1.1813
date: 2007/05/28 21:26:26;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner points out that in scripting I use "break" in an example. It isn't documented to work and I don't implement it but I do show it. Oops. Ok, make it work.
----------------------------
revision 1.1812
date: 2007/05/28 21:15:48;  author: pfaedit;  state: Exp;  lines: +2 -2
Display substitutions was broken.
----------------------------
revision 1.1811
date: 2007/05/28 20:38:14;  author: pfaedit;  state: Exp;  lines: +2 -2
When generating default names for subtables, it is confusing to name them the same as the lookup.
----------------------------
revision 1.1810
date: 2007/05/28 20:32:10;  author: pfaedit;  state: Exp;  lines: +3 -3
USC4 needs more work.
----------------------------
revision 1.1809
date: 2007/05/28 13:17:22;  author: pfaedit;  state: Exp;  lines: +2 -2
Change to using USC4 from UCS2 internally.
----------------------------
revision 1.1808
date: 2007/05/28 03:17:05;  author: pfaedit;  state: Exp;  lines: +2 -2
Provide default names for lookups once the user sets the feature.
----------------------------
revision 1.1807
date: 2007/05/28 03:13:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Disambiguate some strings for the polish translation
----------------------------
revision 1.1806
date: 2007/05/28 03:08:31;  author: pfaedit;  state: Exp;  lines: +3 -3
Revert glyph should not work for old sfd files.
----------------------------
revision 1.1805
date: 2007/05/11 21:48:29;  author: pfaedit;  state: Exp;  lines: +2 -2
Loading some afm files would go into an infinite loop.
----------------------------
revision 1.1804
date: 2007/05/11 21:23:34;  author: pfaedit;  state: Exp;  lines: +2 -2
[Import] button on Font Info->Lookups crashed.
----------------------------
revision 1.1803
date: 2007/05/11 21:14:24;  author: pfaedit;  state: Exp;  lines: +2 -2
Sync up.
----------------------------
revision 1.1802
date: 2007/05/11 21:11:29;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix a number of problems related to anchor classes.
----------------------------
revision 1.1801
date: 2007/05/11 20:55:56;  author: pfaedit;  state: Exp;  lines: +3 -3
After the user does an [Add Lookup] we should select the new lookup, to make it easier for him/her to do an [Add Subtable].
----------------------------
revision 1.1800
date: 2007/05/10 05:26:19;  author: pfaedit;  state: Exp;  lines: +2 -2
Couple of cleanups.
  aalt should merge lookups with the same lookup set across scripts.
  Try to pick slightly better names for lookups by default (search for
   entries with the 'dflt' language first).
----------------------------
revision 1.1799
date: 2007/05/09 20:54:46;  author: pfaedit;  state: Exp;  lines: +2 -2
When ff parsed an afm file it only read the first ligature on a line.
----------------------------
revision 1.1798
date: 2007/05/09 19:35:54;  author: pfaedit;  state: Exp;  lines: +2 -2
The [Call...] button in the scripting dialog is meaningless for python scripts (or I don't know how to give it meaning) so disable it.
----------------------------
revision 1.1797
date: 2007/05/09 16:49:47;  author: pfaedit;  state: Exp;  lines: +2 -2
Vertical scrolling in the metrics view tried to scroll the list of features too.
----------------------------
revision 1.1796
date: 2007/05/09 16:44:09;  author: pfaedit;  state: Exp;  lines: +3 -3
Tab, and arrow keys didn't work in the matrixedit widget after I added hidden columns.
Make Return do the expected thing (move to start of next line and create it if possible).
----------------------------
revision 1.1795
date: 2007/05/09 00:45:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch by Pierre to fix uninitialized value when compacting encodings.
----------------------------
revision 1.1794
date: 2007/05/08 23:09:20;  author: pfaedit;  state: Exp;  lines: +3 -3
Typo in realloc of lookups meant that nothing happened (when it should have increased array size by 1).
----------------------------
revision 1.1793
date: 2007/05/07 22:39:39;  author: pfaedit;  state: Exp;  lines: +2 -2
Add the OFL icon to the fontinfo dlg.
----------------------------
revision 1.1792
date: 2007/05/07 20:28:17;  author: pfaedit;  state: Exp;  lines: +3 -3
Further tweaks to the code to start x on the mac.
----------------------------
revision 1.1791
date: 2007/05/06 15:20:10;  author: pfaedit;  state: Exp;  lines: +2 -2
Plugins were broken with regular link configure option.
----------------------------
revision 1.1790
date: 2007/05/06 14:34:56;  author: pfaedit;  state: Exp;  lines: +3 -3
Inkscape can start X on the mac before it tries to connect. Hmm. I can do that too. Inkscape manages to start X without an xterm. I don't know how to do that.
----------------------------
revision 1.1789
date: 2007/05/05 20:56:01;  author: pfaedit;  state: Exp;  lines: +2 -2
When reading PS and CharStrings, the closepath operator didn't allow for rounding errors.
----------------------------
revision 1.1788
date: 2007/05/05 18:14:43;  author: pfaedit;  state: Exp;  lines: +2 -2
Metrics View would crash if more than 20 glyphs entered.
----------------------------
revision 1.1787
date: 2007/05/05 17:30:11;  author: pfaedit;  state: Exp;  lines: +2 -2
Alexej Kryukov points out that it would be nice if moving an anchor point did not set "changed since last hinted.
----------------------------
revision 1.1786
date: 2007/05/05 17:28:28;  author: pfaedit;  state: Exp;  lines: +2 -2
Alexej Kryukov points out that the "changed since last hinted" flag gets set inappropriately.
----------------------------
revision 1.1785
date: 2007/05/05 17:26:22;  author: pfaedit;  state: Exp;  lines: +3 -3
Alexej Kryukov points out that the Anchor control menu item looked as though it had changed, but actually had not.
----------------------------
revision 1.1784
date: 2007/05/01 20:11:16;  author: pfaedit;  state: Exp;  lines: +3 -3
Stupid typo.
----------------------------
revision 1.1783
date: 2007/04/30 22:52:28;  author: pfaedit;  state: Exp;  lines: +2 -2
The context chaining dlg didn't had some buttons off the bottom of the window if you did things "By Glyphs".
----------------------------
revision 1.1782
date: 2007/04/30 20:28:39;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a "lock" icon beside the width line if the glyph contains a reference with the "use my metrics" bit set.
----------------------------
revision 1.1781
date: 2007/04/30 20:06:05;  author: pfaedit;  state: Exp;  lines: +2 -2
When a glyph changed, the metrics view's picture of that glyph would not change.
----------------------------
revision 1.1780
date: 2007/04/30 15:19:37;  author: pfaedit;  state: Exp;  lines: +2 -2
Don't always synchronize width
----------------------------
revision 1.1779
date: 2007/04/30 14:47:06;  author: pfaedit;  state: Exp;  lines: +2 -2
Er. My overlap fixes had some bugs of their own.
----------------------------
revision 1.1778
date: 2007/04/30 13:45:41;  author: pfaedit;  state: Exp;  lines: +3 -3
Patches from Pierre Hanser
- 2 cases of core dump
- 1 case of jumping to the wrong fontinfo sub item when there
  is no anchor class available and trying to add an anchor
----------------------------
revision 1.1777
date: 2007/04/30 03:20:07;  author: pfaedit;  state: Exp;  lines: +2 -2
Select by lookup subtable had several bugs.
----------------------------
revision 1.1776
date: 2007/04/30 02:21:25;  author: pfaedit;  state: Exp;  lines: +3 -3
Finish initial version of python.
Various other small fixes.
----------------------------
revision 1.1775
date: 2007/04/28 12:57:58;  author: pfaedit;  state: Exp;  lines: +3 -3
One final tweak to overlap.
----------------------------
revision 1.1774
date: 2007/04/27 22:37:11;  author: pfaedit;  state: Exp;  lines: +3 -3
More work on remove overlap. (Simplify does more too).
----------------------------
revision 1.1773
date: 2007/04/27 04:06:08;  author: pfaedit;  state: Exp;  lines: +2 -2
Hmm. Maybe it is possible to get rid of some rounding errors in remove overlap.
----------------------------
revision 1.1772
date: 2007/04/26 15:24:07;  author: pfaedit;  state: Exp;  lines: +3 -3
Don't show side bearings when they are 0. The display doesn't make sense.
----------------------------
revision 1.1771
date: 2007/04/26 04:48:53;  author: pfaedit;  state: Exp;  lines: +2 -2
I hope that finishes off the python glyph.
----------------------------
revision 1.1770
date: 2007/04/26 03:03:16;  author: pfaedit;  state: Exp;  lines: +2 -2
FF would destroy memory in the metrics view if the user attempted to display a character which was not in the font.
----------------------------
revision 1.1769
date: 2007/04/25 21:25:58;  author: pfaedit;  state: Exp;  lines: +2 -2
More stuff for python.
  left/right side bearings
  createChar changed
  removeGlyph added.
----------------------------
revision 1.1768
date: 2007/04/25 20:48:11;  author: pfaedit;  state: Exp;  lines: +2 -2
If the use_my_metrics bit is set in a glyph then don't let the user change
the glyph's width.
----------------------------
revision 1.1767
date: 2007/04/25 19:15:32;  author: pfaedit;  state: Exp;  lines: +3 -3
If a font contains glyphs outside of BMP then OS/2 first/last char index get set to 0xffff.
----------------------------
revision 1.1766
date: 2007/04/24 23:02:47;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. Lookups didn't always get the appropriate index assigned to them when generating a font.
----------------------------
revision 1.1765
date: 2007/04/24 22:55:02;  author: pfaedit;  state: Exp;  lines: +3 -3
Bugs in 'PfEd' table, glyph comment subtable.
----------------------------
revision 1.1764
date: 2007/04/21 00:25:30;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a transform command to glyph in python.
----------------------------
revision 1.1763
date: 2007/04/20 23:29:14;  author: pfaedit;  state: Exp;  lines: +2 -2
Find problems didn't find references which intersected.
----------------------------
revision 1.1762
date: 2007/04/20 22:54:55;  author: pfaedit;  state: Exp;  lines: +2 -2
add a selfIntersects command to python.
----------------------------
revision 1.1761
date: 2007/04/20 14:57:32;  author: pfaedit;  state: Exp;  lines: +2 -2
Couple of places where I actually say "FontForge 1.0". Let's bump that to 2.0 now that I've done that for the sfd format.
----------------------------
revision 1.1760
date: 2007/04/20 14:52:52;  author: pfaedit;  state: Exp;  lines: +3 -3
Overlap problems with incorrect path orientations.
----------------------------
revision 1.1759
date: 2007/04/19 23:39:13;  author: pfaedit;  state: Exp;  lines: +3 -3
Add python scripting support for lookups.
Redo the way the size feature was handled.
Redo the way tt instructions were handled.
----------------------------
revision 1.1758
date: 2007/04/18 20:50:45;  author: pfaedit;  state: Exp;  lines: +3 -3
Wasn't handling optical bounds right.
----------------------------
revision 1.1757
date: 2007/04/16 23:23:26;  author: pfaedit;  state: Exp;  lines: +2 -2
Arrow keys didn't work in the charview if the tabset were active.
----------------------------
revision 1.1756
date: 2007/04/16 21:52:33;  author: pfaedit;  state: Exp;  lines: +3 -3
Patches by Pierre Hanser to python scripting.
----------------------------
revision 1.1755
date: 2007/04/16 05:21:08;  author: pfaedit;  state: Exp;  lines: +3 -3
Werner points out that there is no way now to remove individual Pos/Sub data from a glyph (we can remove an entire lookup-subtable, but that's too much). (Old scripting protocol).
----------------------------
revision 1.1754
date: 2007/04/15 03:05:32;  author: pfaedit;  state: Exp;  lines: +3 -3
Add support for glyph level hints to python scripting.
----------------------------
revision 1.1753
date: 2007/04/13 21:15:47;  author: pfaedit;  state: Exp;  lines: +2 -2
I used to use "><" on the font's window title to represent a compacted font. No one understood it. Use "Compacted" instead.
----------------------------
revision 1.1752
date: 2007/04/13 21:12:04;  author: pfaedit;  state: Exp;  lines: +3 -3
Add support for the Pen Protocol.
----------------------------
revision 1.1751
date: 2007/04/12 18:45:20;  author: pfaedit;  state: Exp;  lines: +3 -3
Philipp Poll wants to see the side bearings (I think) in the charview.
----------------------------
revision 1.1750
date: 2007/04/11 20:55:05;  author: pfaedit;  state: Exp;  lines: +2 -2
Nicolas Spalinger of SIL suggests a help button next to [Add OFL] to open a browser on the official OFL site.
----------------------------
revision 1.1749
date: 2007/04/11 20:46:17;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch from Nicolas Spalinger of SIL regarding the verbiage surrounding the OFL in the fontinfo. Also his suggestion to make the tooltip live longer.
----------------------------
revision 1.1748
date: 2007/04/11 20:22:34;  author: pfaedit;  state: Exp;  lines: +2 -2
Patches by Pierre Hanser to the python interface.
----------------------------
revision 1.1747
date: 2007/04/11 14:22:14;  author: pfaedit;  state: Exp;  lines: +3 -3
python bugs
----------------------------
revision 1.1746
date: 2007/04/06 19:00:43;  author: pfaedit;  state: Exp;  lines: +3 -3
Initial version of python scripting.
----------------------------
revision 1.1745
date: 2007/04/03 16:23:56;  author: pfaedit;  state: Exp;  lines: +3 -3
Some tweaks for python.
----------------------------
revision 1.1744
date: 2007/04/01 00:56:03;  author: pfaedit;  state: Exp;  lines: +3 -3
The garbage collection code I put in for autotrace (keeping track of ps arrays)
overflowed the chunk size. So increase it.
----------------------------
revision 1.1743
date: 2007/03/29 22:08:53;  author: pfaedit;  state: Exp;  lines: +3 -3
Replace with Reference didn't check reference offsets correctly.
----------------------------
revision 1.1742
date: 2007/03/27 04:56:27;  author: pfaedit;  state: Exp;  lines: +3 -3
When ff read 'onum' from an sfd file (version 2) of Junicode it stripped the feature/script/lang info.
----------------------------
revision 1.1741
date: 2007/03/25 22:15:13;  author: pfaedit;  state: Exp;  lines: +2 -2
Couple of problems in parsing kern pairs from glyph info.
----------------------------
revision 1.1740
date: 2007/03/25 20:59:35;  author: pfaedit;  state: Exp;  lines: +3 -3
Fix some bugs.
----------------------------
revision 1.1739
date: 2007/03/25 05:21:29;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops, Select by lookup subtable didn't work.
----------------------------
revision 1.1738
date: 2007/03/24 20:56:54;  author: pfaedit;  state: Exp;  lines: +3 -3
fix bugs.
----------------------------
revision 1.1737
date: 2007/03/24 05:15:20;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix some problems with glyph info.
----------------------------
revision 1.1736
date: 2007/03/23 22:56:05;  author: pfaedit;  state: Exp;  lines: +3 -3
The "use new indic scripts" flag should be off by default.
----------------------------
revision 1.1735
date: 2007/03/23 03:05:49;  author: pfaedit;  state: Exp;  lines: +2 -2
Get the links right when the user presses the F1 button in the various new dlgs.
----------------------------
revision 1.1734
date: 2007/03/23 01:24:08;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a pull down list of available script/lang pairs to the script/lang text field in the metrics view.
----------------------------
revision 1.1733
date: 2007/03/22 18:48:13;  author: pfaedit;  state: Exp;  lines: +3 -3
Redo the metrics view so that it applies opentype lookups properly, and give user control of which features are to be applied.

I don't know how to do indic reordering yet, so that presumably doesn't work.
----------------------------
revision 1.1732
date: 2007/03/20 04:37:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix some memory leaks in my postscript interpreter.
----------------------------
revision 1.1731
date: 2007/03/19 21:41:42;  author: pfaedit;  state: Exp;  lines: +2 -2
Victor Gaultney says that, for legal reasons, it is a bad idea to include "unofficial" translations of the OFL in the 'name' table.

So get rid of them.
----------------------------
revision 1.1730
date: 2007/03/19 19:05:50;  author: pfaedit;  state: Exp;  lines: +2 -2
Grr stupid typo in charinfo.
----------------------------
revision 1.1729
date: 2007/03/19 17:32:12;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a French translation of the OFL.
----------------------------
revision 1.1728
date: 2007/03/19 17:17:03;  author: pfaedit;  state: Exp;  lines: +2 -2
I was getting confused by ligature carets, when looking for other psts in the Glyph Info dlg.
----------------------------
revision 1.1727
date: 2007/03/19 16:20:59;  author: pfaedit;  state: Exp;  lines: +2 -2
 Show ATT didn't work for anchors.
----------------------------
revision 1.1726
date: 2007/03/19 14:54:38;  author: pfaedit;  state: Exp;  lines: +3 -3
If one scrolled the fontinfo->lookup window, you could not select things in it.
----------------------------
revision 1.1725
date: 2007/03/19 04:01:36;  author: pfaedit;  state: Exp;  lines: +3 -3
Add some standard classes to the context chaining dlg.
----------------------------
revision 1.1724
date: 2007/03/16 03:17:27;  author: pfaedit;  state: Exp;  lines: +2 -2
The kerning subtable dlg had a layout bug.
Make the "kerning by classes" dlg use boxes.
----------------------------
revision 1.1723
date: 2007/03/15 16:31:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner points out that I missed at least one debug window.
----------------------------
revision 1.1722
date: 2007/03/15 16:24:31;  author: pfaedit;  state: Exp;  lines: +2 -2
Make sure we only generate a postscript name in the name table once.
----------------------------
revision 1.1721
date: 2007/03/15 15:16:10;  author: pfaedit;  state: Exp;  lines: +2 -2
Tell users they should add their email address to the License after pressing the [Add SIL Open Font License] button.
----------------------------
revision 1.1720
date: 2007/03/15 13:30:15;  author: pfaedit;  state: Exp;  lines: +2 -2
The change length button of the cvt dlg didn't work.
----------------------------
revision 1.1719
date: 2007/03/15 13:15:52;  author: pfaedit;  state: Exp;  lines: +3 -3
Input/Output of Apple's 'lcar' table was inconsistent. I don't know if it is "right" now, but at least ff can read back what it wrote.
----------------------------
revision 1.1718
date: 2007/03/14 20:14:24;  author: pfaedit;  state: Exp;  lines: +2 -2
branches:  1.1718.2;
Werner points out that the debug windows show up at odd places if the window gets resized.
----------------------------
revision 1.1717
date: 2007/03/14 14:41:18;  author: pfaedit;  state: Exp;  lines: +3 -3
Not following TeX conventions about character depth.
----------------------------
revision 1.1716
date: 2007/03/13 00:37:16;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a mechanism whereby the SIL Open Font License may be easily specified in the 'name' table.
----------------------------
revision 1.1715
date: 2007/03/12 21:02:37;  author: pfaedit;  state: Exp;  lines: +2 -2
TeX extension lists would be neither read from nor output to tfm files.
----------------------------
revision 1.1714
date: 2007/03/12 20:15:51;  author: pfaedit;  state: Exp;  lines: +3 -3
If the user specified specific TeX height/depth entries in Glyph Info, those data did not get stored in tfm/ofm files properly.
----------------------------
revision 1.1713
date: 2007/03/08 04:55:30;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch from Reuben Thomas to turn off the splashs screen from prefs.
----------------------------
revision 1.1712
date: 2007/03/08 04:25:17;  author: pfaedit;  state: Exp;  lines: +3 -3
Panov points out that I've used the wrong dotlessj code point. Again.
----------------------------
revision 1.1711
date: 2007/03/01 05:06:54;  author: pfaedit;  state: Exp;  lines: +3 -3
If a glyph's point numbers weren't ordered properly (and that should not happen, but did), then when adding ttf instructions to the glyph, the instructions would be thrown out as soon as we noticed this problem. So the user would never see the instructions. Now force the points to be ordered before adding the instructions.
----------------------------
revision 1.1710
date: 2007/02/24 03:46:05;  author: pfaedit;  state: Exp;  lines: +3 -3
FF did not do a very good job of fitting the outline view to an empty glyph.
----------------------------
revision 1.1709
date: 2007/02/18 01:43:34;  author: pfaedit;  state: Exp;  lines: +3 -3
We used to allow the syntax "<number>* command" in ttf instructions (which automagically inserted an implied push). Someone noticed that
PUSHB_1
1
2
would lose the second number and not complain. In fixing that, I broke the first. Now both should work (I hope).
----------------------------
revision 1.1708
date: 2007/02/16 20:04:38;  author: pfaedit;  state: Exp;  lines: +2 -2
Code which I hope will handle German keyboards and make them do what the menu says they should for certain hot keys (brackets, curly brackets, brokets all get different modifier sequences on a german keyboard than an english).
----------------------------
revision 1.1707
date: 2007/02/16 19:19:42;  author: pfaedit;  state: Exp;  lines: +3 -3
If a glyph had no hints then ff could add a hintmask operator (which didn't try to control any hints). Now I can't find anything in the docs which SAYS it's illegal to have a hintmask in a glyph with no fonts, it does seem bad practice, and a program called tx.exe complained about it.
----------------------------
revision 1.1706
date: 2007/02/16 04:19:54;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch by Michal Nowakowski to allow a nicer notation for delta instructions in the instruction editing window:
Example: PUSHB_3 6@12 8 1 DELTAP2

This moves point 8 by six delta-steps (that's clear) at 37 ppem (that's
not clear at first glance - assuming delta_base is 9, DELTAP2 works
from 25 ppem to 25+15 ppem, in this example it's 25+12 ppem).

So it's just a way of constructing an argument byte for DELTAP/C.
----------------------------
revision 1.1705
date: 2007/02/16 03:11:36;  author: pfaedit;  state: Exp;  lines: +3 -3
Allow FontForge's menu shortcuts (hot keys, whatever) to be user definable. We use a gettext based mechanism, type
$ make FontForge-MenuShortCuts.pot
to get a pot file for the process. It needs to be converted to an mo file and
installed in $(prefix)/share/locale/$(LANG)/LC_MESSAGES, just like any other getext file.
----------------------------
revision 1.1704
date: 2007/02/10 02:18:27;  author: pfaedit;  state: Exp;  lines: +3 -3
The Export scripting command did not work as documented. It is documented to export all >selected< glyphs. Instead it exported >all< glyphs.
----------------------------
revision 1.1703
date: 2007/02/09 04:39:36;  author: pfaedit;  state: Exp;  lines: +3 -3
Redo the anchor control dlg.
----------------------------
revision 1.1702
date: 2007/02/06 04:58:01;  author: pfaedit;  state: Exp;  lines: +2 -2
Be a little more lenient about bitmap bounding boxes for empty glyphs.
----------------------------
revision 1.1701
date: 2007/02/05 16:10:46;  author: pfaedit;  state: Exp;  lines: +3 -3
Make the ClearHints scripting command take arguments: "Horizontal" or "Vertical" to allow users to choose to clear either horizontal or vertical hints (the old form with no args still works and clears both, of course).
----------------------------
revision 1.1700
date: 2007/01/30 03:40:36;  author: pfaedit;  state: Exp;  lines: +2 -2
Typo gives us an unititialized variable when saving ufo.
----------------------------
revision 1.1699
date: 2007/01/30 00:16:09;  author: pfaedit;  state: Exp;  lines: +3 -3
Various problems to various anchor dialogs.
----------------------------
revision 1.1698
date: 2007/01/28 18:49:53;  author: pfaedit;  state: Exp;  lines: +3 -3
Pairwise positioning lookups could also get their device table offsets screwed up.
----------------------------
revision 1.1697
date: 2007/01/27 03:54:31;  author: pfaedit;  state: Exp;  lines: +3 -3
If an anchor point contained an x devtab but not a y devtab then it produced a pointer to garbage for the y devtab instead of NUL.
----------------------------
revision 1.1696
date: 2007/01/22 16:10:23;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner points out that if you have a series of the same glyph in a row in the encoding (generally .notdef) and you are in a char view, then pressing Next Glyph does nothing. You are stuck at the same code point. (same thing happens for Prev Glyph).
----------------------------
revision 1.1695
date: 2007/01/22 15:58:45;  author: pfaedit;  state: Exp;  lines: +2 -2
a chinese input method steals keystrokes I use for hot keys (I think). So if users don't want glyph navigation by typing characters in the charview (controled by a preference item) then don't turn on the input method when the window is created.
----------------------------
revision 1.1694
date: 2007/01/22 15:41:13;  author: pfaedit;  state: Exp;  lines: +2 -2
Add hot key for Select->Points on selected contours.
----------------------------
revision 1.1693
date: 2007/01/22 15:16:01;  author: pfaedit;  state: Exp;  lines: +3 -3
Assign "dotlessj" to map to 0x237, the unicode code point, rather than to 0xf6be, the old Adobe private use area. !!!! THIS DOES NOT CONFORM TO THE AGL !!!!!
----------------------------
revision 1.1692
date: 2007/01/20 02:20:54;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops. The gloss for the shift point/contour/zone was slightly off and gave the
wrong information.
----------------------------
revision 1.1691
date: 2007/01/19 02:27:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Add vietnamese font styles (bold, italic, regular, etc.)
From Clytie Siddall.
----------------------------
revision 1.1690
date: 2007/01/19 02:00:48;  author: pfaedit;  state: Exp;  lines: +3 -3
Fixes for rounding errors in finding spline intersections.
----------------------------
revision 1.1689
date: 2007/01/18 05:30:32;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner points out that removing a bitmap glyph from the bitmapview does not force a redisplay in the fontview.
----------------------------
revision 1.1688
date: 2007/01/18 05:16:09;  author: pfaedit;  state: Exp;  lines: +3 -3
Gleep. Werner points out that when generating bitmap strikes, ff would always generate a postscript font to rasterize, so any truetype instructions would be ignored.
----------------------------
revision 1.1687
date: 2007/01/12 21:19:51;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a command to show anchor point attachments within the outline character view (View->Combinations->Anchor Glyph at Point)
----------------------------
revision 1.1686
date: 2007/01/12 00:02:59;  author: pfaedit;  state: Exp;  lines: +2 -2
Force point numbers to be correct when changing glyphs in the charview.
----------------------------
revision 1.1685
date: 2007/01/11 23:26:36;  author: pfaedit;  state: Exp;  lines: +2 -2
Add support for Apple/Adobe's obsolete 'typ1' sfnt. A way of stuffing a type1 font into an sfnt wrapper.
----------------------------
revision 1.1684
date: 2007/01/11 16:16:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Even though the viewbox/output width hieght ratios are different, people want the image scaled the same in svg input.
----------------------------
revision 1.1683
date: 2007/01/11 15:40:45;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a tabs line to the outline char window. If users are going to have only one charview open then they probably want some history too.
----------------------------
revision 1.1682
date: 2007/01/10 21:59:44;  author: pfaedit;  state: Exp;  lines: +3 -3
People would like to have only one charview and double clicking in the fontview just changes the contents of an existing window.
Preference Item: OpenCharsInNewWindow
----------------------------
revision 1.1681
date: 2007/01/07 13:45:10;  author: pfaedit;  state: Exp;  lines: +3 -3
Werner points out that what I call "Type42 CID" should actually be called either "Type11" or "CID Type 2".
----------------------------
revision 1.1680
date: 2007/01/04 23:48:42;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch from Mike FABIAN of suse. Need to increase an array bound in display fonts.
----------------------------
revision 1.1679
date: 2007/01/04 22:48:59;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops, can only set the grayscale field of the freetype exc structure if version number is 2.1.10 or more (It didn't exist before then).
----------------------------
revision 1.1678
date: 2007/01/04 17:25:07;  author: pfaedit;  state: Exp;  lines: +3 -3
Update copyright notices to 2007.
----------------------------
revision 1.1677
date: 2006/12/21 16:26:09;  author: pfaedit;  state: Exp;  lines: +2 -2
ReTag dlg would crash.
----------------------------
revision 1.1676
date: 2006/12/21 16:13:20;  author: pfaedit;  state: Exp;  lines: +3 -3
I had too many code points assigned to Yi.
----------------------------
revision 1.1675
date: 2006/12/20 19:31:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch by  Johan Winge to fix magnification by dragging a rectangle.
----------------------------
revision 1.1674
date: 2006/12/20 19:23:17;  author: pfaedit;  state: Exp;  lines: +3 -3
Uninitialized variable. Patch by Mike FABIAN of suse.
----------------------------
revision 1.1673
date: 2006/12/20 05:32:38;  author: pfaedit;  state: Exp;  lines: +3 -3
Fix a couple of memory leaks.
----------------------------
revision 1.1672
date: 2006/12/18 03:08:17;  author: pfaedit;  state: Exp;  lines: +2 -2
The docs don't mention this, but... mangal.ttf has a NULL offset for the lookahead class definition, so if that happens -- no classes.
----------------------------
revision 1.1671
date: 2006/12/17 14:17:44;  author: pfaedit;  state: Exp;  lines: +3 -3
Werner doesn't like that I always add dummy bitmaps for .notdef, .null & nonmarkingreturn. It seemed logical to me that if I were prepared to add those glyphs to the outline font I should be prepared to add them to the bitmap strike. But Werner (I think) sees bitmap strikes as containing exceptional glyphs which need special handling, whereas I just saw them as complete fonts. So in this context I guess there is no need to add these glyphs.

As a compromise I have decided that I will add the glyphs to the bitmap strike if I added the glyphs to the outline font.
----------------------------
revision 1.1670
date: 2006/12/15 21:56:46;  author: pfaedit;  state: Exp;  lines: +2 -2
Add scripting functions:
  SelectMoreIf
  SelectMoreSingletonsIf
  SelectSingletonsIf
----------------------------
revision 1.1669
date: 2006/12/15 21:39:07;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner cared that the changed flag wasn't being set in Remove ATT.
----------------------------
revision 1.1668
date: 2006/12/15 21:33:04;  author: pfaedit;  state: Exp;  lines: +3 -3
Werner wants a Remove this glyph in the bitmap view.
----------------------------
revision 1.1667
date: 2006/12/15 01:44:18;  author: pfaedit;  state: Exp;  lines: +2 -2
GetPosSub scripting command trashed memory.
----------------------------
revision 1.1666
date: 2006/12/15 01:23:52;  author: pfaedit;  state: Exp;  lines: +2 -2
Make default char of OS/2 be space for otf and .notdef for ttf. This is a guess at what should be done.
----------------------------
revision 1.1665
date: 2006/12/15 00:04:15;  author: pfaedit;  state: Exp;  lines: +2 -2
Add the ability to remove bitmap glyphs from a strike.
----------------------------
revision 1.1664
date: 2006/12/14 21:33:04;  author: pfaedit;  state: Exp;  lines: +3 -3
In a font without any LCG characters, fontforge set the OS/2 capheight and xheight fields to -1e10. It should have been 0. Patch by Roozbeh Pournader.
----------------------------
revision 1.1663
date: 2006/12/13 13:34:16;  author: pfaedit;  state: Exp;  lines: +3 -3
Werner wants to be able to set bitmap magnification in the font view.
----------------------------
revision 1.1662
date: 2006/12/13 01:57:48;  author: pfaedit;  state: Exp;  lines: +2 -2
there was an uninitialized variable used in parsing contextual by coverage table.
----------------------------
revision 1.1661
date: 2006/12/12 23:41:42;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner points out that when double clicking on a bitmap glyph in the font view, the glyph is created / rasterized without using freetype.
----------------------------
revision 1.1660
date: 2006/12/12 23:32:36;  author: pfaedit;  state: Exp;  lines: +2 -2
Still bugs related to FontSize in fontview.
----------------------------
revision 1.1659
date: 2006/12/12 23:12:19;  author: pfaedit;  state: Exp;  lines: +2 -2
FF was still setting firstcharindex in OS/2 incorrectly. The problem is that glyph 1 (or 2?) has encoding 0 in the mac cmap table while it is not referenced at all in the windows cmap.
----------------------------
revision 1.1658
date: 2006/12/12 17:24:03;  author: pfaedit;  state: Exp;  lines: +3 -3
Wasn't setting os2_typelinegap field when reading an sfnt.
----------------------------
revision 1.1657
date: 2006/12/12 03:53:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Sigh. Ok. make the size of the label font in the fontview configurable.
fontforge.FontView.FontSize: 24
----------------------------
revision 1.1656
date: 2006/12/11 23:46:59;  author: pfaedit;  state: Exp;  lines: +2 -2
Allow the user to create an empty bitmap strike.
----------------------------
revision 1.1655
date: 2006/12/11 20:58:50;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch by Roozbeh Pournader. Regular bit in fsSel in OS/2 was being set when it should not have been.
----------------------------
revision 1.1654
date: 2006/12/10 18:51:43;  author: pfaedit;  state: Exp;  lines: +3 -3
Yet more work on the 'gasp' table.
----------------------------
revision 1.1653
date: 2006/12/08 19:31:30;  author: pfaedit;  state: Exp;  lines: +2 -2
Clean up new gasp support (retain version number).
Clean up head table flags.
----------------------------
revision 1.1652
date: 2006/12/08 13:51:41;  author: pfaedit;  state: Exp;  lines: +3 -3
The 'gasp' table has been extended to give users control over clear type. Version number has changed too. FF now supports the new bits, but will convert a version 0 table to a version 1 table.
----------------------------
revision 1.1651
date: 2006/12/07 03:37:29;  author: pfaedit;  state: Exp;  lines: +3 -3
The "Recalculate Bitmaps" button in the bitmap view should adjust its positioning as the window is resized (and be sensitive to other languages which might have different button widths).
----------------------------
revision 1.1650
date: 2006/12/04 22:14:52;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner finds "Original" confusing for an encoding and suggests "Glyph Order" instead.
----------------------------
revision 1.1649
date: 2006/12/04 21:52:33;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner wants me to update the gloss info for GETINFO now that MS has described some new bits for us.
----------------------------
revision 1.1648
date: 2006/12/04 21:06:52;  author: pfaedit;  state: Exp;  lines: +3 -3
The context chain dlg [Set] button didn't work (broken by the encoding change)
Layout is a bit cramped in places.
Set/Select aren't very informative, change to "Set from font"/"Select in Font"
----------------------------
revision 1.1647
date: 2006/12/03 20:23:00;  author: pfaedit;  state: Exp;  lines: +2 -2
Improve the way glyphs are centered in the outline char view. At least I hope it's an improvement.
----------------------------
revision 1.1646
date: 2006/12/03 15:03:49;  author: pfaedit;  state: Exp;  lines: +3 -3
Werner suggests that when looking at a bitmap strike, nextdef and prevdef look at the next glyph defined in the strike rather than the font as a whole. Useful for sparse bitmaps
----------------------------
revision 1.1645
date: 2006/12/03 03:13:14;  author: pfaedit;  state: Exp;  lines: +2 -2
Oh. It is perfectly legal to have a context chain rule with no substitutions. This can be used to avoid matches in complex cases so:
[a-z] a b => does nothing
a b [a-z] => does nothing
a b => substitutes
will only substitute of "ab" is a word all to itself.
----------------------------
revision 1.1644
date: 2006/12/03 02:19:11;  author: pfaedit;  state: Exp;  lines: +2 -2
Be paranoid.
----------------------------
revision 1.1643
date: 2006/12/03 00:34:38;  author: pfaedit;  state: Exp;  lines: +3 -3
Deal with the case where we have a sequence of control points before any indication of curve/qcurve.
----------------------------
revision 1.1642
date: 2006/12/02 01:39:50;  author: pfaedit;  state: Exp;  lines: +2 -2
Didn't do implied points right in quadratic glyphs.
Add support for postscript hints (not part of the UFO/glif standard, but is what RoboFab uses)
----------------------------
revision 1.1641
date: 2006/12/01 21:58:14;  author: pfaedit;  state: Exp;  lines: +3 -3
If the metrics view were displaying text containing non UNICODE characters then some edits in the text field which displays glyphs would leave us with the replacement character showing instead.
----------------------------
revision 1.1640
date: 2006/12/01 04:19:56;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner wants to know whether storage locations are uninitialized or not, and to get warnings when reading an uninit value.
----------------------------
revision 1.1639
date: 2006/12/01 02:26:36;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner wants to see IF statements indented in truetype instruction display.
----------------------------
revision 1.1638
date: 2006/12/01 02:08:29;  author: pfaedit;  state: Exp;  lines: +2 -2
FF wasn't telling freetype to set the mono bit when loading a glyph, which meant that GETINFO would return the wrong value for mono rasterization.
----------------------------
revision 1.1637
date: 2006/12/01 01:58:15;  author: pfaedit;  state: Exp;  lines: +3 -3
If there are too many numbers after an NPUSH[BW] instruction, FF silently ignores them.
----------------------------
revision 1.1636
date: 2006/11/29 14:09:40;  author: pfaedit;  state: Exp;  lines: +3 -3
merge fonts would get the script lang index of merged kern pairs wrong.
----------------------------
revision 1.1635
date: 2006/11/29 03:05:53;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner wants to be able to set memory watch points on storage and cvt locations. Set these through the cvt/storage windows by clicking on the appropriate locations. Modify the points window so the user can set watch points by clicking on it too.
The Points window would sometimes scroll in unexpected ways.
----------------------------
revision 1.1634
date: 2006/11/28 20:16:21;  author: pfaedit;  state: Exp;  lines: +3 -3
Werner wants to see the raw value of a "WS" instruction in the gloss.
----------------------------
revision 1.1633
date: 2006/11/20 22:41:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Hmm. Had explicit code to set OS/2.firstcharindex to 13, when it should be 32 (space). not sure why.
----------------------------
revision 1.1632
date: 2006/11/20 22:32:44;  author: pfaedit;  state: Exp;  lines: +2 -2
Anti-Aliased rasters still weren't aligned properly with the outlines in the debug window.
----------------------------
revision 1.1631
date: 2006/11/20 22:01:00;  author: pfaedit;  state: Exp;  lines: +2 -2
When debugging I provided popup information for anti-aliased rasters. But I didn't for mono rasters.
----------------------------
revision 1.1630
date: 2006/11/20 21:13:30;  author: pfaedit;  state: Exp;  lines: +2 -2
The pixel grid in truetype debugging (RasterGridColor) was invisible against the light blue background.
----------------------------
revision 1.1629
date: 2006/11/20 21:00:54;  author: pfaedit;  state: Exp;  lines: +2 -2
ff would crash when asked to debug fpgm/prep (because my rasterization routine didn't work if there were no contours).
----------------------------
revision 1.1628
date: 2006/11/20 20:45:09;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner wants to turn off auto goto in the charview when debugging is going on.
----------------------------
revision 1.1627
date: 2006/11/20 20:36:50;  author: pfaedit;  state: Exp;  lines: +3 -3
The gloss information for delta point (and cvt) was wrong if the magnitude selector was 7. I claimed it moved (changed) by 0, when it should have been by -1.
----------------------------
revision 1.1626
date: 2006/11/20 01:47:55;  author: pfaedit;  state: Exp;  lines: +2 -2
icc has lots of really stupid warnings.
----------------------------
revision 1.1625
date: 2006/11/19 21:18:32;  author: pfaedit;  state: Exp;  lines: +2 -2
Apostolos points out that NAME_MAX isn't defined on solaris, but _POSIX_NAME_MAX is. But _POSIX_NAME_MAX doesn't seem to be defined on linux.
----------------------------
revision 1.1624
date: 2006/11/19 21:04:27;  author: pfaedit;  state: Exp;  lines: +2 -2
Display fonts would crash if you tried to change the font. But introduced in last release.
----------------------------
revision 1.1623
date: 2006/11/19 20:50:34;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch from Mike FABIAN. Rasterizing by freetype only initialized a variable if CONFIG_TYPE3 (multilayer) was set.
----------------------------
revision 1.1622
date: 2006/11/14 03:33:56;  author: pfaedit;  state: Exp;  lines: +2 -2
StrSplit & StrJoin scripting functions.
----------------------------
revision 1.1621
date: 2006/11/14 02:40:38;  author: pfaedit;  state: Exp;  lines: +3 -3
People asked me to implement the UFO/GLIF format in part because each glyph is stored in a separate file giving finer granularity to version control.
Personally I dislike the UFO format because there is no documentation on how to store GSUB/GPOS features (with the exception of kerning). No support for ligatures nor mark placement. No support for hints or truetype instructions. No support for cid keyed fonts. No support for multi-master fonts. No support for bitmaps. etc.
So I've tweaked my sfd format into an sfdir format: A directory containing separate files for each glyph.
----------------------------
revision 1.1620
date: 2006/11/08 20:04:08;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch by Rüdiger Oertel. Strncat could overflow a buffer.
----------------------------
revision 1.1619
date: 2006/11/08 20:02:17;  author: pfaedit;  state: Exp;  lines: +2 -2
Make simplify do point catagorization, and not just of points changed.
----------------------------
revision 1.1618
date: 2006/11/08 20:00:16;  author: pfaedit;  state: Exp;  lines: +3 -3
Curved stems are also limited by geometry. Can't just assume control points work.
----------------------------
revision 1.1617
date: 2006/11/05 23:32:05;  author: pfaedit;  state: Exp;  lines: +3 -3
Another array bound overflow.
----------------------------
revision 1.1616
date: 2006/11/03 04:52:02;  author: pfaedit;  state: Exp;  lines: +2 -2
Why are pdf files listed as a source of bitmap fonts?
----------------------------
revision 1.1615
date: 2006/11/03 04:51:05;  author: pfaedit;  state: Exp;  lines: +2 -2
Make a black background work.
----------------------------
revision 1.1614
date: 2006/11/02 16:17:33;  author: pfaedit;  state: Exp;  lines: +3 -3
People don't like grey. Let's try something based on Yannis's cream background.
----------------------------
revision 1.1613
date: 2006/10/31 05:03:11;  author: pfaedit;  state: Exp;  lines: +2 -2
Add support for Unified Font Objects (a directory holding many Glyph Interchange Format files). People at the Open Font Library seem to think this is useful. Also support for importing/exporting glyphs in glif.
----------------------------
revision 1.1612
date: 2006/10/30 15:29:21;  author: pfaedit;  state: Exp;  lines: +3 -3
When examining a bitmap font, metrics view would crash when asked to look at a non-existant glyph.
----------------------------
revision 1.1611
date: 2006/10/29 23:12:43;  author: pfaedit;  state: Exp;  lines: +2 -2
The list of verbs for indic glyph rearrangement didn't display.
----------------------------
revision 1.1610
date: 2006/10/29 23:02:55;  author: pfaedit;  state: Exp;  lines: +2 -2
Converting from the mac korean encoding didn't work.
----------------------------
revision 1.1609
date: 2006/10/29 22:13:49;  author: pfaedit;  state: Exp;  lines: +3 -3
Images imported into a bdf character did not set the character used bit.
----------------------------
revision 1.1608
date: 2006/10/27 23:15:37;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a CopyAnchors command.
----------------------------
revision 1.1607
date: 2006/10/27 22:25:55;  author: pfaedit;  state: Exp;  lines: +3 -3
Tweak Raph's patch slightly.
----------------------------
revision 1.1606
date: 2006/10/26 22:53:16;  author: pfaedit;  state: Exp;  lines: +2 -2
Unguarded use of isalpha caused a crash outside of BMP.
----------------------------
revision 1.1605
date: 2006/10/26 22:31:22;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch from Raph Levien. FF mishandled seac if the accent were not translated.
----------------------------
revision 1.1604
date: 2006/10/26 03:08:12;  author: pfaedit;  state: Exp;  lines: +2 -2
It was impossible to set preferences on the Accents pane. They would either always be 0 (or false), or make spurious complaints.
----------------------------
revision 1.1603
date: 2006/10/25 16:46:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a Ucs4 scripting command (reverses Utf8).
----------------------------
revision 1.1602
date: 2006/10/25 16:41:37;  author: pfaedit;  state: Exp;  lines: +3 -3
when creating an array with [...] notation I forgot to dereference lvalues.
----------------------------
revision 1.1601
date: 2006/10/24 16:23:42;  author: pfaedit;  state: Exp;  lines: +2 -2
Minor tweaks to the FontImage cmd.
----------------------------
revision 1.1600
date: 2006/10/24 15:58:17;  author: pfaedit;  state: Exp;  lines: +2 -2
Add scripting commands
	Revert
	RevertToBackup
Make the "+" operator concatenate arrays
  [1,2] + [3,4] == [1,2,3,4]
  [1,2] + 3 == [1,2,3]
----------------------------
revision 1.1599
date: 2006/10/24 15:44:28;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a scripting command, FontImage, which generates a font thumbnail.
----------------------------
revision 1.1598
date: 2006/10/24 02:06:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Make it possible to save the Font Display dlg as an image.
----------------------------
revision 1.1597
date: 2006/10/24 00:16:19;  author: pfaedit;  state: Exp;  lines: +2 -2
Get rid of the concept of "unhinted truetype" from the display fonts dlg.
Convert the display fonts dlg to boxes.
----------------------------
revision 1.1596
date: 2006/10/23 20:56:08;  author: pfaedit;  state: Exp;  lines: +2 -2
At Andrey V. Panov's request I have added a scripting command "CopyUnlinked" which behaves like Copy except that any references will be unlinked (turned into splines) as they are placed in the clipboard.
----------------------------
revision 1.1595
date: 2006/10/23 19:46:18;  author: pfaedit;  state: Exp;  lines: +2 -2
I believe OpenType would prefer if formed arabic glyphs didn't use their unicode encodings, but used simple substitutions instead. Accept both for svg output (previously we only accepted unicode encodings).
----------------------------
revision 1.1594
date: 2006/10/23 14:57:14;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch from debian (bug392688) from Wojciech Mu*a and K*stutis Bili*nas
----------------------------
revision 1.1593
date: 2006/10/19 22:56:37;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch from mfabian of suse. Array overflow.
----------------------------
revision 1.1592
date: 2006/10/19 05:18:25;  author: pfaedit;  state: Exp;  lines: +2 -2
the instructions out of date flag was not getting cleared if user simply pressed ok in the instruction editor. s/he had to make a change. That seems extreme. Also the refresh didn't always note that the bit had changed.
----------------------------
revision 1.1591
date: 2006/10/19 05:10:40;  author: pfaedit;  state: Exp;  lines: +3 -3
Make libintl be another library we'll try to dlopen. This is complicated because on linux libintl is part of libc so there we must link directly.
Further complicated because fink install script has a bug and doesn't put /sw/lib in DYLD_LIBRARY_PATH so we have to look there ourselves.
----------------------------
revision 1.1590
date: 2006/10/16 19:54:32;  author: pfaedit;  state: Exp;  lines: +3 -3
Disambiguation for Polish.
----------------------------
revision 1.1589
date: 2006/10/15 22:24:52;  author: pfaedit;  state: Exp;  lines: +2 -2
Michal Nowakowski wants the 'gasp' titles disambiguated.
----------------------------
revision 1.1588
date: 2006/10/15 22:12:56;  author: pfaedit;  state: Exp;  lines: +2 -2
Some UI typoes. Patch by Malcom Parsons.
----------------------------
revision 1.1587
date: 2006/10/15 20:31:51;  author: pfaedit;  state: Exp;  lines: +3 -3
locale strings aren't required to contain an encoding (which the locale docs incorrectly call a charset). Michal Nowakowski points me to nl_langinfo which will give me the encoding even if not specified in the locale.
----------------------------
revision 1.1586
date: 2006/10/15 00:59:32;  author: pfaedit;  state: Exp;  lines: +3 -3
Add pdf files to the standard format list for openfontdlg
----------------------------
revision 1.1585
date: 2006/10/12 18:10:29;  author: pfaedit;  state: Exp;  lines: +2 -2
Using the help command would generally crash fontforge on cygwin.
----------------------------
revision 1.1584
date: 2006/10/12 14:08:45;  author: pfaedit;  state: Exp;  lines: +2 -2
Add extension "pmf" to font open/bitmap import.
----------------------------
revision 1.1583
date: 2006/10/12 14:02:59;  author: pfaedit;  state: Exp;  lines: +3 -3
Change the bitmap dlg to take advantage of boxes.
----------------------------
revision 1.1582
date: 2006/10/11 21:04:26;  author: pfaedit;  state: Exp;  lines: +2 -2
Adobe uses the American spelling of diaeresis (that is dieresis), but some fonts contain glyph names with the European spelling. So add that as an alternate.
----------------------------
revision 1.1581
date: 2006/10/11 21:00:19;  author: pfaedit;  state: Exp;  lines: +2 -2
Clean up the 'gasp' pane a bit.
----------------------------
revision 1.1580
date: 2006/10/11 20:38:23;  author: pfaedit;  state: Exp;  lines: +3 -3
If a bdf font contained an unencoded .notdef glyph, then we crashed.
----------------------------
revision 1.1579
date: 2006/10/09 20:36:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Adding Greek translations for font styles. (Thanks to Apostolos)
----------------------------
revision 1.1578
date: 2006/10/09 19:53:19;  author: pfaedit;  state: Exp;  lines: +3 -3
If we aren't dealing with a TeX math font, then the "Sub/super"script positioning fields of Glyph Info->TeX aren't meaningful. So grey them out.
----------------------------
revision 1.1577
date: 2006/10/09 02:52:50;  author: pfaedit;  state: Exp;  lines: +2 -2
Remove internal/external did the wrong thing in expand stroke if we also removed overlap and had counter-clockwise splines.
----------------------------
revision 1.1576
date: 2006/10/08 18:31:20;  author: pfaedit;  state: Exp;  lines: +3 -3
Alexej Kryukov points out that reverting a glyph with anchors lost the anchors.
----------------------------
revision 1.1575
date: 2006/10/07 13:07:21;  author: pfaedit;  state: Exp;  lines: +2 -2
Add simplified Chinese style names to our built-in lists.
----------------------------
revision 1.1574
date: 2006/10/07 12:28:57;  author: pfaedit;  state: Exp;  lines: +3 -3
Problem reading autotraced input.
----------------------------
revision 1.1573
date: 2006/10/06 22:03:46;  author: pfaedit;  state: Exp;  lines: +2 -2
The encoding change of last summer broke tfm output with glyph lists or extension characters.
----------------------------
revision 1.1572
date: 2006/10/06 21:51:48;  author: pfaedit;  state: Exp;  lines: +2 -2
If add extrema added a point too close to a start/end point expand stroke could generate NaNs.
----------------------------
revision 1.1571
date: 2006/10/06 20:55:56;  author: pfaedit;  state: Exp;  lines: +3 -3
FF could crash when adding extrema to an open contour.
----------------------------
revision 1.1570
date: 2006/10/05 14:34:44;  author: pfaedit;  state: Exp;  lines: +3 -3
broke pairwise positioning dlg when I boxed it.
----------------------------
revision 1.1569
date: 2006/10/05 04:53:11;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a scripting function to set the gasp table.
----------------------------
revision 1.1568
date: 2006/10/05 04:04:33;  author: pfaedit;  state: Exp;  lines: +3 -3
Improvements to the 'gasp' data entry.
----------------------------
revision 1.1567
date: 2006/10/03 13:36:56;  author: pfaedit;  state: Exp;  lines: +3 -3
Add Polish styles to the translation list.
----------------------------
revision 1.1566
date: 2006/10/03 04:05:52;  author: pfaedit;  state: Exp;  lines: +2 -2
Add support for the 'gasp' table.
----------------------------
revision 1.1565
date: 2006/10/03 00:28:56;  author: pfaedit;  state: Exp;  lines: +2 -2
Alexej Kryukov wants format 6 cmap tables.
----------------------------
revision 1.1564
date: 2006/10/02 20:27:07;  author: pfaedit;  state: Exp;  lines: +2 -2
Recent change to simplify (to allow making the last spline of a contour into a line if knownlinear) meant we could remove the start point, and we weren't prepared for that.
----------------------------
revision 1.1563
date: 2006/10/02 20:13:42;  author: pfaedit;  state: Exp;  lines: +3 -3
Disambiguate width here.
Use boxes.
----------------------------
revision 1.1562
date: 2006/09/29 21:57:45;  author: pfaedit;  state: Exp;  lines: +2 -2
After editing instructions the debugger would incorrectly complain that instructions were out of date.
----------------------------
revision 1.1561
date: 2006/09/29 15:18:13;  author: pfaedit;  state: Exp;  lines: +2 -2
Disambiguate Original.
----------------------------
revision 1.1560
date: 2006/09/29 14:29:00;  author: pfaedit;  state: Exp;  lines: +2 -2
Extra semicolon is illegal in declarations.
----------------------------
revision 1.1559
date: 2006/09/29 14:25:30;  author: pfaedit;  state: Exp;  lines: +3 -3
Extranious underscore.
----------------------------
revision 1.1558
date: 2006/09/29 03:23:44;  author: pfaedit;  state: Exp;  lines: +3 -3
Rats. Ralph Levien's patch did not work. But maybe now I'm using FT_Outline_Get_Bitmap properly.
----------------------------
revision 1.1557
date: 2006/09/27 21:11:57;  author: pfaedit;  state: Exp;  lines: +2 -2
Michal Nowakowski complains that "Instructions are out of date" warning appears too many times when doing a global transformation. Make it only pop up as a dlg once and thereafter occur as a LogError.
----------------------------
revision 1.1556
date: 2006/09/27 17:43:17;  author: pfaedit;  state: Exp;  lines: +2 -2
Using the wrong string for the mod time.
----------------------------
revision 1.1555
date: 2006/09/27 17:32:42;  author: pfaedit;  state: Exp;  lines: +2 -2
If a font contained only space glyphs it could still be marked onlybitmaps and not allow outline generation.
----------------------------
revision 1.1554
date: 2006/09/27 17:10:43;  author: pfaedit;  state: Exp;  lines: +2 -2
Show ATT did not translate scripts & languages.
----------------------------
revision 1.1553
date: 2006/09/27 17:09:16;  author: pfaedit;  state: Exp;  lines: +2 -2
Converted a utf8 string to unicode using latin1 conventions.
----------------------------
revision 1.1552
date: 2006/09/27 15:34:17;  author: pfaedit;  state: Exp;  lines: +3 -3
Parsing an empty list of ttf instructions crashed Michael Zedler's machine.
----------------------------
revision 1.1551
date: 2006/09/26 22:58:47;  author: pfaedit;  state: Exp;  lines: +3 -3
Make type1 generation use (essentially) the same subroutine mechanism as type2.
Try and fail to improve type2 subroutine usage.
----------------------------
revision 1.1550
date: 2006/09/26 04:12:00;  author: pfaedit;  state: Exp;  lines: +2 -2
Warning message about 'size' feature needs a newline at the end.
----------------------------
revision 1.1549
date: 2006/09/25 21:14:13;  author: pfaedit;  state: Exp;  lines: +2 -2
Local subroutines were being freed twice in cff cid-keyed font generation.
----------------------------
revision 1.1548
date: 2006/09/25 18:49:52;  author: pfaedit;  state: Exp;  lines: +3 -3
Removing an alternate unicode encoding (Detach Glyphs) was broken in some cases.
----------------------------
revision 1.1547
date: 2006/09/25 03:33:36;  author: pfaedit;  state: Exp;  lines: +3 -3
FF failed to perform some simplifications on the last spline of a closed contour.
----------------------------
revision 1.1546
date: 2006/09/22 22:17:20;  author: pfaedit;  state: Exp;  lines: +2 -2
Add boxes to the search dlg.
----------------------------
revision 1.1545
date: 2006/09/22 20:54:31;  author: pfaedit;  state: Exp;  lines: +2 -2
Boxify the maxp dialog and friends.
----------------------------
revision 1.1544
date: 2006/09/22 12:40:07;  author: pfaedit;  state: Exp;  lines: +3 -3
Various fixes for Michal N.
----------------------------
revision 1.1543
date: 2006/09/21 23:50:32;  author: pfaedit;  state: Exp;  lines: +2 -2
Add scripting interfaces to many of the ctype functions.
----------------------------
revision 1.1542
date: 2006/09/21 22:18:25;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a scripting interface to the 'size' feature, now that Adobe has finally decided what to do about 'size'.
----------------------------
revision 1.1541
date: 2006/09/21 04:25:21;  author: pfaedit;  state: Exp;  lines: +3 -3
The TTF Names pane of Font Info should now use the MatrixEdit widget.
The filter dlg should now specify an appropriate "New"
Extend and debug the MatrixEdit gadget.
----------------------------
revision 1.1540
date: 2006/09/20 03:11:58;  author: pfaedit;  state: Exp;  lines: +3 -3
Didn't terminate a list.
----------------------------
revision 1.1539
date: 2006/09/19 01:05:57;  author: pfaedit;  state: Exp;  lines: +2 -2
Disambiguate default.
----------------------------
revision 1.1538
date: 2006/09/19 00:44:02;  author: pfaedit;  state: Exp;  lines: +2 -2
A couple of strings were not marked for translation.
----------------------------
revision 1.1537
date: 2006/09/19 00:35:08;  author: pfaedit;  state: Exp;  lines: +2 -2
Had the wrong title for kerning state machine dlgs.
----------------------------
revision 1.1536
date: 2006/09/19 00:24:38;  author: pfaedit;  state: Exp;  lines: +2 -2
Yet another problem with numbering truetype points.
----------------------------
revision 1.1535
date: 2006/09/18 23:37:55;  author: pfaedit;  state: Exp;  lines: +3 -3
Redo the preference dlg.
----------------------------
revision 1.1534
date: 2006/09/18 03:46:26;  author: pfaedit;  state: Exp;  lines: +2 -2
The two preference items, AlwaysGenApple, and AlwaysGenOpenType, were a bad choice on my part and have lead to considerable confusion. I mentioned some time ago that I would remove them if there were no objection.

There was no objection.

I have now removed them.

I also made the SetPrefs scripting function sort of work if the user
tries to set one of these (it will set the appropriate flags in the
default option set used by generate).

The defaults of these flags were different on the Mac from everywhere
else. This meant that a script could do different things on the Mac and
on linux. That seems like a bad idea. I have changed things so that the
default options setting for generate is always OpenType.

THIS IS AN INCOMPATIBLE CHANGE AND SCRIPTS ON THE MAC COULD NOW BEHAVE
DIFFERENTLY.
----------------------------
revision 1.1533
date: 2006/09/18 03:39:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. Disambiguation patch not complete. Need to switch from _("") to S_("")
----------------------------
revision 1.1532
date: 2006/09/17 23:28:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch from Michal Nowakowski to have ff number points after conversion to truetype.
----------------------------
revision 1.1531
date: 2006/09/17 23:02:40;  author: pfaedit;  state: Exp;  lines: +2 -2
Try to provide disambiguation for all strings "New" so that in languages where "New" must agree in gender with the thing being created translators will be happier.
----------------------------
revision 1.1530
date: 2006/09/17 19:38:04;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a Polish translation from Michal Nowakowski.
Remove the po/Makefile.in and redo the configure script to build it (so that I don't have to modify it each time I get a new language).
----------------------------
revision 1.1529
date: 2006/09/15 21:29:31;  author: pfaedit;  state: Exp;  lines: +3 -3
Are we going outside array bounds?
----------------------------
revision 1.1528
date: 2006/09/15 03:20:56;  author: pfaedit;  state: Exp;  lines: +2 -2
Extend the knife tool so that if Meta (Alt) is held down it will move any spline it intersects (rather than cutting the spline).
----------------------------
revision 1.1527
date: 2006/09/15 00:00:53;  author: pfaedit;  state: Exp;  lines: +2 -2
FF would crash if $HOME did not exist.
----------------------------
revision 1.1526
date: 2006/09/14 23:46:46;  author: pfaedit;  state: Exp;  lines: +2 -2
I guess it makes sense that if ff read in a compressed sfd file then using a simple File->Save command (not Save As) should produce another compressed sfd file.
----------------------------
revision 1.1525
date: 2006/09/14 14:29:12;  author: pfaedit;  state: Exp;  lines: +2 -2
When scaling a reference in otf output we had problems if the reference had more than one contour.
----------------------------
revision 1.1524
date: 2006/09/14 13:50:35;  author: pfaedit;  state: Exp;  lines: +2 -2
If we deleted many glyphs from a font we are sometimes left with kern pairs pointing to things not worth outputting. Make sure we don't generate kerning info for them.
----------------------------
revision 1.1523
date: 2006/09/14 13:23:50;  author: pfaedit;  state: Exp;  lines: +2 -2
Be paranoid about open splines when copying hints.
----------------------------
revision 1.1522
date: 2006/09/14 13:21:32;  author: pfaedit;  state: Exp;  lines: +2 -2
Ligature carets were not being scaled by scale to em.
----------------------------
revision 1.1521
date: 2006/09/14 13:02:30;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch from mfabian at suse.
----------------------------
revision 1.1520
date: 2006/09/14 04:13:15;  author: pfaedit;  state: Exp;  lines: +2 -2
If a user has a font with a glyph that is bigger than 16*em-size (in many dimensions) and that user generates a tfm file, then warn him that the glyph can't be expressed in a tfm file and truncate the size to the biggest legal value.
----------------------------
revision 1.1519
date: 2006/09/14 03:30:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Attempt to mitigate the effects of X claiming to have a font when it doesn't.
----------------------------
revision 1.1518
date: 2006/09/13 21:11:01;  author: pfaedit;  state: Exp;  lines: +3 -3
Saving CID keyed fonts would look at garbage memory for its encoding data if not saved from the biggest subfont.
----------------------------
revision 1.1517
date: 2006/09/10 22:44:37;  author: pfaedit;  state: Exp;  lines: +3 -3
Add support for version 4 of the OS/2 table.
----------------------------
revision 1.1516
date: 2006/09/10 03:51:17;  author: pfaedit;  state: Exp;  lines: +2 -2
If Interpretation was set in a font then when generating a 8/16 type cmap fontforge always went down the traditional chinese (big5) branch.
----------------------------
revision 1.1515
date: 2006/09/10 03:33:22;  author: pfaedit;  state: Exp;  lines: +2 -2
MS has changed their indic shaping engine. It still uses the same features but they are applied differently. To disambiguate this change they have created a parallel set of script tags for the indic writing system. FontForge should recognize these and use them when appropriate.
----------------------------
revision 1.1514
date: 2006/09/10 01:32:35;  author: pfaedit;  state: Exp;  lines: +2 -2
When Adobe first released fonts with a 'size' feature they did not follow the opentype specification. In August of 2006 they announced an incompatible change to bring fonts produced after that date in line with the specification. Unfortunately there are programs which depend on the old, broken format.
   Legacy programs will not work when given a font in the correct format. New programs should be able to handle either correct or broken 'size' features.
  FontForge should now be able to read in a size feature in either format and gives the user the option of producing 'size' features in either format on output.
----------------------------
revision 1.1513
date: 2006/09/09 13:06:18;  author: pfaedit;  state: Exp;  lines: +3 -3
For Japanese fonts we tried to use cp932 (a variant of sjis) but then halfway through didn't know what to do with it.
----------------------------
revision 1.1512
date: 2006/09/08 02:59:31;  author: pfaedit;  state: Exp;  lines: +2 -2
Another fix for saving sub-opentype fonts from a cid font.
----------------------------
revision 1.1511
date: 2006/09/08 02:52:12;  author: pfaedit;  state: Exp;  lines: +2 -2
From a script, if a user asks to generate a ttf outline font with ttf bitmaps from a database with no outlines then technically this isn't supposed to work. But it used to and it's easy enough to tweak so that it works again.
----------------------------
revision 1.1510
date: 2006/09/07 15:19:11;  author: pfaedit;  state: Exp;  lines: +3 -3
Update to Unicode 5.0
----------------------------
revision 1.1509
date: 2006/09/07 03:13:00;  author: pfaedit;  state: Exp;  lines: +2 -2
Again when adding accents to the left of a glyph we should shift the glyph over to give it a reasonable lbearing.
----------------------------
revision 1.1508
date: 2006/09/07 02:55:20;  author: pfaedit;  state: Exp;  lines: +2 -2
When building an accented glyph, we generally want use_my_metrics set on the reference. But if we add an accent to right (horn) or left (psili/varia on cap greeks) we want to turn it off. We did turn it off on the right side, but not on the left.
----------------------------
revision 1.1507
date: 2006/09/06 20:17:58;  author: pfaedit;  state: Exp;  lines: +3 -3
 Philipp Poll points out that ScaleToEm doesn't scale the OS/2 metrics (and some other stuff). Actually it does, but font info did the scaling BEFORE setting the values. So the metrics get scaled, and then reset to the values in fontinfo (which usually means they don't get changed).
----------------------------
revision 1.1506
date: 2006/09/06 02:29:39;  author: pfaedit;  state: Exp;  lines: +2 -2
Yet more fixes for bitmap only sfnts.
Some fixes for pcf loading.
Fix some memory leaks.
----------------------------
revision 1.1505
date: 2006/09/06 02:26:11;  author: pfaedit;  state: Exp;  lines: +3 -3
Make the Import dialog use the new gadgets flow structure.
----------------------------
revision 1.1504
date: 2006/09/05 05:48:04;  author: pfaedit;  state: Exp;  lines: +2 -2
Various fixes to CID keyed fonts.
----------------------------
revision 1.1503
date: 2006/09/04 20:24:31;  author: pfaedit;  state: Exp;  lines: +2 -2
Last patch which set the bb of a sub-font to that of it's parent neglected to do it for the afm file.
----------------------------
revision 1.1502
date: 2006/09/04 15:13:40;  author: pfaedit;  state: Exp;  lines: +2 -2
Even the pretty ttf approximation routines need to worry about diametrically opposed control points.
----------------------------
revision 1.1501
date: 2006/09/04 14:53:07;  author: pfaedit;  state: Exp;  lines: +3 -3
When generating multiple type1 fonts, output the bounding box of each as that of the full font. This will make it vaguely likely that applications will get the same line spacing.
----------------------------
revision 1.1500
date: 2006/09/04 03:45:04;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops. The vertical metrics bit wasn't preserved when flattening a cid font.
----------------------------
revision 1.1499
date: 2006/09/02 22:01:12;  author: pfaedit;  state: Exp;  lines: +3 -3
Ack! Window titles and such were being interpreted in Latin1 and not in UTF-8.
----------------------------
revision 1.1498
date: 2006/09/01 23:11:30;  author: pfaedit;  state: Exp;  lines: +3 -3
Rewrite the transform dlg to do auto layout.
----------------------------
revision 1.1497
date: 2006/08/31 22:55:12;  author: pfaedit;  state: Exp;  lines: +2 -2
Interpretation of PostScript arc operator failed if the two angles were 360 degrees apart. Normalization made them both the same.
----------------------------
revision 1.1496
date: 2006/08/31 19:13:58;  author: pfaedit;  state: Exp;  lines: +3 -3
Clean up the display of the save font dlg.
Document our various bitmap only sfnt formats (no one else does, so I guess I should).
----------------------------
revision 1.1495
date: 2006/08/31 04:37:24;  author: pfaedit;  state: Exp;  lines: +3 -3
Distinguish between bitmap only sfnt output and "in TTF" bitmap output.
We were still have troubles with sbits only dfont output if applemode wasn't set.
----------------------------
revision 1.1494
date: 2006/08/29 04:43:16;  author: pfaedit;  state: Exp;  lines: +2 -2
Oh. So THAT's how I make shared libraries on cygwin.
----------------------------
revision 1.1493
date: 2006/08/28 13:54:35;  author: pfaedit;  state: Exp;  lines: +3 -3
further work on the cmap picker.
----------------------------
revision 1.1492
date: 2006/08/28 04:28:01;  author: pfaedit;  state: Exp;  lines: +2 -2
Apple has deprecated some more useful functions.
Their online docs even have the gall to say that this happened in 10.4. My 10.4.0 system does not think they are deprecated, but more recent systems do.
----------------------------
revision 1.1491
date: 2006/08/28 03:57:17;  author: pfaedit;  state: Exp;  lines: +2 -2
Further work on user specified cmaps.
----------------------------
revision 1.1490
date: 2006/08/27 22:27:07;  author: pfaedit;  state: Exp;  lines: +2 -2
My wildcard matcher could not handle *.{*pk,*gf}.
Add TeX bitmap fonts to standard lists.
----------------------------
revision 1.1489
date: 2006/08/27 21:38:07;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. Add pcf to the list of "All Fonts".
----------------------------
revision 1.1488
date: 2006/08/27 21:13:47;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a filter for TeX bitmap fonts to the open dlg.
----------------------------
revision 1.1487
date: 2006/08/27 04:55:28;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner wants a mechanism to examine the cmaps of a font. Give him a rather poor solution.
----------------------------
revision 1.1486
date: 2006/08/27 01:51:57;  author: pfaedit;  state: Exp;  lines: +3 -3
Play with popups for the splash screen.
----------------------------
revision 1.1485
date: 2006/08/25 02:33:56;  author: pfaedit;  state: Exp;  lines: +2 -2
Nifty. Libtool on the mac produces names that are completely unexpected for shared objects. Handle them. Also there is no need to link gb12345 against the X libraries (caused a user problems. I guess he built for scripts but still wanted the encodings).
----------------------------
revision 1.1484
date: 2006/08/24 23:53:13;  author: pfaedit;  state: Exp;  lines: +3 -3
If applemode was not set and "bitmap only sfnt" was set then ff would probably crash.
----------------------------
revision 1.1483
date: 2006/08/22 15:18:00;  author: pfaedit;  state: Exp;  lines: +2 -2
Oopsie. Stupid infinite loop in new hinting code.
----------------------------
revision 1.1482
date: 2006/08/22 14:46:31;  author: pfaedit;  state: Exp;  lines: +3 -3
Adobe applies hints at the bounding box of glyphs that don't have hints. At least it does sometimes. Try to guess when it might be good to do this.
----------------------------
revision 1.1481
date: 2006/08/22 04:52:59;  author: pfaedit;  state: Exp;  lines: +2 -2
Someone complained that Find Problems->Path Direction got the wrong answer. It got the wrong answer because they had a self-intersecting path (which screws up all concepts of in/out-side. So try to make it clear that they should do a find intersecting paths first.
----------------------------
revision 1.1480
date: 2006/08/21 23:07:02;  author: pfaedit;  state: Exp;  lines: +2 -2
Update my scripts list (in particular include music).
----------------------------
revision 1.1479
date: 2006/08/21 23:03:26;  author: pfaedit;  state: Exp;  lines: +3 -3
Produce a hint at the bottom of a circumflex.
----------------------------
revision 1.1478
date: 2006/08/20 20:42:11;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a new command to the point menu which allows you to specify a spline and one coordinate (either X or Y) on that spline. FF will calculate the other coordinate and add a point there.
----------------------------
revision 1.1477
date: 2006/08/20 19:23:42;  author: pfaedit;  state: Exp;  lines: +3 -3
Was getting stems which weren't stems.
----------------------------
revision 1.1476
date: 2006/08/18 22:13:50;  author: pfaedit;  state: Exp;  lines: +2 -2
Clean up a couple of things broken by the recent change.
Also retain the default filter.
----------------------------
revision 1.1475
date: 2006/08/18 21:49:33;  author: pfaedit;  state: Exp;  lines: +2 -2
Due to a typo, ff thought pretty much everything outside unicode BMP was in the hebrew script.
----------------------------
revision 1.1474
date: 2006/08/18 21:12:19;  author: pfaedit;  state: Exp;  lines: +2 -2
CODE2000 contains an anchor class with only base glyphs (no mark glyphs) as part of a set of anchor classes. FF crashed.
----------------------------
revision 1.1473
date: 2006/08/18 20:08:54;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch by Nix. svg.c did not compile when designed to be linked directly with libxml (instead of dlopening it).
----------------------------
revision 1.1472
date: 2006/08/18 01:49:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Redo the font open dlg so that there's a list of standard filters and a mechanism for changing that list.
----------------------------
revision 1.1471
date: 2006/08/18 01:36:11;  author: pfaedit;  state: Exp;  lines: +3 -3
If a popup menu is huge it used to appear under the cursor. This meant that even if the user didn't mean to s/he would have selected something and press/release would not be a no-op. This was a problem with the Font Info ->TTF Names
----------------------------
revision 1.1470
date: 2006/08/12 03:30:49;  author: pfaedit;  state: Exp;  lines: +2 -2
Clean up a couple of other dlgs.
----------------------------
revision 1.1469
date: 2006/08/11 21:48:50;  author: pfaedit;  state: Exp;  lines: +3 -3
Make the Point Info dlg work with the new gadget alignment stuff.
----------------------------
revision 1.1468
date: 2006/08/10 22:35:18;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch from SUSE. Use of uninitialized local variable. But the result is never used, so just remove the offending lines.
----------------------------
revision 1.1467
date: 2006/08/10 18:40:20;  author: pfaedit;  state: Exp;  lines: +3 -3
Emulate gtk's boxes and use that to do automatic dialog layout.
Get the font info dlg working (and the Set Width dlg as a test).
This means that the layout is no longer optimized for English, but will look better in other languages (I hope).
----------------------------
revision 1.1466
date: 2006/08/07 04:45:57;  author: pfaedit;  state: Exp;  lines: +2 -2
Improve the unicode ranges stuff. Add a bit mask telling us which codepoints are assigned by unicode.
----------------------------
revision 1.1465
date: 2006/08/06 23:22:46;  author: pfaedit;  state: Exp;  lines: +2 -2
Add an information function to Font Info to display what unicode character ranges are supplied by the font.
----------------------------
revision 1.1464
date: 2006/08/06 20:52:57;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops. Linux defines "time_t" if I include stdio.h (or some such) while Mac OS/X does not. Explicitly include time.h. I should have anyway.
----------------------------
revision 1.1463
date: 2006/08/06 04:52:34;  author: pfaedit;  state: Exp;  lines: +3 -3
Philipp Poll points out that when generating versioned fonts (ie. Ambrosia-1.0 rather than just Ambrosia) you don't want the filename to default to the fontname (the fontname will be Ambrosia), instead you want some way of specifying a default filename. So add that to the Names pane of the Font Info dlg.
----------------------------
revision 1.1462
date: 2006/08/04 21:24:31;  author: pfaedit;  state: Exp;  lines: +2 -2
Try to keep track of font creation and modification times. NOTE: This is different from file times (which is what appears to be stored in the 'head' table of an sfnt file). Add a new table 'FFTM' to our sfnt output with these timestamps (and the timestamp of fontforge itself, just in case we ever care).
----------------------------
revision 1.1461
date: 2006/08/04 16:46:57;  author: pfaedit;  state: Exp;  lines: +3 -3
Mark classes could not be set from the selection.
----------------------------
revision 1.1460
date: 2006/08/04 03:25:03;  author: pfaedit;  state: Exp;  lines: +2 -2
Ben Laenen points out that if an order2 glyph has a dependent which refers to it using point matching and we keep changing the point number on the glyph then we'll keep getting warning messages. He suggests one message.
----------------------------
revision 1.1459
date: 2006/08/04 02:59:24;  author: pfaedit;  state: Exp;  lines: +2 -2
Empty glyphs weren't marked with red Xs any more.
----------------------------
revision 1.1458
date: 2006/08/04 02:38:07;  author: pfaedit;  state: Exp;  lines: +2 -2
In font compare, when comparing two contextual/chaining lookups, I forgot that class[0] was always NULL.
----------------------------
revision 1.1457
date: 2006/08/04 02:36:07;  author: pfaedit;  state: Exp;  lines: +3 -3
Open contours caused the ttf point renumberer to crash.
----------------------------
revision 1.1456
date: 2006/08/02 23:03:34;  author: pfaedit;  state: Exp;  lines: +3 -3
A font can have many kerning pairs. More than will fit in one GPOS subtable (which essentially has a 64k data limit or a bit more than 10,000 kern pairs). So be prepared to generate many sub-tables each dealing with a subset of the (first) glyphs.
----------------------------
revision 1.1455
date: 2006/08/01 14:59:42;  author: pfaedit;  state: Exp;  lines: +3 -3
Kanou needs to disambiguate between "Points" (meaning a location on the screen) and "Points" (meaning 1/72.27 of an inch).
----------------------------
revision 1.1454
date: 2006/07/28 17:43:00;  author: pfaedit;  state: Exp;  lines: +3 -3
Still not getting default apple features right.
----------------------------
revision 1.1453
date: 2006/07/27 13:39:24;  author: pfaedit;  state: Exp;  lines: +3 -3
If an apple mutually exclusive feature had a default setting which wasn't 0 then my previous patch didn't work.
----------------------------
revision 1.1452
date: 2006/07/27 03:38:18;  author: pfaedit;  state: Exp;  lines: +2 -2
If guessing bluevalues found no OtherBlues, fontinfo->PS Private would create an incorrect OtherBlues value [0]
----------------------------
revision 1.1451
date: 2006/07/27 03:34:50;  author: pfaedit;  state: Exp;  lines: +2 -2
Earlier BlueScale patch had some problems.
----------------------------
revision 1.1450
date: 2006/07/27 03:20:57;  author: pfaedit;  state: Exp;  lines: +2 -2
Some tweaks to improve svg cut & paste.
----------------------------
revision 1.1449
date: 2006/07/26 21:16:22;  author: pfaedit;  state: Exp;  lines: +2 -2
Support clipboards containing image/svg
----------------------------
revision 1.1448
date: 2006/07/26 20:34:52;  author: pfaedit;  state: Exp;  lines: +3 -3
Ralf Stubner points out that the maximum zone size of bluezones is determined by 1/BlueScale. So adjust BlueScale if the max zone is too big.
----------------------------
revision 1.1447
date: 2006/07/26 03:19:57;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. Bug in copying kern classes if they had device tables.
----------------------------
revision 1.1446
date: 2006/07/25 16:15:19;  author: pfaedit;  state: Exp;  lines: +2 -2
And copy FPSTs too.
----------------------------
revision 1.1445
date: 2006/07/25 16:00:05;  author: pfaedit;  state: Exp;  lines: +2 -2
Let's merge kern classes and state machines too.
Merging kern classes may be a bad idea. We don't really merge them we just copy them so that if the same glyph is mentioned in two classes unexpected things might happen.
----------------------------
revision 1.1444
date: 2006/07/25 15:23:24;  author: pfaedit;  state: Exp;  lines: +2 -2
Merge fonts didn't merge anchors and got into a terrible mess.
----------------------------
revision 1.1443
date: 2006/07/25 15:21:25;  author: pfaedit;  state: Exp;  lines: +3 -3
ff could crash on an sfd file containing erroneous anchors (such as might be generated by the merge fonts command).
----------------------------
revision 1.1442
date: 2006/07/24 13:52:57;  author: pfaedit;  state: Exp;  lines: +2 -2
Once upon a time, Apple was so concerned about accuracy of floating point operations that they required all operations be performed in IEEE extended (80bit). This had the interesting side effect that a program which conformed to Apple's standards could not also conform to ANSI C (which required operations use double temporaries for double values). I find it somewhat ironic, therefore, that gcc on the mac doesn't even promote floats to doubles. FF needs the extra accuracy provided by a double (an extended type doesn't seem to provide additional assistance unfortunately). So on the mac we got extrema that weren't, which meant that remove overlap didn't.
----------------------------
revision 1.1441
date: 2006/07/23 23:13:07;  author: pfaedit;  state: Exp;  lines: +3 -3
If we had a mac feature which had multiple subtables (ie. a state machine for a contextual substitution, and a non-contextual substitution too) then we produced a bad chain in the morx table.
----------------------------
revision 1.1440
date: 2006/07/23 03:27:55;  author: pfaedit;  state: Exp;  lines: +2 -2
Merge & Simplify would sometimes generate solutions using control points which were diametrically opposed to what they should be.
----------------------------
revision 1.1439
date: 2006/07/23 00:08:08;  author: pfaedit;  state: Exp;  lines: +2 -2
Yet another attempt to do a better job of autohinting.
----------------------------
revision 1.1438
date: 2006/07/22 20:40:23;  author: pfaedit;  state: Exp;  lines: +2 -2
More tweaks to the Revert Backup command (we left the ~ in the filename so subsequent saves went to the backup file).
The Revert command should not be available in new fonts.
----------------------------
revision 1.1437
date: 2006/07/22 14:51:29;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a "Revert to Backup" command.
----------------------------
revision 1.1436
date: 2006/07/21 21:54:17;  author: pfaedit;  state: Exp;  lines: +3 -3
Put code in to correct for single bit (sometimes double bit) errors when search from extrema. This is at a lower level than the previous patch.
----------------------------
revision 1.1435
date: 2006/07/20 20:36:37;  author: pfaedit;  state: Exp;  lines: +2 -2
Output of extension lookups wasn't working
----------------------------
revision 1.1434
date: 2006/07/20 15:11:50;  author: pfaedit;  state: Exp;  lines: +3 -3
The cantremove bit on ttf names wasn't always initialized.
----------------------------
revision 1.1433
date: 2006/07/18 03:51:34;  author: pfaedit;  state: Exp;  lines: +2 -2
Another improvement to the ruler display.
A slight improvement to magnifying by dragging a rectangle.
----------------------------
revision 1.1432
date: 2006/07/18 00:32:07;  author: pfaedit;  state: Exp;  lines: +2 -2
The first time you click on a transition in a Font Info->Mac SM->Indic state machine, ff would crash.
----------------------------
revision 1.1431
date: 2006/07/18 00:18:04;  author: pfaedit;  state: Exp;  lines: +2 -2
Tihkomirov points out that it isn't clear how to delete a ttf name from the name pane of fontinfo. So add some popup help.
The language & string ID menus in that pane were sorted on the wrong key
----------------------------
revision 1.1430
date: 2006/07/17 23:27:59;  author: pfaedit;  state: Exp;  lines: +3 -3
Was not preserving (unparsed) tables properly. Several bugs.
----------------------------
revision 1.1429
date: 2006/07/16 19:23:03;  author: pfaedit;  state: Exp;  lines: +3 -3
For mutually exclusive features there must be an "Off" feature, which generally does nothing.
----------------------------
revision 1.1428
date: 2006/07/16 00:56:40;  author: pfaedit;  state: Exp;  lines: +2 -2
When loading an apple bitmap font (with no hmtx tables) we need to dummy up widths for the outline glyphs.
----------------------------
revision 1.1427
date: 2006/07/16 00:01:44;  author: pfaedit;  state: Exp;  lines: +2 -2
Apple's bitmap only fonts should not have 'hhea' nor 'hmtx' tables. Undocumented fact.
----------------------------
revision 1.1426
date: 2006/07/15 23:33:52;  author: pfaedit;  state: Exp;  lines: +2 -2
Was getting the flags wrong for turning off features in an apple morx chain.
----------------------------
revision 1.1425
date: 2006/07/15 21:27:57;  author: pfaedit;  state: Exp;  lines: +3 -3
When outputing mark-to-base sub-tables with multiple marks I neglected to output an NUL offsets for the anchors that weren't there. So if a glyph had only one anchor (instead of two, or however many) then the offsets would be all wrong.
----------------------------
revision 1.1424
date: 2006/07/14 13:08:54;  author: pfaedit;  state: Exp;  lines: +3 -3
The SetPref() scripting function was misdocumented to be called SetPrefs() so accepte both names.
----------------------------
revision 1.1423
date: 2006/07/14 00:28:46;  author: pfaedit;  state: Exp;  lines: +3 -3
Further improvements to the ruler info window.
----------------------------
revision 1.1422
date: 2006/07/13 05:26:53;  author: pfaedit;  state: Exp;  lines: +3 -3
When building an accented letter out of glyphs with an anchor class ff would increase the advance width of the accented glyph by the size (xmax-xmin) of the accent.
----------------------------
revision 1.1421
date: 2006/07/10 20:55:23;  author: pfaedit;  state: Exp;  lines: +3 -3
Expand the functionality of the ruler tool so that it also shows curvature.
----------------------------
revision 1.1420
date: 2006/07/09 21:39:37;  author: pfaedit;  state: Exp;  lines: +2 -2
ftxvalidate complains if the vertical line metrics are 0. Even in a strike with no vertical metrics information. So dummy something up.
----------------------------
revision 1.1419
date: 2006/07/09 20:58:15;  author: pfaedit;  state: Exp;  lines: +3 -3
When importing a bitmap font from a mac binary or an sfnt and the encodings of the destination and the bitmap did not match, then things got rather screwed up and might crash.
----------------------------
revision 1.1418
date: 2006/07/07 20:28:38;  author: pfaedit;  state: Exp;  lines: +3 -3
patch from KANOU. the ref check routine in glyphcomp compared one reference to itself.
----------------------------
revision 1.1417
date: 2006/07/03 22:50:15;  author: pfaedit;  state: Exp;  lines: +2 -2
If we had a font consisting of one or two glyphs and we generated an otf from it then we'd not get a meaningful 'hmtx' table.
----------------------------
revision 1.1416
date: 2006/07/03 22:48:04;  author: pfaedit;  state: Exp;  lines: +2 -2
One more case where we can omit a final vector in type2 (in a repetative hvline to).
----------------------------
revision 1.1415
date: 2006/07/03 22:46:23;  author: pfaedit;  state: Exp;  lines: +2 -2
Merge fonts will merge in the back ground layer too now.
----------------------------
revision 1.1414
date: 2006/07/03 19:08:08;  author: pfaedit;  state: Exp;  lines: +2 -2
More hinting problems.
----------------------------
revision 1.1413
date: 2006/07/03 18:55:39;  author: pfaedit;  state: Exp;  lines: +2 -2
Previous patch about selections was incomplete.
----------------------------
revision 1.1412
date: 2006/07/03 18:46:11;  author: pfaedit;  state: Exp;  lines: +2 -2
Type2 charstrings have no closepath operator. I used to think that meant I could not omit the final vector. In fact it means I can omit the final vector AND the closepath operator.
----------------------------
revision 1.1411
date: 2006/07/03 18:23:57;  author: pfaedit;  state: Exp;  lines: +2 -2
If we had a font with no complete code pages we used to generate a version 0 OS/2 table without codepage info. But now windows refuses to install such a font. Instead generate a bogus codepage field which claims to have latin1 (even though it doesn't).
Windows won't use a font where the codepages field is 0.
----------------------------
revision 1.1410
date: 2006/07/03 17:35:20;  author: pfaedit;  state: Exp;  lines: +2 -2
Canonical contours crashed on open contours.
----------------------------
revision 1.1409
date: 2006/07/03 16:16:04;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a new scripting function MultipleEncodingsToReferences to undo the effects fo SameGlyphAs.
----------------------------
revision 1.1408
date: 2006/07/03 16:03:44;  author: pfaedit;  state: Exp;  lines: +3 -3
If the fontview exposed an encoding which had no attached glyph, and that encoding was selected, then the selection did not show in the window.
----------------------------
revision 1.1407
date: 2006/07/02 21:34:01;  author: pfaedit;  state: Exp;  lines: +3 -3
Matthias Kilian points out that I was too hasty in ignoring some of his patches.
----------------------------
revision 1.1406
date: 2006/07/01 04:34:10;  author: pfaedit;  state: Exp;  lines: +2 -2
When generating a FOND for a bitmap only sfnt, we created dummy 'NFNT' resources with the wrong resource ids. Which meant we got garbage when the font was used.
----------------------------
revision 1.1405
date: 2006/06/30 21:04:08;  author: pfaedit;  state: Exp;  lines: +3 -3
Make the TabSets in the font & glyph info dialogs run vertically rather than horizontally. (Add an option to get the old display back).
----------------------------
revision 1.1404
date: 2006/06/30 03:07:15;  author: pfaedit;  state: Exp;  lines: +2 -2
The names of kern class 0 were not retained.
The kern pair sub-mode of the kerning class dlg didn't show any glyphs for a class 0 with glyphs in it.
----------------------------
revision 1.1403
date: 2006/06/30 02:11:12;  author: pfaedit;  state: Exp;  lines: +2 -2
Approximate Spline from Point Slopes sometimes set the control point while leaving the nonextcp flag on.
----------------------------
revision 1.1402
date: 2006/06/30 01:40:01;  author: pfaedit;  state: Exp;  lines: +2 -2
Add Extrema only looked at how close a point was to the extrema in one dimension. While that dimension is more important, make a less stringent check on the other.
----------------------------
revision 1.1401
date: 2006/06/29 23:15:36;  author: pfaedit;  state: Exp;  lines: +2 -2
Extract some utf8 strings from the standard gettext and move to utf8.pot.
----------------------------
revision 1.1400
date: 2006/06/29 22:35:37;  author: pfaedit;  state: Exp;  lines: +2 -2
Internal cleanup.
----------------------------
revision 1.1399
date: 2006/06/29 14:08:00;  author: pfaedit;  state: Exp;  lines: +3 -3
Another bug in ExpandStroke.
----------------------------
revision 1.1398
date: 2006/06/29 00:02:31;  author: pfaedit;  state: Exp;  lines: +2 -2
Beautifications to the curvature info stuff.
----------------------------
revision 1.1397
date: 2006/06/28 19:19:23;  author: pfaedit;  state: Exp;  lines: +3 -3
Expand Stroke removes "U-turns" from splines because they confuse it. But the routine that did that got a bit rambunctious and did the wrong thing on a circular arc.
----------------------------
revision 1.1396
date: 2006/06/27 16:19:49;  author: pfaedit;  state: Exp;  lines: +2 -2
If a font did not contain an OS/2 table then we didn't retain the 'hhea' ascent/descent.
----------------------------
revision 1.1395
date: 2006/06/27 15:59:42;  author: pfaedit;  state: Exp;  lines: +2 -2
Various fixes from Matthias Kilian of OpenBSD.
----------------------------
revision 1.1394
date: 2006/06/27 14:37:35;  author: pfaedit;  state: Exp;  lines: +2 -2
The point matching (anchor point) patch of a fortnight ago was wrong in at least one case.
----------------------------
revision 1.1393
date: 2006/06/27 14:22:52;  author: pfaedit;  state: Exp;  lines: +3 -3
When asking for default 'subs' features, every glyph gets assigned U+2080.
----------------------------
revision 1.1392
date: 2006/06/26 22:43:57;  author: pfaedit;  state: Exp;  lines: +3 -3
Display the curvature information at each point. In Point Info dlg, and in a popup window when editing cps.
----------------------------
revision 1.1391
date: 2006/06/23 21:06:36;  author: pfaedit;  state: Exp;  lines: +3 -3
Add two new menu commands/scripting commands:
   Canonical Start Points (CanonicalStart())
   Canonical Contours (CanonicalContours())
The first sets the start point of each contour to the leftmost point, while the second orders the contours by their leftmost points. This will slightly reduce the size of output charstrings. It will also make more things available to be put in subroutines.
----------------------------
revision 1.1390
date: 2006/06/23 02:45:33;  author: pfaedit;  state: Exp;  lines: +2 -2
Print Multi-Size & Full Page printed the wrong glyphs from the font view. Broken since the encoding change.
----------------------------
revision 1.1389
date: 2006/06/23 02:38:36;  author: pfaedit;  state: Exp;  lines: +3 -3
When stroking a contour that makes a 180degree turn, ff did not give it a semi-circle if linejoin was set to round.
----------------------------
revision 1.1388
date: 2006/06/20 22:17:46;  author: pfaedit;  state: Exp;  lines: +3 -3
SPLCopyTranslatedHintMasks didn't work if there were more than one contour being copied.
----------------------------
revision 1.1387
date: 2006/06/19 14:53:17;  author: pfaedit;  state: Exp;  lines: +2 -2
Nathan Summers points out that if the XUID is garbage the ff can go into an infinite loop when generating an otf/cff font.
----------------------------
revision 1.1386
date: 2006/06/19 14:49:58;  author: pfaedit;  state: Exp;  lines: +3 -3
Somehow the XUID and UniqueID fields crept of the bottom of the fontinfo Names pane and weren't visible or modifyable. Give them their own pane now.
----------------------------
revision 1.1385
date: 2006/06/19 04:45:51;  author: pfaedit;  state: Exp;  lines: +2 -2
Apply some patches (with some changes) from Nathan Summers to the truetype debugger.
----------------------------
revision 1.1384
date: 2006/06/19 03:03:52;  author: pfaedit;  state: Exp;  lines: +2 -2
Damn. The property count in BDF fonts is wrong.
----------------------------
revision 1.1383
date: 2006/06/18 23:29:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Ralf Stubner points out that the notdef glyph in an otf font should look like that in a ttf font, and not like that in a type1 font. (that is there should be something in the glyph).
----------------------------
revision 1.1382
date: 2006/06/18 22:27:33;  author: pfaedit;  state: Exp;  lines: +2 -2
Add support for group "encodings" which have empty spaces for unused glyphs.
----------------------------
revision 1.1381
date: 2006/06/18 16:24:30;  author: pfaedit;  state: Exp;  lines: +2 -2
make another attempt to find a good default sli for glyphs with no default script.
----------------------------
revision 1.1380
date: 2006/06/18 15:43:03;  author: pfaedit;  state: Exp;  lines: +2 -2
Typo in scripting function DefaultATT.
----------------------------
revision 1.1379
date: 2006/06/18 15:06:38;  author: pfaedit;  state: Exp;  lines: +3 -3
The View->Display Substitutions has been broken since the encoding change last summer.
----------------------------
revision 1.1378
date: 2006/06/18 03:51:19;  author: pfaedit;  state: Exp;  lines: +2 -2
Mark glyphs with out of date instructions differently from those with no instructions.
----------------------------
revision 1.1377
date: 2006/06/18 02:44:53;  author: pfaedit;  state: Exp;  lines: +2 -2
The last change to the cvt table generally did not get made.
----------------------------
revision 1.1376
date: 2006/06/17 19:40:17;  author: pfaedit;  state: Exp;  lines: +2 -2
Make glyph compare check for point matching in anchor points and in references.
----------------------------
revision 1.1375
date: 2006/06/17 19:08:12;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a warning message about out of date instructions when generating a font.
----------------------------
revision 1.1374
date: 2006/06/17 14:51:12;  author: pfaedit;  state: Exp;  lines: +3 -3
Add some warning messages about out of date instructions, and when we lose instructions, and when point matching goes out of date, etc.
----------------------------
revision 1.1373
date: 2006/06/15 04:01:09;  author: pfaedit;  state: Exp;  lines: +2 -2
When dumping anchor points matched to ttf points, ff failed to allocate enough space for them and offsets got all confused.
----------------------------
revision 1.1372
date: 2006/06/14 22:18:28;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. Some variables which should have been static were dynamic. Which meant we kept dlopening libfreetype.
----------------------------
revision 1.1371
date: 2006/06/14 22:02:57;  author: pfaedit;  state: Exp;  lines: +2 -2
If we had an anchor point which positioned itself with point matching, and we generated an otf font then we'd output a lookup which tried to do point matching in postscript. Only do point matching if we are sure we're in a tt font.
----------------------------
revision 1.1370
date: 2006/06/14 21:41:32;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a preference item to control clearing of tt instructions.
Clean up various bugs that have crept in of late.
----------------------------
revision 1.1369
date: 2006/06/14 04:23:33;  author: pfaedit;  state: Exp;  lines: +2 -2
Printing a multi-size page of a truetype font crashed.
----------------------------
revision 1.1368
date: 2006/06/13 22:58:15;  author: pfaedit;  state: Exp;  lines: +2 -2
Anchor Point dlg didn't work well with matching tt points.
----------------------------
revision 1.1367
date: 2006/06/13 22:40:58;  author: pfaedit;  state: Exp;  lines: +2 -2
FT_Outline and TT_ExecContext have different signedness now for the tags and contours arrays.
----------------------------
revision 1.1366
date: 2006/06/13 14:55:30;  author: pfaedit;  state: Exp;  lines: +2 -2
More tweaks for the glyph search in kerning classes.
----------------------------
revision 1.1365
date: 2006/06/13 14:17:22;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a field to allow users to search for a glyph name within a kerning class.
----------------------------
revision 1.1364
date: 2006/06/13 13:24:33;  author: pfaedit;  state: Exp;  lines: +2 -2
The sfd format must support class 0 of kerning classes too.
----------------------------
revision 1.1363
date: 2006/06/13 13:15:51;  author: pfaedit;  state: Exp;  lines: +3 -3
The kerning class comparison routine also needs to check class 0 now.
----------------------------
revision 1.1362
date: 2006/06/13 04:21:38;  author: pfaedit;  state: Exp;  lines: +2 -2
Interesting. In kerning by classes, if the coverage table does not match the glyphs specified in all the classes (for the first (left) glyph), then any glyphs in the coverage table but not in any class should be treated as being in class 0.
----------------------------
revision 1.1361
date: 2006/06/12 19:00:55;  author: pfaedit;  state: Exp;  lines: +2 -2
Add something to the font view's copy from menu to control whether truetype instructions are copied or not.
----------------------------
revision 1.1360
date: 2006/06/12 15:09:03;  author: pfaedit;  state: Exp;  lines: +3 -3
Add another thing to find problems: Check for glyphs with both contours and references.
----------------------------
revision 1.1359
date: 2006/06/11 03:55:10;  author: pfaedit;  state: Exp;  lines: +3 -3
Support copying of ttf instructions the way we support copying of hints.
Don't delete ttf instructions when the point count of a glyph changes, rather mark them as out of date and use the same mechanism to display that as out of date hints.
Don't turn off point matching in refs when the point count changes, mark as out of date.
Add some find problems to
  Find out of date point matched references.
  Find references with transformation matrices which can't be expressed (as refs) in truetype
  Find references with transformation matrices which aren't translations (and so can't be expressed (as refs) in type1/2 fonts.
----------------------------
revision 1.1358
date: 2006/06/08 16:09:33;  author: pfaedit;  state: Exp;  lines: +3 -3
Allow the user to turn off composite info in afm files.
----------------------------
revision 1.1357
date: 2006/06/05 14:25:56;  author: pfaedit;  state: Exp;  lines: +3 -3
otf kerning classes were dumped in the wrong order.
----------------------------
revision 1.1356
date: 2006/06/05 03:59:47;  author: pfaedit;  state: Exp;  lines: +3 -3
In GaramondPremrPro.otf (version 001.000) Adobe has coverage tables (for some context chaining subs) which have the glyphs mentioned multiple times. I suppose this is legal, but it is annoying. I want my strings to have each glyph appear at most once. So add a little thingy to remove duplicate glyphs when we generate a list of glyph names.
----------------------------
revision 1.1355
date: 2006/06/02 13:09:39;  author: pfaedit;  state: Exp;  lines: +3 -3
Adobe has depreciated the use of PUA to represent small caps, old style numerals, etc. Add a preference item so that ff will no longer recognize "a.sc" as having a PUA encoding.

Also the tool time for the preference item "NameListForNewFonts" was wrong.
----------------------------
revision 1.1354
date: 2006/06/01 13:21:48;  author: pfaedit;  state: Exp;  lines: +2 -2
More bad hinting.
----------------------------
revision 1.1353
date: 2006/06/01 13:19:48;  author: pfaedit;  state: Exp;  lines: +2 -2
Horizontal scrolling in the show att dlg was too slow. It was by pixel. Make it be by something which approximates the width of a character.
----------------------------
revision 1.1352
date: 2006/06/01 13:17:04;  author: pfaedit;  state: Exp;  lines: +3 -3
If we had a contextual substution and the subs was by coverage table and the coverage table had the same glyph name twice then we'd get an IError. It shouldn't happen in the first place, but an IError is extreme.
----------------------------
revision 1.1351
date: 2006/05/12 21:54:16;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a new scripting command to give a font's bounding box.
----------------------------
revision 1.1350
date: 2006/05/12 21:12:56;  author: pfaedit;  state: Exp;  lines: +2 -2
Sigh. Within a GPOS lookup, sub-tables are not additive. Only one will be applied at a time. So order the 'kern' lookup so that pair-wise kerning comes out first (to override class kerning).
----------------------------
revision 1.1349
date: 2006/05/12 21:02:33;  author: pfaedit;  state: Exp;  lines: +3 -3
Was sometimes outputting mkmk base-mark attachement points as the mark attachment point.
----------------------------
revision 1.1348
date: 2006/05/08 04:50:42;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix some typoes in the gettext comments.
----------------------------
revision 1.1347
date: 2006/05/07 23:35:56;  author: pfaedit;  state: Exp;  lines: +3 -3
Clytie Siddall has many suggestions about how to make the translation process easier for translators. He also tells me how to insert contextual comments into the program source, and provides many fixes for typoes.
----------------------------
revision 1.1346
date: 2006/05/05 00:44:04;  author: pfaedit;  state: Exp;  lines: +2 -2
The OS/2 version 1,2 has a different defn of avgCharWidth than OS/2 version 3(,4) does. Display of CJK fonts is supposed to break under windows if using the v3 defn.
Use the appropriate defn for the version we happen to be outputting.
----------------------------
revision 1.1345
date: 2006/05/05 00:12:43;  author: pfaedit;  state: Exp;  lines: +3 -3
Autohinting crashed on glyphs in an order2 font if the glyph contained both an outline and a reference.
----------------------------
revision 1.1344
date: 2006/05/02 19:27:23;  author: pfaedit;  state: Exp;  lines: +2 -2
Another hinting fix.
----------------------------
revision 1.1343
date: 2006/05/02 14:54:50;  author: pfaedit;  state: Exp;  lines: +3 -3
Pressing the help key in the main windows went to the overview page, not to the contextual help for the window.
----------------------------
revision 1.1342
date: 2006/05/01 14:45:14;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a warning when 'CFF ' widths and 'hmtx' widths differ.
----------------------------
revision 1.1341
date: 2006/05/01 14:42:04;  author: pfaedit;  state: Exp;  lines: +3 -3
Set the default and normative widths too late after the cff subroutine change.
----------------------------
revision 1.1340
date: 2006/04/30 21:17:21;  author: pfaedit;  state: Exp;  lines: +2 -2
Make double clicking in the list of kern pair/anchor combinations bring up either Kern Pair Closeup dlg or Anchors Away.
----------------------------
revision 1.1339
date: 2006/04/30 20:27:03;  author: pfaedit;  state: Exp;  lines: +3 -3
The Anchor control dlg didn't work after the encoding change.
Add a popup message to explain what "Cor:" means.
----------------------------
revision 1.1338
date: 2006/04/29 05:08:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a mode where we are alerted immediately when we get a bad o2 spline.
----------------------------
revision 1.1337
date: 2006/04/29 00:40:23;  author: pfaedit;  state: Exp;  lines: +3 -3
Typo.
----------------------------
revision 1.1336
date: 2006/04/28 03:47:05;  author: pfaedit;  state: Exp;  lines: +2 -2
Doing a Close() from a script didn't work if the windowing system were open.
----------------------------
revision 1.1335
date: 2006/04/28 03:21:15;  author: pfaedit;  state: Exp;  lines: +2 -2
Yet another bug in type1 hinting output.
----------------------------
revision 1.1334
date: 2006/04/28 03:02:55;  author: pfaedit;  state: Exp;  lines: +2 -2
Some versions of realloc don't like allocating 0 bytes.
----------------------------
revision 1.1333
date: 2006/04/27 19:11:47;  author: pfaedit;  state: Exp;  lines: +2 -2
Users expect ff to recognize a glyph name "Diaeresis", even though Adobe (following standard American, but not European spelling) spells it "Dieresis".
----------------------------
revision 1.1332
date: 2006/04/27 18:50:12;  author: pfaedit;  state: Exp;  lines: +2 -2
GhostScript has canniptions when it gets a version 3 OS/2 table in a ttf file. So back out part of last night's irrelevant patch.
----------------------------
revision 1.1331
date: 2006/04/27 18:30:39;  author: pfaedit;  state: Exp;  lines: +2 -2
Can't add a flex hint when there's a hintmask at the mid point.
----------------------------
revision 1.1330
date: 2006/04/27 18:29:04;  author: pfaedit;  state: Exp;  lines: +3 -3
The hintmask part of PointInfo would not let you clear a hintmask.
----------------------------
revision 1.1329
date: 2006/04/27 04:14:10;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a new command to the fontview: Edit->Select->Select by Name
and a new scripting command: SelectAllInstancesOf
Both will select all encoding slots containing the named glyph (or unicode value)
----------------------------
revision 1.1328
date: 2006/04/27 03:33:54;  author: pfaedit;  state: Exp;  lines: +2 -2
Add scripting command: RemoveDetachedGlyphs
I note that scripting commands: DetachGlyphs and DetachAndRemoveGlyphs are not documented. Document them.
----------------------------
revision 1.1327
date: 2006/04/27 01:28:33;  author: pfaedit;  state: Exp;  lines: +2 -2
Be a little cleverer when dealing with altunis and a glyph's "real" unicode encoding.
----------------------------
revision 1.1326
date: 2006/04/27 01:19:32;  author: pfaedit;  state: Exp;  lines: +2 -2
Was setting typo linegap to hhead linegap.
----------------------------
revision 1.1325
date: 2006/04/27 00:57:53;  author: pfaedit;  state: Exp;  lines: +3 -3
Change some niggling irrelevancies in fontforge's truetype output.
----------------------------
revision 1.1324
date: 2006/04/25 22:28:13;  author: pfaedit;  state: Exp;  lines: +2 -2
Using the X clipboard to paste into the character view has been broken at least since I added multi-layered editing.
----------------------------
revision 1.1323
date: 2006/04/25 21:58:40;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a pref to control whether we prefer to use spacing or combining accents when building accented glyphs.
----------------------------
revision 1.1322
date: 2006/04/25 14:33:37;  author: pfaedit;  state: Exp;  lines: +3 -3
Spacing in the group dlg was sometimes off.
----------------------------
revision 1.1321
date: 2006/04/25 00:21:39;  author: pfaedit;  state: Exp;  lines: +3 -3
More hinting fixes. If the edges of a stem aren't quite parallel we had problems
----------------------------
revision 1.1320
date: 2006/04/21 22:24:07;  author: pfaedit;  state: Exp;  lines: +2 -2
More hinting fixes.
----------------------------
revision 1.1319
date: 2006/04/21 20:53:06;  author: pfaedit;  state: Exp;  lines: +3 -3
Add some new built in variables: $order, $em, $ascent, $descent
----------------------------
revision 1.1318
date: 2006/04/20 15:07:58;  author: pfaedit;  state: Exp;  lines: +3 -3
Another hinting fix.
----------------------------
revision 1.1317
date: 2006/04/20 04:48:47;  author: pfaedit;  state: Exp;  lines: +2 -2
The 'TeX ' table was output incorrectly if glyphs order wasn't the same in the sf as in the ttf.
----------------------------
revision 1.1316
date: 2006/04/19 19:51:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Random cleanup. Another leak or two.
----------------------------
revision 1.1315
date: 2006/04/19 18:44:54;  author: pfaedit;  state: Exp;  lines: +2 -2
Allow the [*] Back visibility checkbox to control whether the grid fit lines are visible or not.
----------------------------
revision 1.1314
date: 2006/04/19 16:29:36;  author: pfaedit;  state: Exp;  lines: +2 -2
If scripting is in verbose mode, flush the output buffer before calling a built in procedure (so any errors it generates will at least show the right line).
----------------------------
revision 1.1313
date: 2006/04/19 16:09:23;  author: pfaedit;  state: Exp;  lines: +3 -3
Another hinting patch.
----------------------------
revision 1.1312
date: 2006/04/18 21:12:09;  author: pfaedit;  state: Exp;  lines: +2 -2
Ambrose LI points out that the master font in a cid keyed font should match the ascent/descent of at least one of its subfonts (so that the typoAscent/Descent fields will default correctly).
----------------------------
revision 1.1311
date: 2006/04/18 14:58:17;  author: pfaedit;  state: Exp;  lines: +3 -3
More leaks.
----------------------------
revision 1.1310
date: 2006/04/18 05:41:15;  author: pfaedit;  state: Exp;  lines: +2 -2
Get rid of some more memory leaks.
----------------------------
revision 1.1309
date: 2006/04/17 22:43:07;  author: pfaedit;  state: Exp;  lines: +2 -2
Make ControlAfmLigatureOutput (scripting command) apply to ofm/tfm files too.
----------------------------
revision 1.1308
date: 2006/04/17 21:48:29;  author: pfaedit;  state: Exp;  lines: +2 -2
If we have a glyph with non-integral hints and save it with rounding then make sure glyph comp will accept.
----------------------------
revision 1.1307
date: 2006/04/17 21:46:17;  author: pfaedit;  state: Exp;  lines: +2 -2
The stem database work failed when we had tiny splines. Splines smaller than the rounding error in solving a cubic for example.
----------------------------
revision 1.1306
date: 2006/04/17 14:23:09;  author: pfaedit;  state: Exp;  lines: +3 -3
Spend some quality time with valgrind looking (oh, and fixing) memory leaks.
----------------------------
revision 1.1305
date: 2006/04/16 02:44:11;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. When parsing mac state machines I was using sizeof(long) when I should have said sizeof(int32). It gave rather bad results on 64bit machines.
----------------------------
revision 1.1304
date: 2006/04/15 20:04:47;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a scripting function to load a user defined cidmap file.
----------------------------
revision 1.1303
date: 2006/04/14 20:49:10;  author: pfaedit;  state: Exp;  lines: +3 -3
Hmm. sizeof(point)==8 on AMD64, but structures are aligned to 4. This means our chunk alloc routines complain. So if we're given something that isn't in units of sizeof(pointer) then just round it up.
----------------------------
revision 1.1302
date: 2006/04/14 02:21:19;  author: pfaedit;  state: Exp;  lines: +2 -2
lookup ordering within GSUB has been totally broken at least since I added the code to coalesce lookups for kerning.
----------------------------
revision 1.1301
date: 2006/04/13 19:09:16;  author: pfaedit;  state: Exp;  lines: +2 -2
Kanou suggests changing function name that includes Char to be Glyph. Well a few do really mean Char, but the rest should be Glyph. Leave the old names there but document them as deprecated.
----------------------------
revision 1.1300
date: 2006/04/13 17:46:10;  author: pfaedit;  state: Exp;  lines: +2 -2
Make CID keyed fonts use the new subroutine mechanism too. We can use global subrs now too!
----------------------------
revision 1.1299
date: 2006/04/13 17:41:17;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops. Familyname can be NULL, and we were indescriminately checking to make sure its length was less than 31.
----------------------------
revision 1.1298
date: 2006/04/13 05:12:20;  author: pfaedit;  state: Exp;  lines: +2 -2
Make a better use of subroutines when generating otf fonts. Doesn't work for CID fonts yet.
----------------------------
revision 1.1297
date: 2006/04/12 15:24:17;  author: pfaedit;  state: Exp;  lines: +3 -3
We crashed if we changed from one cid sub-font to another when compacted.
----------------------------
revision 1.1296
date: 2006/04/11 23:36:40;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops. I made ff work with ft22 if the debugger was being built... but it failed to compile if people didn't build the debugger.
----------------------------
revision 1.1295
date: 2006/04/11 04:35:52;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops a scripting function was marked as not needing a font when it did (HasPreservedTable & friends).
----------------------------
revision 1.1294
date: 2006/04/09 05:41:25;  author: pfaedit;  state: Exp;  lines: +2 -2
More for font compare. If there is a difference in a glyph in the two fonts add the option for including the outlines of the second glyph into the first. If the first font is missing a glyph, add an option to insert it with the outlines in the background.
----------------------------
revision 1.1293
date: 2006/04/08 20:56:33;  author: pfaedit;  state: Exp;  lines: +2 -2
Good heavens, someone wants to play with acorn2sfd. Make it compile again.
----------------------------
revision 1.1292
date: 2006/04/08 19:52:17;  author: pfaedit;  state: Exp;  lines: +3 -3
People seem to want sfddiff. So rewrite it as a fontforge script and add it back into the install process.
----------------------------
revision 1.1291
date: 2006/04/08 04:29:55;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner wants to see the raw numbers for point locations.
----------------------------
revision 1.1290
date: 2006/04/08 04:26:47;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch by Mike Frysinger to make ff look at HOME before /etc/passwd.
----------------------------
revision 1.1289
date: 2006/04/07 03:14:59;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix typo.
----------------------------
revision 1.1288
date: 2006/04/07 02:23:20;  author: pfaedit;  state: Exp;  lines: +2 -2
When using View->Show Grid Fit in an empty glyph (so it will not get a GID in the test ttf generated), fontforge would crash.
Patch from Ian Jackson of Ubuntu.
----------------------------
revision 1.1287
date: 2006/04/06 17:24:14;  author: pfaedit;  state: Exp;  lines: +2 -2
Insure that we don't generate binary eexec data which starts with a space of some nature.
----------------------------
revision 1.1286
date: 2006/04/06 17:15:09;  author: pfaedit;  state: Exp;  lines: +2 -2
Interesting. White space is defined differently after eexec than it is in other areas of PostScript. White space after eexec does not include formfeed.
----------------------------
revision 1.1285
date: 2006/04/06 14:02:40;  author: pfaedit;  state: Exp;  lines: +2 -2
Oh. The family name is also subject to the 31 character limitation under windows. Interestingly entries in the 'name' table are not.
----------------------------
revision 1.1284
date: 2006/04/06 13:32:04;  author: pfaedit;  state: Exp;  lines: +3 -3
When generating a non windows ANSI pfm file we did get the encoding right.
----------------------------
revision 1.1283
date: 2006/04/06 05:01:35;  author: pfaedit;  state: Exp;  lines: +3 -3
Grump. Windows won't install a type1 font if the fontname is longer than 31 characters.
----------------------------
revision 1.1282
date: 2006/04/05 04:22:17;  author: pfaedit;  state: Exp;  lines: +3 -3
Attempt to produce pfm files which work with non windows "ANSI" encodings.
----------------------------
revision 1.1281
date: 2006/04/05 04:20:23;  author: pfaedit;  state: Exp;  lines: +2 -2
Make fontforge compile with freetype2.2
----------------------------
revision 1.1280
date: 2006/04/05 04:08:56;  author: pfaedit;  state: Exp;  lines: +3 -3
Font compare will now unlink references to compare if the exact match fails. Useful when loading a postscript font.
----------------------------
revision 1.1279
date: 2006/04/05 04:04:44;  author: pfaedit;  state: Exp;  lines: +3 -3
Make the freehand tool work in quadratic mode (by converting the cubics generated to quadratics).
----------------------------
revision 1.1278
date: 2006/04/05 04:02:10;  author: pfaedit;  state: Exp;  lines: +2 -2
Change the way the pen tool works in quadratic mode (so that it edits cps rather than on-curve points).
----------------------------
revision 1.1277
date: 2006/04/05 03:58:53;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch by Michal Nowakowski. Get Info failed to refigure some splines properly.
----------------------------
revision 1.1276
date: 2006/04/05 03:57:55;  author: pfaedit;  state: Exp;  lines: +2 -2
invoking kde's default browser didn't work.
Patch by Dimitar Zhekov
----------------------------
revision 1.1275
date: 2006/04/05 03:56:02;  author: pfaedit;  state: Exp;  lines: +2 -2
FF still has problems when glyphs contain contours which start with control points.
----------------------------
revision 1.1274
date: 2006/04/05 03:52:48;  author: pfaedit;  state: Exp;  lines: +2 -2
If a font contained a .notdef glyph the when generating a sfnt, ff would usually put the wrong value for its advance width into the 'hmtx' table.
----------------------------
revision 1.1273
date: 2006/04/05 03:49:30;  author: pfaedit;  state: Exp;  lines: +3 -3
More fixes for font compare.
----------------------------
revision 1.1272
date: 2006/03/30 06:05:21;  author: pfaedit;  state: Exp;  lines: +2 -2
In the Select menu, Width had an extra underscore.
----------------------------
revision 1.1271
date: 2006/03/30 05:52:51;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. I failed to commit a patch to get the right weight name in an otf font.
----------------------------
revision 1.1270
date: 2006/03/30 05:49:38;  author: pfaedit;  state: Exp;  lines: +2 -2
When comparing context/chaining lookups in font compare, if a nested lookup doesn't have the same generated tag (quite likely) then check what it does rather than relying on the tag alone.
----------------------------
revision 1.1269
date: 2006/03/30 05:26:13;  author: pfaedit;  state: Exp;  lines: +2 -2
The pen tool didn't handle quadratic splines properly.
----------------------------
revision 1.1268
date: 2006/03/30 04:56:46;  author: pfaedit;  state: Exp;  lines: +2 -2
A patch added back in 2004 to make vertical substitutions work for Japanese (to work around a bug in Windows to be precise) had a bug itself if more than one language was involved.
----------------------------
revision 1.1267
date: 2006/03/29 23:43:20;  author: pfaedit;  state: Exp;  lines: +2 -2
When handling translated hintmasks we did the wrong translation for vertical stems and got garbage results.
----------------------------
revision 1.1266
date: 2006/03/29 23:40:08;  author: pfaedit;  state: Exp;  lines: +2 -2
More work on select point at.
----------------------------
revision 1.1265
date: 2006/03/29 20:51:29;  author: pfaedit;  state: Exp;  lines: +2 -2
Give a bit more info about hintmask mismatches.
----------------------------
revision 1.1264
date: 2006/03/29 20:31:33;  author: pfaedit;  state: Exp;  lines: +3 -3
New command to allow user to enter X,Y coordinates of a point and have that point be selected. I want this for debugging. It might be useful generally.
----------------------------
revision 1.1263
date: 2006/03/29 02:59:31;  author: pfaedit;  state: Exp;  lines: +2 -2
Remove an unused routine.
----------------------------
revision 1.1262
date: 2006/03/29 02:58:08;  author: pfaedit;  state: Exp;  lines: +2 -2
More work on font compare
----------------------------
revision 1.1261
date: 2006/03/29 02:09:59;  author: pfaedit;  state: Exp;  lines: +2 -2
ReplaceWithReference had too large a fudge factor and found macron when it should have found macron.sc in minionpro-regular.
Still problems with type2 subroutines containing glyphs with conflicts.
----------------------------
revision 1.1260
date: 2006/03/29 02:06:30;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a new flag to font compare (& some cleanup).
----------------------------
revision 1.1259
date: 2006/03/28 21:52:05;  author: pfaedit;  state: Exp;  lines: +2 -2
If an alternate/multiple subs had more than 30 components then we lost all those after 30.
----------------------------
revision 1.1258
date: 2006/03/28 21:35:25;  author: pfaedit;  state: Exp;  lines: +3 -3
Fixes for font compare.
----------------------------
revision 1.1257
date: 2006/03/28 02:00:21;  author: pfaedit;  state: Exp;  lines: +2 -2
Hmm. Sometimes least squares does give the answer we want for merge. So give it a try.
----------------------------
revision 1.1256
date: 2006/03/28 01:14:25;  author: pfaedit;  state: Exp;  lines: +2 -2
ff was overcounting kerning tables (thought it always had at least one horizontal and at least one vertical table) bug introduced by the last kerning patch.
----------------------------
revision 1.1255
date: 2006/03/27 19:37:30;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch by kanou to fix some translation problem.
----------------------------
revision 1.1254
date: 2006/03/27 16:04:03;  author: pfaedit;  state: Exp;  lines: +2 -2
One more tweak to getinfo.
----------------------------
revision 1.1253
date: 2006/03/27 15:21:32;  author: pfaedit;  state: Exp;  lines: +2 -2
Instead of generating a quadratic shape at the start, generate a cubic shape and convert to quadratic. The convert routine now knows about how to find integer control points and such.
----------------------------
revision 1.1252
date: 2006/03/27 14:59:52;  author: pfaedit;  state: Exp;  lines: +3 -3
A couple of tweaks to get info.
----------------------------
revision 1.1251
date: 2006/03/27 04:37:27;  author: pfaedit;  state: Exp;  lines: +2 -2
In Point Get Info, give users the option of editing the control points of an interpolated point. Ie. adjust the base to the cps, rather than the cps to the base.
----------------------------
revision 1.1250
date: 2006/03/26 17:44:59;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch from Kanou to get more grid size values for looking at bitmaps.
----------------------------
revision 1.1249
date: 2006/03/26 17:39:34;  author: pfaedit;  state: Exp;  lines: +3 -3
Once we start translating namelist names we must do it consistently, else we get crashes.
----------------------------
revision 1.1248
date: 2006/03/25 00:23:57;  author: pfaedit;  state: Exp;  lines: +2 -2
If a glyph starts with a control point then ff would sometimes throw out the ttf instructions, thinking it wasn't numbered properly.
----------------------------
revision 1.1247
date: 2006/03/24 23:47:50;  author: pfaedit;  state: Exp;  lines: +2 -2
A merge in a quadratic font produced a straight line. Even when it shouldn't have.
----------------------------
revision 1.1246
date: 2006/03/24 22:06:15;  author: pfaedit;  state: Exp;  lines: +3 -3
Change namelists to support non-ASCII glyph names.
----------------------------
revision 1.1245
date: 2006/03/23 17:18:10;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. Some hinting scripting commands had a "b" prepended to their name by mistake.
----------------------------
revision 1.1244
date: 2006/03/23 16:27:27;  author: pfaedit;  state: Exp;  lines: +2 -2
When pasting a glyph with hints into an empty glyph, we shouldn't set the "in need of autohinting" flag.
(Actually, we might should if the original copy were done in a glyph with out of date hints.... but that gets more complicated).
----------------------------
revision 1.1243
date: 2006/03/23 14:52:20;  author: pfaedit;  state: Exp;  lines: +3 -3
Default value of mark points of inflection wasn't being set in new charviews.
----------------------------
revision 1.1242
date: 2006/03/23 04:58:12;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch to make loading bdf fonts more efficient.
----------------------------
revision 1.1241
date: 2006/03/23 04:03:33;  author: pfaedit;  state: Exp;  lines: +2 -2
Add Kanou's "fontview" font to the list of fonts searched by default for the fontview window.
----------------------------
revision 1.1240
date: 2006/03/23 00:18:16;  author: pfaedit;  state: Exp;  lines: +2 -2
FF did not mark ghost hints.
----------------------------
revision 1.1239
date: 2006/03/22 23:26:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Interpolating fonts broke when I did the encoding change last summer.
----------------------------
revision 1.1238
date: 2006/03/22 20:41:40;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch from Kanou to prevent the hash function from returning negative numbers.
----------------------------
revision 1.1237
date: 2006/03/22 05:19:44;  author: pfaedit;  state: Exp;  lines: +2 -2
In font compare add support for checking gsub/gpos features.
----------------------------
revision 1.1236
date: 2006/03/21 23:21:31;  author: pfaedit;  state: Exp;  lines: +2 -2
More work on font compare.
----------------------------
revision 1.1235
date: 2006/03/21 16:19:27;  author: pfaedit;  state: Exp;  lines: +3 -3
Font Compare dialog.
More work on font compare scripting command.
----------------------------
revision 1.1234
date: 2006/03/20 05:33:02;  author: pfaedit;  state: Exp;  lines: +2 -2
Add (an initial version) of a scripting routine for comparing two fonts. Current version compares the outlines and hints/instructions and nothing else.
----------------------------
revision 1.1233
date: 2006/03/19 22:43:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. There's a stray underscore in a field in font info.
----------------------------
revision 1.1232
date: 2006/03/19 22:02:11;  author: pfaedit;  state: Exp;  lines: +2 -2
Refresh font view(s) after changing glyph name/unicode in glyph info in case those are being displayed.
----------------------------
revision 1.1231
date: 2006/03/19 21:57:24;  author: pfaedit;  state: Exp;  lines: +2 -2
Don't name glyphs "NameMe-%d" name them "NameMe.%d" instead. More in keeping with glyph naming conventions.
----------------------------
revision 1.1230
date: 2006/03/19 21:51:31;  author: pfaedit;  state: Exp;  lines: +2 -2
If a name entered in the goto dlg was a single unicode char, then goto would treat it as such. Normally this is fine, but a user might use the underscore character (for example) as a glyph name and not assign it to U+005F. So check for the name too.
----------------------------
revision 1.1229
date: 2006/03/19 21:44:32;  author: pfaedit;  state: Exp;  lines: +3 -3
More work on stems which aren't quite horizontal/vertical but which people seem to think should be hinted.
----------------------------
revision 1.1228
date: 2006/03/19 04:58:48;  author: pfaedit;  state: Exp;  lines: +2 -2
More hinting fixes.
----------------------------
revision 1.1227
date: 2006/03/19 04:38:58;  author: pfaedit;  state: Exp;  lines: +3 -3
I was calculating points of inflection incorrectly.
(And I was calling extrema points of inflection in some comments)
----------------------------
revision 1.1226
date: 2006/03/17 01:30:30;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops there was a path through the cubic->quadratic code which left things uninitialized.
----------------------------
revision 1.1225
date: 2006/03/16 14:49:25;  author: pfaedit;  state: Exp;  lines: +2 -2
If a glyph contained references but no alphabetic characters then Glyph Info would crash.
----------------------------
revision 1.1224
date: 2006/03/16 14:39:00;  author: pfaedit;  state: Exp;  lines: +3 -3
Scripting command AskUser doesn't work unless FF_SCRIPT_IN_LATIN1 is set. Patch by Kanou.
----------------------------
revision 1.1223
date: 2006/03/15 17:29:07;  author: pfaedit;  state: Exp;  lines: +2 -2
In some error messages I ended a sentence with a comma. Make it a full stop.
----------------------------
revision 1.1222
date: 2006/03/15 17:26:00;  author: pfaedit;  state: Exp;  lines: +2 -2
Patches from Kanou to make Japanese translation better.
----------------------------
revision 1.1221
date: 2006/03/15 17:09:57;  author: pfaedit;  state: Exp;  lines: +3 -3
Kanou points out that the code which handles modifications to the unicode char textfield complains about the wrong things and he provides a patch.
----------------------------
revision 1.1220
date: 2006/03/15 01:36:29;  author: pfaedit;  state: Exp;  lines: +2 -2
Tweak that last cubic->quadratic patch a little.
----------------------------
revision 1.1219
date: 2006/03/15 01:30:28;  author: pfaedit;  state: Exp;  lines: +2 -2
Another case where cubic->quadratic failed.
----------------------------
revision 1.1218
date: 2006/03/15 01:29:21;  author: pfaedit;  state: Exp;  lines: +2 -2
Hand tool failed to scroll background images (probably failed on hints too).
----------------------------
revision 1.1217
date: 2006/03/14 23:39:43;  author: pfaedit;  state: Exp;  lines: +2 -2
When doing a copy splines with hintmask operation we neglected to refigure the spline after transforming the end points. This was ok since we never used that info -- except if the splines were quadratic and we needed to convert to cubic. So when generating a ps font from a quadratic database, and the font contained references with scaling/rotation/etc. then we'd get erroneous results.
----------------------------
revision 1.1216
date: 2006/03/14 23:35:48;  author: pfaedit;  state: Exp;  lines: +3 -3
In Find Problems, the Flipped Reference check could fail if the reference contained a contours which intersected (themselves or each other).
----------------------------
revision 1.1215
date: 2006/03/13 16:09:48;  author: pfaedit;  state: Exp;  lines: +3 -3
New version of the stem database routines. They seem to do a better job of finding hints.
----------------------------
revision 1.1214
date: 2006/03/13 16:08:08;  author: pfaedit;  state: Exp;  lines: +3 -3
Make ff aware of ExtraLight as a valid weight when setting a default value for the PS weight string.
----------------------------
revision 1.1213
date: 2006/03/13 16:04:57;  author: pfaedit;  state: Exp;  lines: +3 -3
When enter a textfield with attached pulldown list, ff would get an event saying the first entry on the list had been chosen. This meant that the Tag dialog (used for new ligatures/substitutions/etc. would show the first tag in the list instead of blank.
----------------------------
revision 1.1212
date: 2006/03/13 15:54:59;  author: pfaedit;  state: Exp;  lines: +3 -3
Include some synonems from Richard Kinch's TrueTeX list.
----------------------------
revision 1.1211
date: 2006/03/12 04:17:46;  author: pfaedit;  state: Exp;  lines: +3 -3
more on autohinting.
----------------------------
revision 1.1210
date: 2006/03/11 01:09:43;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner points out that dotlessi_grave should really be i_grave.
----------------------------
revision 1.1209
date: 2006/03/11 00:23:46;  author: pfaedit;  state: Exp;  lines: +2 -2
Determination of whether a ghost hint is top (-20) or bottom (-21) should depend on the current contour, not on the glyph as a whole.
----------------------------
revision 1.1208
date: 2006/03/10 23:49:00;  author: pfaedit;  state: Exp;  lines: +3 -3
More hinting tweaks.
----------------------------
revision 1.1207
date: 2006/03/10 04:34:18;  author: pfaedit;  state: Exp;  lines: +2 -2
Further hinting work.
----------------------------
revision 1.1206
date: 2006/03/10 04:25:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. Last patch was wrong.
----------------------------
revision 1.1205
date: 2006/03/10 03:58:33;  author: pfaedit;  state: Exp;  lines: +2 -2
We were too brutal in trimming hints that might be (but weren't) from a flex situation.
----------------------------
revision 1.1204
date: 2006/03/10 01:21:58;  author: pfaedit;  state: Exp;  lines: +2 -2
If a glyph consists solely of references then add <ref-name1>_<ref-name2>_...<ref-name-n> to the list of possible names. Sometimes also add uniXXXXXXXX.
----------------------------
revision 1.1203
date: 2006/03/09 20:18:26;  author: pfaedit;  state: Exp;  lines: +2 -2
Kanou wants to translate some more strings.
----------------------------
revision 1.1202
date: 2006/03/09 14:06:37;  author: pfaedit;  state: Exp;  lines: +3 -3
Redo composite output in afm files.
----------------------------
revision 1.1201
date: 2006/03/08 22:44:22;  author: pfaedit;  state: Exp;  lines: +2 -2
Barry.SCHWARTZ wants to be able to reencode a font to compact from a script.
----------------------------
revision 1.1200
date: 2006/03/08 22:34:56;  author: pfaedit;  state: Exp;  lines: +2 -2
Barry.SCHWARTZ points out that my "cfg" files contain no newlines. Shows how much use they've received:-)
----------------------------
revision 1.1199
date: 2006/03/08 22:32:21;  author: pfaedit;  state: Exp;  lines: +2 -2
Barry.SCHWARTZ points out that when generating an afm file for an otf font only the first 256 characters were given encodings.
----------------------------
revision 1.1198
date: 2006/03/08 21:05:18;  author: pfaedit;  state: Exp;  lines: +3 -3
Simplify shouldn't simplify away corner points.
----------------------------
revision 1.1197
date: 2006/03/08 01:26:34;  author: pfaedit;  state: Exp;  lines: +2 -2
Simplify is now too slow. Make it faster.
----------------------------
revision 1.1196
date: 2006/03/07 23:04:25;  author: pfaedit;  state: Exp;  lines: +3 -3
After examining (and stealing with permission) Huw Davies's code in wine/tools/fnt2fon.c I believe I can now produce .fon files.
----------------------------
revision 1.1195
date: 2006/03/07 06:41:55;  author: pfaedit;  state: Exp;  lines: +2 -2
Typo in simplify/merge.
----------------------------
revision 1.1194
date: 2006/03/07 06:06:48;  author: pfaedit;  state: Exp;  lines: +2 -2
In an effort to make simplify/merge work better, I decided to slow it down by a factor of two. (Start my binary search from both the best point and the second best). This helps some...
----------------------------
revision 1.1193
date: 2006/03/07 00:17:59;  author: pfaedit;  state: Exp;  lines: +2 -2
Make simplify for quadratic splines aware of the peculiarities of truetype. So one simplification is to make a pointer interpolateable. And removing a point is not always good if it means points that were interpolateable become non-interpolateable.
----------------------------
revision 1.1192
date: 2006/03/06 20:25:52;  author: pfaedit;  state: Exp;  lines: +2 -2
Add support for reading bitmap references.
----------------------------
revision 1.1191
date: 2006/03/06 13:48:15;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch by Kanou. cvknife didn't compile in one mode.
----------------------------
revision 1.1190
date: 2006/03/06 05:26:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Typo in an error message in parsettf.c
----------------------------
revision 1.1189
date: 2006/03/06 01:13:57;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a command to show points of inflection (also change View->Mark Extrema to show where extrema occur on a spline if not at the endpoints)
----------------------------
revision 1.1188
date: 2006/03/06 01:07:35;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch by Michal Nowakowski. Uninitialized variable in simplify dlg.
----------------------------
revision 1.1187
date: 2006/03/06 01:07:03;  author: pfaedit;  state: Exp;  lines: +2 -2
If I always look for points of inflection, I get bad splines. If I ignore them I
 get better splines (on conversion cubic -> quadratic) -- at least sometimes.
----------------------------
revision 1.1186
date: 2006/03/06 01:06:09;  author: pfaedit;  state: Exp;  lines: +2 -2
glyph names for unencoded glyphs were always "uniFFFFFFFF" should be "NameMe-<n>
----------------------------
revision 1.1185
date: 2006/03/06 01:02:35;  author: pfaedit;  state: Exp;  lines: +3 -3
Werner wants CC (composite character) entries in afm for GPOS mark-to-base features.
----------------------------
revision 1.1184
date: 2006/03/04 05:51:26;  author: pfaedit;  state: Exp;  lines: +2 -2
The switch to utf8 last summer broke font info->Size
----------------------------
revision 1.1183
date: 2006/03/04 00:43:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Some tweaks to cubic->quadratic
----------------------------
revision 1.1182
date: 2006/03/04 00:28:56;  author: pfaedit;  state: Exp;  lines: +3 -3
Attempt to find integer solutions to cubic->quadratic conversion (fall back to fractions if we can't).
----------------------------
revision 1.1181
date: 2006/03/03 01:38:17;  author: pfaedit;  state: Exp;  lines: +2 -2
Allow users to ask for both 'GPOS' and old-style 'kern' tables.
----------------------------
revision 1.1180
date: 2006/03/03 00:49:02;  author: pfaedit;  state: Exp;  lines: +3 -3
If we tried to put more than about 10000 kerning pairs into one old-style kerning sub-table then we'd overflow various shorts. So split it up after about 10000 kp into several different sub-tables.
----------------------------
revision 1.1179
date: 2006/02/28 15:45:16;  author: pfaedit;  state: Exp;  lines: +2 -2
Add an compilation option that restores the old behavior of cubic to quadratic conversion.
----------------------------
revision 1.1178
date: 2006/02/28 15:31:44;  author: pfaedit;  state: Exp;  lines: +3 -3
Round to Int screwed up interpolated points.
----------------------------
revision 1.1177
date: 2006/02/26 21:26:24;  author: pfaedit;  state: Exp;  lines: +2 -2
When generating a tfm file don't generate a width bigger than 16*em-size (even if the font says to) because TeX will throw it out.
----------------------------
revision 1.1176
date: 2006/02/26 21:07:30;  author: pfaedit;  state: Exp;  lines: +2 -2
There was still a way for parallel lines to sneak into the quadratic conversion leading to nans.
----------------------------
revision 1.1175
date: 2006/02/26 14:39:33;  author: pfaedit;  state: Exp;  lines: +3 -3
Alexey Kryukov's patch to fix an error message.
----------------------------
revision 1.1174
date: 2006/02/25 01:05:40;  author: pfaedit;  state: Exp;  lines: +3 -3
Redo cubic to quadratic spline conversion. Make it symmetric.
----------------------------
revision 1.1173
date: 2006/02/20 04:40:40;  author: pfaedit;  state: Exp;  lines: +2 -2
Printing a CID keyed truetype font to a pdf file produced a very odd ordering of glyphs (compacting some and omitting others and getting errors when it ran out of glyphs but asked for more).
----------------------------
revision 1.1172
date: 2006/02/19 23:10:13;  author: pfaedit;  state: Exp;  lines: +2 -2
Alexey Kryukov suggests repunctuating an error message.
----------------------------
revision 1.1171
date: 2006/02/19 22:55:02;  author: pfaedit;  state: Exp;  lines: +2 -2
autohinting fixes.
----------------------------
revision 1.1170
date: 2006/02/19 22:50:37;  author: pfaedit;  state: Exp;  lines: +2 -2
I need a separate flag to control hint testing so change the argument sequence yet again of CompareGLyphs.
----------------------------
revision 1.1169
date: 2006/02/19 20:00:10;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix hint compare.
----------------------------
revision 1.1168
date: 2006/02/19 15:53:28;  author: pfaedit;  state: Exp;  lines: +3 -3
In type2 fonts, hintmasks for translated references were wrong.
----------------------------
revision 1.1167
date: 2006/02/19 03:00:42;  author: pfaedit;  state: Exp;  lines: +2 -2
Johan Winge also points out that I identify points as tangents when they should not be. This is because I use one measure of sloppiness no matter how close the cps are to the base point when determining colinear. It's probably best to have a variable measure depending on how far the cp is from the base point.
----------------------------
revision 1.1166
date: 2006/02/19 02:56:48;  author: pfaedit;  state: Exp;  lines: +2 -2
Johan Winge suggests an improvement to converting cubic splines to quadratic: If we end up using a line when looking at the spline as a whole, try breaking it at the point of infection(s) first. It seems like a good idea.
----------------------------
revision 1.1165
date: 2006/02/19 02:53:40;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. Typo in hint comparison.
----------------------------
revision 1.1164
date: 2006/02/18 22:54:16;  author: pfaedit;  state: Exp;  lines: +2 -2
Alexey Kryukov thinks Add Unencoded Slots should work in the compacted view by making the thing have a custom encoding.
----------------------------
revision 1.1163
date: 2006/02/18 22:43:18;  author: pfaedit;  state: Exp;  lines: +2 -2
Scripting reencode didn't get rid of the "compacted" mark.
----------------------------
revision 1.1162
date: 2006/02/18 22:29:54;  author: pfaedit;  state: Exp;  lines: +3 -3
Ralf Stubner points out that I produce type1 charstrings which end in "seac endchar" when a simple "seac" is sufficient. He's right.
----------------------------
revision 1.1161
date: 2006/02/18 05:25:08;  author: pfaedit;  state: Exp;  lines: +2 -2
make glyph comp compare hints too.
----------------------------
revision 1.1160
date: 2006/02/17 22:11:09;  author: pfaedit;  state: Exp;  lines: +3 -3
When generating opentype tables in from a single sub-font of a cid-keyed font (ie. user asked for a ttf font generated from one sub-font) ff would crash.
----------------------------
revision 1.1159
date: 2006/02/17 04:59:11;  author: pfaedit;  state: Exp;  lines: +2 -2
When we've got one curved edge and one straight edge we have a hard time figuring if a hint is too big.
----------------------------
revision 1.1158
date: 2006/02/17 04:32:13;  author: pfaedit;  state: Exp;  lines: +2 -2
We didn't hint bold fonts well (anything where stems were bigger than em-size/10)
----------------------------
revision 1.1157
date: 2006/02/17 03:22:14;  author: pfaedit;  state: Exp;  lines: +2 -2
When generating a type1 font with a glyph containing a reference that had to be unlinked, then the vertical stems in that reference would not be hinted.
----------------------------
revision 1.1156
date: 2006/02/17 03:11:43;  author: pfaedit;  state: Exp;  lines: +2 -2
When guessing points at which to attach hints in type1/2 read in we failed if the points were too widely spaced. Be a bit more lenient.
----------------------------
revision 1.1155
date: 2006/02/17 01:31:16;  author: pfaedit;  state: Exp;  lines: +3 -3
SetCharName didn't check its flag value properly.
----------------------------
revision 1.1154
date: 2006/02/16 05:04:40;  author: pfaedit;  state: Exp;  lines: +2 -2
Uncompacting a font caused memory problems.
----------------------------
revision 1.1153
date: 2006/02/15 22:21:48;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix simple crash in metafont.
----------------------------
revision 1.1152
date: 2006/02/15 21:31:47;  author: pfaedit;  state: Exp;  lines: +2 -2
More improvements to glyphcomp.
----------------------------
revision 1.1151
date: 2006/02/15 21:28:37;  author: pfaedit;  state: Exp;  lines: +2 -2
When importing unencoded glyphs into an already existing font, we would sometimes fail to find the matching glyph (and would create a new one).
----------------------------
revision 1.1150
date: 2006/02/15 14:12:02;  author: pfaedit;  state: Exp;  lines: +3 -3
Glyph compare didn't work on bitmaps with depth>1
----------------------------
revision 1.1149
date: 2006/02/14 05:03:13;  author: pfaedit;  state: Exp;  lines: +3 -3
Further improvements (including bug fixes) to glyph compare.
----------------------------
revision 1.1148
date: 2006/02/13 04:02:34;  author: pfaedit;  state: Exp;  lines: +2 -2
If a font contain an encoded glyph called ".notdef" and that glyph was not the first glyph, then type1 fonts had a .notdef glyph at a random place in the font which screwed up freetype's rasterizer in some modes (ftview failed, ftstring worked) Rather than figure out what's wrong with freetype, just always make notdef be first in the chars dictionary and then all is happy.
----------------------------
revision 1.1147
date: 2006/02/13 02:58:37;  author: pfaedit;  state: Exp;  lines: +2 -2
Add new scripting command to compare two glyphs. I want this for testsuites, other people might find a use for it.
----------------------------
revision 1.1146
date: 2006/02/13 01:36:32;  author: pfaedit;  state: Exp;  lines: +2 -2
Make Merge/Simplify even more accurate.
----------------------------
revision 1.1145
date: 2006/02/12 15:59:13;  author: pfaedit;  state: Exp;  lines: +3 -3
gniibe reports that the scripting function Export() produces bitmap images with the wrong format and provides a patch.
----------------------------
revision 1.1144
date: 2006/02/10 01:38:27;  author: pfaedit;  state: Exp;  lines: +3 -3
Instead of refusing to do expand stroke/remove overlap for order2 fonts, why not convert the contours to order3, do the function and convert back.
----------------------------
revision 1.1143
date: 2006/02/08 20:05:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Once more we are numbering points badly.
----------------------------
revision 1.1142
date: 2006/02/08 19:45:30;  author: pfaedit;  state: Exp;  lines: +3 -3
If we clear a glyph which is being referred to (and we don't unlink it first) then when we save it into an sfd file we get a reference to a glyph at orig_pos -1 (because the cleared glyph isn't stored in the sfd) which causes an error when reading it back in.
----------------------------
revision 1.1141
date: 2006/02/08 19:38:01;  author: pfaedit;  state: Exp;  lines: +2 -2
If a copyright message were an exact multiple of 100 characters long, fontforge would screw up memory (and potentially crash) when reading it in from an sfd file.
----------------------------
revision 1.1140
date: 2006/02/08 19:33:35;  author: pfaedit;  state: Exp;  lines: +3 -3
Last "Fix" for merge command, meant that we broke curve points (ie. they formed
a corner rather than a curve). This fixes it properly.
----------------------------
revision 1.1139
date: 2006/02/06 16:17:06;  author: pfaedit;  state: Exp;  lines: +2 -2
crash
----------------------------
revision 1.1138
date: 2006/02/06 16:13:24;  author: pfaedit;  state: Exp;  lines: +2 -2
Add script for N'Ko.
----------------------------
revision 1.1137
date: 2006/02/06 14:41:24;  author: pfaedit;  state: Exp;  lines: +2 -2
Add support for the r2l script N'Ko. Note I'm guessing at the script tag.
----------------------------
revision 1.1136
date: 2006/02/06 14:09:41;  author: pfaedit;  state: Exp;  lines: +3 -3
Kanou tells me that Syriac & Thaana are also r2l scripts and should be added to my list.
----------------------------
revision 1.1135
date: 2006/02/06 05:25:24;  author: pfaedit;  state: Exp;  lines: +2 -2
Johan Winge reports another problem with add extrema. Actually a problem with ApproxFromPointsSlopes if the control points are very close to the base point (so the control points do not give us the slope which the eye sees).
----------------------------
revision 1.1134
date: 2006/02/06 03:45:42;  author: pfaedit;  state: Exp;  lines: +2 -2
If FF was given multiple fonts on the command line the sizes of the font windows would jump around in a very peculiar fashion.
----------------------------
revision 1.1133
date: 2006/02/06 03:25:31;  author: pfaedit;  state: Exp;  lines: +3 -3
Add the concept of a namelist.
Users can specify what names they want for new glyphs, or can force an
entire font into a new naming scheme. Changes to
	FontInfo
	Open
	Generate (Family)
	Preferences
and the Encoding menu.
New scripting functions:
	LoadNamelist(filename)
	LoadNamelistDir([dir])
	RenameGlyphs(namelist)
Extended Generate to take a namelist argument.
----------------------------
revision 1.1132
date: 2006/02/03 02:59:46;  author: pfaedit;  state: Exp;  lines: +3 -3
If users didn't have libuninameslist installed we were still generating spurious ligatures for numero and TM.
----------------------------
revision 1.1131
date: 2006/02/01 21:58:59;  author: pfaedit;  state: Exp;  lines: +2 -2
KANOU points out that if you comment out a bdf glyph (with COMMENT) fontforge sort of reads it anyway.
----------------------------
revision 1.1130
date: 2006/02/01 21:41:53;  author: pfaedit;  state: Exp;  lines: +2 -2
More work for Kanou's disambiguation between latin script and latin language.
Mac languages broken since the gettext patch.
----------------------------
revision 1.1129
date: 2006/02/01 21:05:31;  author: pfaedit;  state: Exp;  lines: +2 -2
Kanou needs to distinquish between the script latin and the language.
----------------------------
revision 1.1128
date: 2006/02/01 20:17:10;  author: pfaedit;  state: Exp;  lines: +3 -3
SplineRemoveAnnoyingExtrema1 got tweaked a little too much in attempting not to generate insane control points.
----------------------------
revision 1.1127
date: 2006/01/28 00:46:53;  author: pfaedit;  state: Exp;  lines: +2 -2
SetCharCount scripting call failed if you reduced the char cnt. (this just affects the encoding now, the glyph remains).
----------------------------
revision 1.1126
date: 2006/01/28 00:20:43;  author: pfaedit;  state: Exp;  lines: +2 -2
Loading a bitmap font could call SFMakeChar with a bad encoding.
----------------------------
revision 1.1125
date: 2006/01/28 00:04:04;  author: pfaedit;  state: Exp;  lines: +3 -3
Typo in an encoding property chech that occurred when loading ZapfDingbats.pcf
----------------------------
revision 1.1124
date: 2006/01/26 14:09:57;  author: pfaedit;  state: Exp;  lines: +3 -3
If I am going to provide a round trip mechanism for bdf->sfnt then I suppose I should preserve the ascent/descent in the horilinemetrics even if I personally think their values are wrong.
----------------------------
revision 1.1123
date: 2006/01/25 22:03:41;  author: pfaedit;  state: Exp;  lines: +3 -3
Damn. I failed to complete the last patch for one of the cases, and bingo that causes failure.
----------------------------
revision 1.1122
date: 2006/01/25 01:12:01;  author: pfaedit;  state: Exp;  lines: +3 -3
If you ask to create an otb font but provide no valid bitmap strikes, ff will crash.
----------------------------
revision 1.1121
date: 2006/01/23 20:43:36;  author: pfaedit;  state: Exp;  lines: +2 -2
Chia points out that I should use the PIXEL_SIZE property to set a bdf font's pixelsize. I was using FONT_ASCENT+FONT_DESCENT. I think they should be the same, but sometimes they are not.
----------------------------
revision 1.1120
date: 2006/01/23 13:52:29;  author: pfaedit;  state: Exp;  lines: +3 -3
Someone handed us a glyph with a point at 13,476,000 (and another near 0) and asked us to rasterize it. We ran out of memory.
----------------------------
revision 1.1119
date: 2006/01/23 02:38:55;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. The change to make Add Extrema remove points close to the extrema failed to consider that one of those points might be a corner and not a smooth curve. Removing a corner is wrong. Removing a curve point is ok.
----------------------------
revision 1.1118
date: 2006/01/22 22:51:25;  author: pfaedit;  state: Exp;  lines: +2 -2
In Gentium Roman the base line is such that "0" is outside one standard deviation from the mean. Tweak things (lie about the standard deviation) so that 0 is always within range.
----------------------------
revision 1.1117
date: 2006/01/22 22:41:51;  author: pfaedit;  state: Exp;  lines: +2 -2
Font Info->PS Private. If we selected OtherBlues and pressed [Guess] it did not change the OtherBlues value.
----------------------------
revision 1.1116
date: 2006/01/22 22:33:52;  author: pfaedit;  state: Exp;  lines: +2 -2
The gettext patch changed Histograms->Blue Values menu item into a line.
----------------------------
revision 1.1115
date: 2006/01/22 22:28:08;  author: pfaedit;  state: Exp;  lines: +2 -2
When changing the order of a font, ff would always ask if you minded losing the undoes. If the font hasn't been changed there are no undoes, and no point in asking.
----------------------------
revision 1.1114
date: 2006/01/22 22:20:57;  author: pfaedit;  state: Exp;  lines: +2 -2
If user changes the next cp of a curve point, the point info dlg should update the prev cp to maintain the slope.
----------------------------
revision 1.1113
date: 2006/01/22 21:56:03;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. There was a path through point info that called SplineRefigure3, so this meant that quadratic splines got converted to cubic ones (the font as a whole remained quadratic, just this one spline). It looked wrong.
----------------------------
revision 1.1112
date: 2006/01/22 21:34:48;  author: pfaedit;  state: Exp;  lines: +3 -3
After approximating a spline I used to check if it were close to linear, and if so, make it linear. Unfortunately that doesn't work too well when we are using elipse mode to stroke a path. The coordinate system gets all screwed up (by the ratio of the axes) and things look linear when they aren't.
----------------------------
revision 1.1111
date: 2006/01/20 04:18:56;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a homedir (and an updir) button to the file chooser dialogs.
----------------------------
revision 1.1110
date: 2006/01/18 19:42:55;  author: pfaedit;  state: Exp;  lines: +3 -3
rotated eliptical pens in expand stroke didn't work.
----------------------------
revision 1.1109
date: 2006/01/17 17:36:14;  author: pfaedit;  state: Exp;  lines: +2 -2
Use the horilinemetrics to provice ascent/descent if they match.
We were using a positive descent value when we should have used a negative.
----------------------------
revision 1.1108
date: 2006/01/17 15:33:59;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. A patch with nothing to do with tilepath made a global function with the same name as a static func in tilepath (and used different arguments).
----------------------------
revision 1.1107
date: 2006/01/17 15:31:52;  author: pfaedit;  state: Exp;  lines: +3 -3
My horizontal line metrics (in the eblc strike header) aren't consistent with my per-glyph metrics.
----------------------------
revision 1.1106
date: 2006/01/16 05:47:33;  author: pfaedit;  state: Exp;  lines: +2 -2
read utf7 strings from sfd files was broken if one of the characters had bit 15 (high bit) set and its position mod 3 was 1.
----------------------------
revision 1.1105
date: 2006/01/16 04:16:01;  author: pfaedit;  state: Exp;  lines: +2 -2
Make the Import() scripting command handle compressed bdf/pcf fonts too.
----------------------------
revision 1.1104
date: 2006/01/16 01:42:12;  author: pfaedit;  state: Exp;  lines: +3 -3
Damn. The patch to merge comments into one property broke the 'BDF ' sfnt table.
----------------------------
revision 1.1103
date: 2006/01/15 06:16:34;  author: pfaedit;  state: Exp;  lines: +2 -2
Change AddExtrema (again) so that if an extremum is very close to an old point it will add the extremum and then remove the old point.
----------------------------
revision 1.1102
date: 2006/01/15 04:27:28;  author: pfaedit;  state: Exp;  lines: +2 -2
The arrow keys should now work like the arrow buttons in the bdf properties dlg.
----------------------------
revision 1.1101
date: 2006/01/14 23:48:26;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a dlg to give user control over bdf properties.
----------------------------
revision 1.1100
date: 2006/01/13 23:08:15;  author: pfaedit;  state: Exp;  lines: +2 -2
If a strike in an sfnt has a BDF FONT_ASCENT property then use that info to set the font's ascent.
----------------------------
revision 1.1099
date: 2006/01/13 23:06:09;  author: pfaedit;  state: Exp;  lines: +3 -3
Ted Packard points out that I output "big metrics" in sfnts inconsistently. This patch should make them consistent and right.
----------------------------
revision 1.1098
date: 2006/01/12 18:35:14;  author: pfaedit;  state: Exp;  lines: +2 -2
More on FULL_NAME -> FACE_NAME
----------------------------
revision 1.1097
date: 2006/01/12 18:30:48;  author: pfaedit;  state: Exp;  lines: +3 -3
Clean up BDF properties a bit.
I read the XLFD spec. So mark as unsigned those properties which X says are unsigned.
QUAD_SPACE has been depreciated, so don't generate it. UNDERLINE_* should be in pixel units. ITALIC_ANGLE is quite unexpectedly defined. FULL_NAME has been renamed to FACE_NAME...
----------------------------
revision 1.1096
date: 2006/01/11 19:07:24;  author: pfaedit;  state: Exp;  lines: +3 -3
The CHARSET_ENCODING often contained a leading "-" when generating bdf fonts with iso8859 encodings. It shouldn't have.
Also note that we need to change bdf properties when the user changes the encoding or the fontname.
----------------------------
revision 1.1095
date: 2006/01/10 12:51:38;  author: pfaedit;  state: Exp;  lines: +3 -3
Adding unencoded slots to a compact encoding would not add them to the normal enc and would cause problems later. Simply turn this off if we are compacted.
----------------------------
revision 1.1094
date: 2006/01/10 02:05:52;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. Remove compaction if we reencode.
----------------------------
revision 1.1093
date: 2006/01/10 01:23:55;  author: pfaedit;  state: Exp;  lines: +3 -3
Restore "compact" views to their old glory. I think they are much easier to handle now (unless I'm missing something).
----------------------------
revision 1.1092
date: 2006/01/08 22:51:37;  author: pfaedit;  state: Exp;  lines: +2 -2
When reading a GenTags: line from an sfd file stored with CRLF line terminators, the next line would be lost.
----------------------------
revision 1.1091
date: 2006/01/08 22:23:16;  author: pfaedit;  state: Exp;  lines: +2 -2
ff couldn't handle xrefs which were broken in bits? Linearized pdf? something like that.
----------------------------
revision 1.1090
date: 2006/01/08 21:37:37;  author: pfaedit;  state: Exp;  lines: +2 -2
When reading a ttf font from a pdf file we found no encoding info. This caused us to crash because various routines expected an encoding map. Add a dummy (Original) map if not exists.
----------------------------
revision 1.1089
date: 2006/01/08 21:07:37;  author: pfaedit;  state: Exp;  lines: +2 -2
Wasn't numbering points in references properly. Shouldn't matter much, but it screwed up test119.pe
----------------------------
revision 1.1088
date: 2006/01/08 15:02:31;  author: pfaedit;  state: Exp;  lines: +3 -3
The "dontinterpolate" patch didn't work because ttf generation turned it off.
----------------------------
revision 1.1087
date: 2006/01/06 02:05:04;  author: pfaedit;  state: Exp;  lines: +2 -2
Gleep! Ever since the gettext code went in, the Generate fonts dlg has refused to generate "No Outline Font" and "No Bitmap Font".
----------------------------
revision 1.1086
date: 2006/01/06 01:28:43;  author: pfaedit;  state: Exp;  lines: +3 -3
Herbert Duerr from OpenOffice tells me that their OpenSymbol.ttf font when produced by fontforge does not work on Win98. This is because Win98 doesn't like the codepages bits ff produces and refuses to use any glyphs in the font. He submitted a patch to make ff produce a version 0 OS/2 table (with no codepage info) for this font. Win98 will accept it then. His patch was against an earlier version of ff and needed to be modified for the current version.
----------------------------
revision 1.1085
date: 2006/01/04 20:41:18;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch by Raph Levien which finally shows me how to use FT_Outline_Get_Bitmap properly.
----------------------------
revision 1.1084
date: 2006/01/02 01:38:27;  author: pfaedit;  state: Exp;  lines: +2 -2
If the user has never called PrintSetup (or if the user has not called PrintSetup this session and has not loaded prefs), then fontforge will invode setpagedevice on a pagesize which will fit on either A4 or US-Letter. The PS manual says a printer should refuse such a size unless it has paper within 5 points of it. So on printers which follow the spec (not mine) nothing will print as it waits for paper.

Now if the pagesize has not been set, don't specify a PageSize to setpagedevice.
----------------------------
revision 1.1083
date: 2006/01/02 01:34:06;  author: pfaedit;  state: Exp;  lines: +2 -2
The PrintSetup scripting command should not require a font.
----------------------------
revision 1.1082
date: 2006/01/01 20:51:56;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a mechanism so that users can prevent ff from making a point implicit. Useful in that point needs to be instructed.
----------------------------
revision 1.1081
date: 2006/01/01 14:48:59;  author: pfaedit;  state: Exp;  lines: +3 -3
New copyright notices for 2006
----------------------------
revision 1.1080
date: 2006/01/01 04:55:12;  author: pfaedit;  state: Exp;  lines: +2 -2
Make the pen tool work better with quadratic splines (make it default to having control points which cause the point to be implicit).
----------------------------
revision 1.1079
date: 2006/01/01 04:25:05;  author: pfaedit;  state: Exp;  lines: +2 -2
Quadratic elipses still aren't quite right.
----------------------------
revision 1.1078
date: 2006/01/01 03:36:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Order2 elipses were not drawn accurately.
----------------------------
revision 1.1077
date: 2006/01/01 03:13:43;  author: pfaedit;  state: Exp;  lines: +2 -2
Point numbers sometimes didn't get properly renumbered after changes. If we have references & splines in a (truetype) glyph then show the numbers as "?".
----------------------------
revision 1.1076
date: 2006/01/01 02:38:34;  author: pfaedit;  state: Exp;  lines: +2 -2
When a charview displays numbered (truetype) points, then it shows all the control points. But the control points are selectable. This is not a good thing, so make them selectable.
----------------------------
revision 1.1075
date: 2005/12/31 21:17:37;  author: pfaedit;  state: Exp;  lines: +2 -2
 The font display to pdf did not include a title at the top of each page.
----------------------------
revision 1.1074
date: 2005/12/31 21:15:50;  author: pfaedit;  state: Exp;  lines: +2 -2
Peter Denisevich points out that when we print something we say "%%Pages atend" instead of "%%Pages (atend)". And the latter is correct.
----------------------------
revision 1.1073
date: 2005/12/31 20:40:50;  author: pfaedit;  state: Exp;  lines: +3 -3
Werner points out that my type1 (and type1 cid) fonts contain a %%DocumentSuppliedResource line, and they should not. The next level up should do that when it includes the font.
----------------------------
revision 1.1072
date: 2005/12/30 20:36:12;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops, missed a spot.
----------------------------
revision 1.1071
date: 2005/12/30 20:35:16;  author: pfaedit;  state: Exp;  lines: +3 -3
Show .xpm files as images we support in import image dlg. We've always supported them, might as well show them.
----------------------------
revision 1.1070
date: 2005/12/29 14:19:26;  author: pfaedit;  state: Exp;  lines: +3 -3
Check the glyph class when deciding what anchor to use.
----------------------------
revision 1.1069
date: 2005/12/28 21:17:40;  author: pfaedit;  state: Exp;  lines: +2 -2
Anshuman Pandey wants to be able to set the glyph's GDEF class. I've never understood why the default behavior wasn't good enough, but it's easy to do.
----------------------------
revision 1.1068
date: 2005/12/28 21:02:25;  author: pfaedit;  state: Exp;  lines: +2 -2
One of the fields in Glyph Info had some garbage initialization.
----------------------------
revision 1.1067
date: 2005/12/28 20:58:54;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a default anchor point type to the AddAnchorPoint scripting command. FF will try to guess an appropriate value.
----------------------------
revision 1.1066
date: 2005/12/26 22:47:09;  author: pfaedit;  state: Exp;  lines: +3 -3
Add some standard window sizes to the fontview window. I'm tired of having the windows sized to other people's standards whenever I review a bug.
----------------------------
revision 1.1065
date: 2005/12/26 04:59:21;  author: pfaedit;  state: Exp;  lines: +2 -2
There was a path through expand stroke where a control point was marked as non-existant by mistake.
----------------------------
revision 1.1064
date: 2005/12/26 03:49:46;  author: pfaedit;  state: Exp;  lines: +2 -2
Expand Stroke would leave contours with the reversed orientation if it had to do a remove overlap internally.
----------------------------
revision 1.1063
date: 2005/12/25 19:44:45;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. The routine to save the encoding prefs file could not handle an encoding plug-in.
----------------------------
revision 1.1062
date: 2005/12/25 19:32:57;  author: pfaedit;  state: Exp;  lines: +3 -3
KANOU points out that the origin pulldown list in the transform dlg was not being translated.
----------------------------
revision 1.1061
date: 2005/12/23 21:29:34;  author: pfaedit;  state: Exp;  lines: +3 -3
Kanou points out that there are still a few vestigates of Latin1 in comments,
and (sort of) in the language strings for the print command. Turn all of these into utf8.
----------------------------
revision 1.1060
date: 2005/12/22 04:47:24;  author: pfaedit;  state: Exp;  lines: +2 -2
In the preference dlg all of the [...] file browsers had the title "Call Script" which isn't appropriate for most of them.
----------------------------
revision 1.1059
date: 2005/12/22 04:45:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Typing .* and pressing [Filter] did not show hidden files in the file chooser.
----------------------------
revision 1.1058
date: 2005/12/21 20:34:07;  author: pfaedit;  state: Exp;  lines: +2 -2
the code to check for intersections failed to check if there were a crossover in the last tiny section of a spline before its end.
----------------------------
revision 1.1057
date: 2005/12/21 19:08:01;  author: pfaedit;  state: Exp;  lines: +2 -2
Was generating ofm files when creating bdf fonts. Seems unnecessary.
----------------------------
revision 1.1056
date: 2005/12/21 18:59:51;  author: pfaedit;  state: Exp;  lines: +2 -2
Grr. I was generating vertical metrics info for bdf fonts even if they had no vertical metrics. (recent bug).
----------------------------
revision 1.1055
date: 2005/12/21 18:45:47;  author: pfaedit;  state: Exp;  lines: +2 -2
the freetype bdf parser concatenates all BDF COMMENTS into one long string (separated by newlines). Be prepared to read such a string out of an sfnt BDF table.
----------------------------
revision 1.1054
date: 2005/12/21 18:43:27;  author: pfaedit;  state: Exp;  lines: +3 -3
Was producing a EBLC table with bad first/last values for first glyphs.
----------------------------
revision 1.1053
date: 2005/12/15 05:47:51;  author: pfaedit;  state: Exp;  lines: +2 -2
Hmm. Not all systems have tzset. Add a configuration option for it.
----------------------------
revision 1.1052
date: 2005/12/15 04:44:20;  author: pfaedit;  state: Exp;  lines: +2 -2
I had a declaration in the middle of executable code. Idiot.
----------------------------
revision 1.1051
date: 2005/12/15 04:27:31;  author: pfaedit;  state: Exp;  lines: +2 -2
In scripting, a return within a loop sent ff into an infinite loop.
----------------------------
revision 1.1050
date: 2005/12/14 22:12:14;  author: pfaedit;  state: Exp;  lines: +2 -2
Kanou's patch for adding a new flag to scripting Import, to clear out the layer first.
----------------------------
revision 1.1049
date: 2005/12/14 21:29:08;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch from KANOU to add SetGlyphChanged scripting function.
----------------------------
revision 1.1048
date: 2005/12/14 19:34:58;  author: pfaedit;  state: Exp;  lines: +2 -2
If an implied point became real, this fact was not reflected on the display until the user forced a point renumbering.
----------------------------
revision 1.1047
date: 2005/12/14 18:26:06;  author: pfaedit;  state: Exp;  lines: +3 -3
A mouse click in an empty metrics view references garbage memory -- And crashed Kanou's session.
----------------------------
revision 1.1046
date: 2005/12/14 04:55:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Retain BDF properties read from BDF/PCF fonts. Design a BDF table for sfnt fonts so we can do round trip transformation of BDF->otb->BDF fonts.
----------------------------
revision 1.1045
date: 2005/12/14 02:38:14;  author: pfaedit;  state: Exp;  lines: +3 -3
Loading a large bitmap font left bits of the backmap of the encoding map uninitialized.
----------------------------
revision 1.1044
date: 2005/12/12 23:07:30;  author: pfaedit;  state: Exp;  lines: +2 -2
Loading a pcf font caused a crash.
----------------------------
revision 1.1043
date: 2005/12/12 22:50:13;  author: pfaedit;  state: Exp;  lines: +2 -2
Moving the control points of an implied point should move the implied point. And we should indicate which points are implied so this behavior doesn't surprise.
----------------------------
revision 1.1042
date: 2005/12/12 22:19:14;  author: pfaedit;  state: Exp;  lines: +2 -2
Michal Nowakowski points out that renumbering points in a glyph should turn off point matching in references.
----------------------------
revision 1.1041
date: 2005/12/12 21:25:42;  author: pfaedit;  state: Exp;  lines: +3 -3
Add support for bitmaps with vertical metrics.
----------------------------
revision 1.1040
date: 2005/12/12 03:14:03;  author: pfaedit;  state: Exp;  lines: +2 -2
Wasn't storing the vendor id in the OS/2 table properly.
----------------------------
revision 1.1039
date: 2005/12/12 03:04:22;  author: pfaedit;  state: Exp;  lines: +3 -3
Rounding error present on PPC which was absent on *86 machines.
----------------------------
revision 1.1038
date: 2005/12/09 21:30:23;  author: pfaedit;  state: Exp;  lines: +2 -2
This fails for B in Vera.ttf
----------------------------
revision 1.1037
date: 2005/12/09 21:28:27;  author: pfaedit;  state: Exp;  lines: +3 -3
Another attempt to position the debugging bitmap properly.
----------------------------
revision 1.1036
date: 2005/12/09 01:18:40;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner would like pixel size info to show on the title of a charview when debugging.
----------------------------
revision 1.1035
date: 2005/12/08 16:07:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Add code to give user the ability to change the cps rather than the point itself to acheive an omitable point. But I don't like the results, so I shan't expose the code just now.
----------------------------
revision 1.1034
date: 2005/12/08 15:21:56;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a new command "Point->Center between CPs", primarily for truetype, to make an on-curve point be excludable.
----------------------------
revision 1.1033
date: 2005/12/08 05:11:22;  author: pfaedit;  state: Exp;  lines: +3 -3
When navigating menus with keys (rather than mouse) pressing Enter on a menu with nothing selected in the menu caused a reference to garbage memory -- usually a crash.
----------------------------
revision 1.1032
date: 2005/12/05 20:13:13;  author: pfaedit;  state: Exp;  lines: +3 -3
Was walking off the end of an external array. This often went unnoticed depending on how memory was laid out. Sometimes it crashed.
----------------------------
revision 1.1031
date: 2005/12/05 00:39:06;  author: pfaedit;  state: Exp;  lines: +3 -3
/* Jonathyn Bet'nct points out that once you edit in an outline window, even */
/*  if by mistake, your onlybitmaps status is gone for good */
/* Regenerate it when reading an sfd file if the font has no splines, refs, etc. */
----------------------------
revision 1.1030
date: 2005/12/02 20:50:33;  author: pfaedit;  state: Exp;  lines: +3 -3
Forgot that I had changed the name of the error routine in scripting.
----------------------------
revision 1.1029
date: 2005/12/02 01:02:22;  author: pfaedit;  state: Exp;  lines: +2 -2
utf8_valid doesn't handle NULL strings.
----------------------------
revision 1.1028
date: 2005/12/02 00:11:01;  author: pfaedit;  state: Exp;  lines: +2 -2
I added a check in parsing tfm files to make sure I didn't read outside the bounds of the kern table. But the table size was expressed in ints (32 bit units), and my index was in bytes, so I frequently exceded it.
----------------------------
revision 1.1027
date: 2005/12/01 23:23:01;  author: pfaedit;  state: Exp;  lines: +2 -2
If we used Get Info on a reference in a ttf font, and that reference did NOT do point matching we would generate an inappropriate error.
----------------------------
revision 1.1026
date: 2005/12/01 23:15:35;  author: pfaedit;  state: Exp;  lines: +3 -3
My support for using endchar as seac in type2 fonts only worked in bare cff fonts, it did not work if the cff were inside an sfnt wrapper (opentype).
----------------------------
revision 1.1025
date: 2005/11/21 04:13:40;  author: pfaedit;  state: Exp;  lines: +3 -3
I have decided that I will now store all postscript strings in utf8 (copyright, weight, familyname, etc.) They SHOULD all be ascii. But the occasional copyright mark would sneak in. We went into an infinite loop on one such because that was an illegal utf8 string. So fix a number of problems related to this.
----------------------------
revision 1.1024
date: 2005/11/18 22:42:36;  author: pfaedit;  state: Exp;  lines: +3 -3
Switch from using an internal routine to using freetype to rasterize b&w bitmaps when debugging ttf instructions.
----------------------------
revision 1.1023
date: 2005/11/16 22:17:43;  author: pfaedit;  state: Exp;  lines: +2 -2
Make the gridfit/debug settings sticky across invocations (store in prefs).
----------------------------
revision 1.1022
date: 2005/11/16 21:48:51;  author: pfaedit;  state: Exp;  lines: +2 -2
Add popup info showing the level of greyness in a truetype font being debugged in anti-alias mode.
----------------------------
revision 1.1021
date: 2005/11/16 21:18:35;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner suggests altering the dynamic range of anti-aliased rasters in the charview so that the outlines remain visible behind them.
----------------------------
revision 1.1020
date: 2005/11/16 20:53:47;  author: pfaedit;  state: Exp;  lines: +3 -3
Make the background color of the debugger raster window configurable by the user.
----------------------------
revision 1.1019
date: 2005/11/16 01:13:18;  author: pfaedit;  state: Exp;  lines: +2 -2
Slight improvement to previous patch. Corner points should still be free to change direction if they have no cp.
----------------------------
revision 1.1018
date: 2005/11/16 01:09:29;  author: pfaedit;  state: Exp;  lines: +3 -3
If a curved point had no control point in one direction, then ff thought it had no direction and felt free to change it. It should inherit the direction from the other side of the point.
This was even more confusing if the point went through a two step process, first simplifying one side into a line (losing the cp) then simplifying the line away (losing the direction).
----------------------------
revision 1.1017
date: 2005/11/14 04:16:42;  author: pfaedit;  state: Exp;  lines: +2 -2
Use a better algorithm to indicate changed pixels.
----------------------------
revision 1.1016
date: 2005/11/14 04:08:21;  author: pfaedit;  state: Exp;  lines: +2 -2
Screwed up View->Show Grid Fit... in Mono mode.
----------------------------
revision 1.1015
date: 2005/11/14 03:54:47;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner wants to be able to see grey scale rasters while debugging truetype.
He also points out that if the instruction before the end of instructions changes pixels, ff would leave them marked "changed" even after finishing the instructions.
----------------------------
revision 1.1014
date: 2005/11/13 22:02:01;  author: pfaedit;  state: Exp;  lines: +2 -2
We also can't (meaningfully) add instructions if references have been scaled by more than 200%
----------------------------
revision 1.1013
date: 2005/11/13 14:14:41;  author: pfaedit;  state: Exp;  lines: +3 -3
We were getting multiple error windows.
----------------------------
revision 1.1012
date: 2005/11/12 14:48:32;  author: pfaedit;  state: Exp;  lines: +3 -3
Don't allow users to add instructions to a glyph containing both a reference and contours.
----------------------------
revision 1.1011
date: 2005/11/12 02:34:44;  author: pfaedit;  state: Exp;  lines: +2 -2
Typo in remove overlap caused bad bug in feta26.
----------------------------
revision 1.1010
date: 2005/11/11 21:04:27;  author: pfaedit;  state: Exp;  lines: +3 -3
Further work on what makes a spline linear.
----------------------------
revision 1.1009
date: 2005/11/11 03:20:08;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops. Add a #include. And fix up scripting so it knows about one of the commands I added.
----------------------------
revision 1.1008
date: 2005/11/09 20:11:53;  author: pfaedit;  state: Exp;  lines: +3 -3
Further tweaks to the simplify patch.
----------------------------
revision 1.1007
date: 2005/11/08 23:03:54;  author: pfaedit;  state: Exp;  lines: +3 -3
The utf7 output routine in sfd did not convert from utf8 properly.
There were some underscores in the ttf names list of font info that should not have been there.
----------------------------
revision 1.1006
date: 2005/11/08 06:21:39;  author: pfaedit;  state: Exp;  lines: +2 -2
Panov finds another bug:
	If we change the unicode value of a glyph, then we also need to change
	the unicode value of any references to that glyph.
----------------------------
revision 1.1005
date: 2005/11/08 05:29:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Panov presents four more bugs:
	If an sfd file contains an unencoded glyph, it will crash
	Force Encoding->Original will crash if there's a bdf font missing
		some characters (ie. the piecemeal display font)
	Goto Dlg tried to free an uninit value
	Goto Dlg contained a string initialized by latin1 rather than utf8.
----------------------------
revision 1.1004
date: 2005/11/08 04:44:40;  author: pfaedit;  state: Exp;  lines: +2 -2
Panov has found yet another error in simplify. Be really exuberant about turning splines that trace out lines into lines.
----------------------------
revision 1.1003
date: 2005/11/07 21:26:23;  author: pfaedit;  state: Exp;  lines: +2 -2
Hmm. the changedsincelasthinted flag doesn't apply to truetype. The equivalent thing (I guess) is not having any instructions on a glyph with splines.
----------------------------
revision 1.1002
date: 2005/11/07 21:18:08;  author: pfaedit;  state: Exp;  lines: +3 -3
Still some places in menus where the lines are marked as selected
----------------------------
revision 1.1001
date: 2005/11/04 21:53:30;  author: pfaedit;  state: Exp;  lines: +3 -3
Panov wants a way to build up arrays using easier syntax than: create array, assign each element.
----------------------------
revision 1.1000
date: 2005/11/04 04:44:27;  author: pfaedit;  state: Exp;  lines: +2 -2
Sometimes we would get both an EUC-CN and a GB2312packed entry in the Encoding menu.
----------------------------
revision 1.999
date: 2005/11/04 03:56:12;  author: pfaedit;  state: Exp;  lines: +2 -2
Make the cmap and name tables pretend that GB12345 is GB2312.
----------------------------
revision 1.998
date: 2005/11/04 03:31:17;  author: pfaedit;  state: Exp;  lines: +3 -3
Add support (needs to be configured though) for GB12345
----------------------------
revision 1.997
date: 2005/11/01 04:27:43;  author: pfaedit;  state: Exp;  lines: +3 -3
Panov wants the offset cut off to be smaller.
----------------------------
revision 1.996
date: 2005/10/28 22:37:01;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a new scripting funtion: NearlyLines to convert almost linear splines to linear.
Tweak AddExtrema so that it doesn't create Extrema points which are too close to the endpoints.
----------------------------
revision 1.995
date: 2005/10/28 13:02:57;  author: pfaedit;  state: Exp;  lines: +3 -3
Didn't terminate an array of answer strings to a question dialog.
Fixed a crash in stem database.
----------------------------
revision 1.994
date: 2005/10/25 21:15:12;  author: pfaedit;  state: Exp;  lines: +3 -3
I was dumping all opentype ligatures into an ofm(tfm) file. But I should probably only add 'liga' and 'rlig' ligatures.
Omega has a bug where it thinks 0 width glyphs do not exist. Which means it thinks none of the combining accents, etc. exist. Stupid. So force the width of any zero width glyphs to be the smallest positive width.
----------------------------
revision 1.993
date: 2005/10/24 21:37:48;  author: pfaedit;  state: Exp;  lines: +2 -2
FF gave alternate substitutions (and multiple subs?) a tag of 0.
----------------------------
revision 1.992
date: 2005/10/24 20:55:06;  author: pfaedit;  state: Exp;  lines: +2 -2
The ClearTable scripting command parsed the table's tag incorrectly.
----------------------------
revision 1.991
date: 2005/10/24 15:54:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Add two scripting routines to allow people to read & write strings from and to files. One string per file.
----------------------------
revision 1.990
date: 2005/10/24 15:14:07;  author: pfaedit;  state: Exp;  lines: +2 -2
Grr. Another typo in ofm generation.
----------------------------
revision 1.989
date: 2005/10/24 14:24:44;  author: pfaedit;  state: Exp;  lines: +3 -3
Someone wanted longer strings in scripts. So raise the limit to 256 bytes from 100.
----------------------------
revision 1.988
date: 2005/10/23 21:34:41;  author: pfaedit;  state: Exp;  lines: +3 -3
David Binderman points out an out of bounds array reference in cvexport which has been there for years. Gleep.
----------------------------
revision 1.987
date: 2005/10/21 23:09:36;  author: pfaedit;  state: Exp;  lines: +3 -3
Add scripting commands for manipulating ttf instructions.
----------------------------
revision 1.986
date: 2005/10/21 03:22:36;  author: pfaedit;  state: Exp;  lines: +2 -2
Daniel Gillmor points out there is no way to set the OS/2 Width field from a script. He then provides a script which does this. I realize there is no way to set any of the OS/2 values (except panose) or the PS private dictionary, and there should be (and to retrieve them too).

the following new scripting functions:
        SetOS2Value("item-name", value)
        GetOS2Value("item-name")
        SetPrivateValue("item-key","item-value")
        GetPrivateValue("item-key")
        HasPrivateValue("item-key")
        RemovePrivateValue("item-key")

SetPrivateValue
        Changes (or Adds) an entry to the font's private dictionary with
        the given key and given value. Both must be strings. The key may
        be anything, it is not limited to any set of expected keys.
GetPrivateValue
        Returns the string in the private dictionary which matches the
        given key. If the key isn't in the dictionary it explodes.
HasPrivateValue
        Returns whether a key is in the dictionary
RemovePrivateValue
        Removes a key (and associated value) from the dictionary.
        Returns whether the key was in the dictionary (this is not a
        typo).
SetOS2Value
        The first argument must be one of the following strings. The
        second argument is usually an integer, but VendorId takes a (4
        character) string, and panose takes a 10 element integer array.
        Weight, Width, FSType, IBMFamily, VendorID, Panose,
        WinAscent, WinAscentIsOffset
                These are equivalent to the WinAscent field & []Offset
                check box in Font Info->OS/2->Misc. Where
                WinAscentOffset controls whether WinAscent is treated as
                an absolute number or as relative to the expected
                number.
        WinDescent, WinDescentIsOffset,
        TypoAscent, TypoAscentIsOffset,
        TypoDescent, TypoDescentIsOffset,
        HHeadAscent, HHeadAscentIsOffset,
        HHeadDescent, HHeadDescentIsOffset,
        TypoLineGap, HHeadLineGap, VHeadLineGap,
        SubXSize, SubYSize, SubXOffset, SubYOffset,
                Sets the Subscript x/y sizes/offsets
        SupXSize, SupYSize, SupXOffset, SupYOffset,
                Sets the Superscript x/y sizes/offsets
        StrikeOutSize, StrikeOutPos
GetOS2Value
        The argument takes the same set of tag strings. VendorId returns
        a string, and Panose returns an array. The others return
        integers.
----------------------------
revision 1.985
date: 2005/10/20 15:31:10;  author: pfaedit;  state: Exp;  lines: +2 -2
And the popup menu in the bitmap view has underscores where it should not.
----------------------------
revision 1.984
date: 2005/10/20 13:32:31;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops problems with popup menus in font & outline views.
----------------------------
revision 1.983
date: 2005/10/18 21:45:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. Ofm files with a glyph with more than 128 kerns didn't work.
----------------------------
revision 1.982
date: 2005/10/18 14:58:33;  author: pfaedit;  state: Exp;  lines: +3 -3
When outputting mark-to-base lookups with multiple anchor classes, ff would put a base glyph in the coverage table several times if it was used by several mark classes. Bad.
----------------------------
revision 1.981
date: 2005/10/18 04:46:18;  author: pfaedit;  state: Exp;  lines: +2 -2
KANOU points out that I was using too strict a rule for parsing svg polygons.
----------------------------
revision 1.980
date: 2005/10/18 04:24:36;  author: pfaedit;  state: Exp;  lines: +2 -2
Back before LogError, I printed everything to stderr, and strings needed to be converted to the default (output) encoding. No I use LogError and strings need to be utf8. I didn't think of this (most strings passed to LogError were ASCII). But Panov found a crash with KOI8-R.
----------------------------
revision 1.979
date: 2005/10/17 23:34:17;  author: pfaedit;  state: Exp;  lines: +2 -2
Oh. It looks as though ofm files don't actually use the font direction field. All files I've looked at have this set to 0 (Top to bottom, Left to Right) even the arabic only ones.
----------------------------
revision 1.978
date: 2005/10/17 23:27:57;  author: pfaedit;  state: Exp;  lines: +3 -3
KANOU points out that gettext only works for me if it outputs a UTF-8 encoding. I think calling bind-textdomain-codeset does that for me.
----------------------------
revision 1.977
date: 2005/10/17 04:51:36;  author: pfaedit;  state: Exp;  lines: +1 -1
We weren't passing -lintl to sfddiff.
----------------------------
revision 1.976
date: 2005/10/17 04:42:12;  author: pfaedit;  state: Exp;  lines: +1 -1
On the mac we need a special -I entry to find libintl.h (it's in /sw/include) but we can't use CFLAGS for splinerefigure (lest we turn on the optimizer), so we have to compile it with CPPFLAGS. Which we weren't doing.
----------------------------
revision 1.975
date: 2005/10/17 04:35:39;  author: pfaedit;  state: Exp;  lines: +2 -2
Lost a declaration we need on the mac in the window menu builder.
----------------------------
revision 1.974
date: 2005/10/17 01:59:56;  author: pfaedit;  state: Exp;  lines: +2 -2
I think I know what values to use for font_direction in an ofm file. I shall only worry about l2r & r2l.
----------------------------
revision 1.973
date: 2005/10/16 18:22:04;  author: pfaedit;  state: Exp;  lines: +2 -2
Add default 'nukt' "ligature" substitutions to appropriate Devanagari characters.
----------------------------
revision 1.972
date: 2005/10/16 17:59:36;  author: pfaedit;  state: Exp;  lines: +2 -2
Typo.
----------------------------
revision 1.971
date: 2005/10/16 15:47:44;  author: pfaedit;  state: Exp;  lines: +2 -2
FontInfo had some display problems.
----------------------------
revision 1.970
date: 2005/10/16 15:33:09;  author: pfaedit;  state: Exp;  lines: +3 -3
More tweaks to ofm files, but ofm2opl still crashes on our attempts.
----------------------------
revision 1.969
date: 2005/10/16 02:47:44;  author: pfaedit;  state: Exp;  lines: +2 -2
No labels in maxp dlg.
----------------------------
revision 1.968
date: 2005/10/15 18:23:04;  author: pfaedit;  state: Exp;  lines: +3 -3
The ignore marks patch of 8 Oct (which relied on widthset rather than width!=1em) broke bitmap output. Bitmap input (from win & palm fonts) didn't set widthset when it should, and bitmap editing didn't set it either.
----------------------------
revision 1.967
date: 2005/10/15 04:14:32;  author: pfaedit;  state: Exp;  lines: +3 -3
The ofm patch broke tfm output.
Ofm files didn't contain ligatures.
----------------------------
revision 1.966
date: 2005/10/14 22:14:47;  author: pfaedit;  state: Exp;  lines: +3 -3
Change fontforge to use GNU gettext rather than my own nomen services (for translations).
----------------------------
revision 1.965
date: 2005/10/13 00:36:43;  author: pfaedit;  state: Exp;  lines: +2 -2
branches:  1.965.2;
Forgot about scripting access to ofm files.
----------------------------
revision 1.964
date: 2005/10/13 00:27:37;  author: pfaedit;  state: Exp;  lines: +3 -3
Add support for generating ofm files. I hope.
----------------------------
revision 1.963
date: 2005/10/11 20:08:42;  author: pfaedit;  state: Exp;  lines: +3 -3
Entry for the warnings window is dimmed even if window is invisible.
----------------------------
revision 1.962
date: 2005/10/10 20:45:19;  author: pfaedit;  state: Exp;  lines: +3 -3
If I tried to generate a font from an absolutely empty fontdb (ie. a new one) then I'd get a stupid error about how .notdef was at encoding -1 and this was a bad idea.
----------------------------
revision 1.961
date: 2005/10/09 14:26:57;  author: pfaedit;  state: Exp;  lines: +3 -3
Add 4 new information types to scripting GlyphInfo
  * LayerCount
	Number of layers in glyph (usually 2)
  * RefCount
	Number of refs in glyph
  * RefNames
	Returns an array of all reference names (may be 0 length)
  * RefTransform
	Returns an array of all reference transforms
----------------------------
revision 1.960
date: 2005/10/09 05:37:29;  author: pfaedit;  state: Exp;  lines: +2 -2
Don't mark glyphs with widths other than 1em as being worth outputting (require widthset). Used to use both (because in the early days, before pfaedit moved to sourceforge even, the widthset bit didn't exist). Now there are too many cases where glyphs are created with a width other than 1em (marks, glyphs in monospace fonts (where the space is anything but 1em)).
----------------------------
revision 1.959
date: 2005/10/09 04:59:12;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops. The create monospace glyph patch was wrong.
----------------------------
revision 1.958
date: 2005/10/08 00:44:51;  author: pfaedit;  state: Exp;  lines: +2 -2
Ok. Now we can parse simple pdf type3 fonts (ie. the kind we generate, no text, no images).
----------------------------
revision 1.957
date: 2005/10/08 00:41:44;  author: pfaedit;  state: Exp;  lines: +2 -2
When printing a type3 pdf font, give it a name. Not required, but so what.
----------------------------
revision 1.956
date: 2005/10/07 21:25:17;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch from Michal Nowakowski. When editing truetype instructions using my prefix notation for numbers, there was a crash if a number needed a word (rather than a byte).
----------------------------
revision 1.955
date: 2005/10/07 03:02:54;  author: pfaedit;  state: Exp;  lines: +3 -3
Add some support for reading fonts out of a pdf file.
	* No support for pdf type3
	* Only support (Hex, 85, Flate, RLE)Decode filters
		(no support for lzw, fax, JBIG, DCT)
----------------------------
revision 1.954
date: 2005/10/05 22:24:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. I turned "is_type2" on in the wrong place. So my previous patch for reading bad type2 fonts with othersubr calls didn't work.
----------------------------
revision 1.953
date: 2005/10/05 21:41:52;  author: pfaedit;  state: Exp;  lines: +2 -2
Fixup a couple of other likely memory leaks caused by using SplinePointListFree rather than using SplinePointListsFree.
----------------------------
revision 1.952
date: 2005/10/05 20:24:46;  author: pfaedit;  state: Exp;  lines: +2 -2
The routine to build the stem database would set up a point database and then call a routine to convert all splines into a set of monotonics. But that routine could remove 0 length splines (and the points attached), which would mean our point db would be wrong.
----------------------------
revision 1.951
date: 2005/10/05 19:01:02;  author: pfaedit;  state: Exp;  lines: +2 -2
Stefan Wanger suggests some patches to fix memory leaks. Most were correct, if a bit verbose. Some of the leaks fixed will never happen in a real font though.
----------------------------
revision 1.950
date: 2005/10/05 18:24:10;  author: pfaedit;  state: Exp;  lines: +2 -2
Stefan Wanger gave me a type2 font which used type1 flex conventions (calling othersubrs, etc.) There is no othersubrs operator in type2, nor any place to store othersubrs subroutines. But it is easy enough to support, so why not. Warn that it's an illegal font, of course.
----------------------------
revision 1.949
date: 2005/10/05 18:20:01;  author: pfaedit;  state: Exp;  lines: +2 -2
Stefan Wanger gave me a font containing the utf8 byte order mark in a fontname (in a CFF Name Index). PostScript says FontNames are printable ASCII. But it's easy enough to skip over it.
----------------------------
revision 1.948
date: 2005/10/05 12:55:24;  author: pfaedit;  state: Exp;  lines: +3 -3
Stefan Wanger points out a memory leak in reading flex subroutines from a type1 font.
----------------------------
revision 1.947
date: 2005/10/02 23:24:59;  author: pfaedit;  state: Exp;  lines: +2 -2
I'm a twit. In a monospace font ALL glyphs should default to the mono-width. The previous patch only worked on marks, extend it for everything.
----------------------------
revision 1.946
date: 2005/10/02 23:18:22;  author: pfaedit;  state: Exp;  lines: +2 -2
Stepan Roh points out that in a monospace font, combining glyphs should default to the mono-width while in a proportional font they should default to 0 width (or perhaps 1 em-unit for compatability with old idiotic windows systems). Use the panose field to determine if a font is monospace.
----------------------------
revision 1.945
date: 2005/10/02 22:49:05;  author: pfaedit;  state: Exp;  lines: +2 -2
New dialog: Hints->Edit 'maxp'...
Gives user access to number of functions defined, the
stack depth, storage usage, number of twilight points, which ff can't
figure out for you.
----------------------------
revision 1.944
date: 2005/10/02 15:31:35;  author: pfaedit;  state: Exp;  lines: +3 -3
For no reason I can think of this patch seems to make transparent images work on cygwin.
----------------------------
revision 1.943
date: 2005/09/30 13:23:54;  author: pfaedit;  state: Exp;  lines: +2 -2
Michal Nowakowski points out that negative values are duplicated in cvt.
----------------------------
revision 1.942
date: 2005/09/30 13:20:36;  author: pfaedit;  state: Exp;  lines: +3 -3
Patch from Michal Nowakowski fixing crash when setting size of cvt table to 0.
----------------------------
revision 1.941
date: 2005/09/30 01:42:20;  author: pfaedit;  state: Exp;  lines: +2 -2
Add utf8 entry points for many (ucs2) routines. Minimal ability to draw non-BMP glyphs now with bdf fonts with encodings: *-UnicodePlane-1 (for plane 1), *-UnicodePlane-2 (for plane 2), etc.
----------------------------
revision 1.940
date: 2005/09/30 01:07:18;  author: pfaedit;  state: Exp;  lines: +2 -2
Disable "Private to cvt" if the font has no private dict.
----------------------------
revision 1.939
date: 2005/09/30 01:00:15;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a menu command to add values from the private dict into the cvt table (BlueValues, StemSnaps).
----------------------------
revision 1.938
date: 2005/09/30 00:31:23;  author: pfaedit;  state: Exp;  lines: +2 -2
The Edit cvt window usually failed to draw anything in itself when it popped up (subsequent refreshes were ok).
----------------------------
revision 1.937
date: 2005/09/29 22:44:50;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch from Michal Nowakowski to improve memory usage in auto instr.
----------------------------
revision 1.936
date: 2005/09/29 22:41:30;  author: pfaedit;  state: Exp;  lines: +3 -3
Printing sample text was broken in fonts with no kerning classes.
----------------------------
revision 1.935
date: 2005/09/29 22:21:58;  author: pfaedit;  state: Exp;  lines: +3 -3
cygwin does very weird things with shared libaries, and we didn't support them at all.
----------------------------
revision 1.934
date: 2005/09/27 21:37:32;  author: pfaedit;  state: Exp;  lines: +3 -3
FontForge did not support the depreciated usage of endchar to mean (almost) seac in type2 charstrings. It should now.
----------------------------
revision 1.933
date: 2005/09/26 19:45:05;  author: pfaedit;  state: Exp;  lines: +3 -3
os2 typo linegap was not read out of sfd files.
----------------------------
revision 1.932
date: 2005/09/25 18:45:31;  author: pfaedit;  state: Exp;  lines: +3 -3
Notice 'gai' files in the open dlg.
----------------------------
revision 1.931
date: 2005/09/25 04:52:11;  author: pfaedit;  state: Exp;  lines: +3 -3
I got some mnemonics wrong. Fix 'em up.
----------------------------
revision 1.930
date: 2005/09/23 00:34:11;  author: pfaedit;  state: Exp;  lines: +2 -2
bdftopcf will use the glyph encoded at 0 as the default glyph if there is no
explicit DEFAULT_CHAR. It seems happy with a DEFAULT_CHAR of -1 to mean no default, so use that if we don't want glyph 0 to be the default.
----------------------------
revision 1.929
date: 2005/09/23 00:24:21;  author: pfaedit;  state: Exp;  lines: +2 -2
when outputting bdf, fnt or pt3 bitmap fonts with no outline font generated, we'd get filenames like foo-*-13.bdf. Get rid of the "-*".
----------------------------
revision 1.928
date: 2005/09/22 16:35:54;  author: pfaedit;  state: Exp;  lines: +2 -2
Support point numbering of composites even when not debugging.
----------------------------
revision 1.927
date: 2005/09/22 15:07:29;  author: pfaedit;  state: Exp;  lines: +3 -3
 Michal Nowakowski points out that the cvt editor crashed if we changed the length of the table.
----------------------------
revision 1.926
date: 2005/09/22 03:37:57;  author: pfaedit;  state: Exp;  lines: +2 -2
Provide two new scripting functions:
	MoveReference(xoff,yoff,[ref-name/ref-unicode]+)
	PositionReference(x,y,[ref-name/ref-unicode]+)
These search all selected glyphs, looking for any references in those glyphs with the given name/unicode value, and then translating the reference by (xoff,yoff) or positioning the reference absolutely at (x,y).
----------------------------
revision 1.925
date: 2005/09/21 19:39:07;  author: pfaedit;  state: Exp;  lines: +3 -3
ff failed to read horizontal metrics properly from a type2 CFF CID font. In most cases this would be masked by the fact that ff would correct the bad width values by reading the hmtx table. But if one had a bare CFF font, or a 'gai' font where there is no external source of widths, ff would get things wrong.
----------------------------
revision 1.924
date: 2005/09/21 00:23:13;  author: pfaedit;  state: Exp;  lines: +2 -2
Alexej Kryukov points out that most entries in the private dict should be scaled when we do a ScaleToEm.
----------------------------
revision 1.923
date: 2005/09/20 21:03:34;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix a couple of problems with cid font display that "gai" fonts expose.
----------------------------
revision 1.922
date: 2005/09/20 15:39:13;  author: pfaedit;  state: Exp;  lines: +2 -2
Michal Nowakowski points out that I generated truetype instructions --- and then forgot to attach them to the glyph. Whoops.
----------------------------
revision 1.921
date: 2005/09/20 14:03:38;  author: pfaedit;  state: Exp;  lines: +3 -3
Loading extensible glyph information from a tfm file was broken by the encoding change.
----------------------------
revision 1.920
date: 2005/09/19 19:31:26;  author: pfaedit;  state: Exp;  lines: +2 -2
ff didn't read mac classes properly (it read one more element than it should have).
----------------------------
revision 1.919
date: 2005/09/19 15:17:47;  author: pfaedit;  state: Exp;  lines: +2 -2
Clean up svg output for a kerning class with no members.
----------------------------
revision 1.918
date: 2005/09/19 14:59:13;  author: pfaedit;  state: Exp;  lines: +2 -2
Out of bounds array reference in OS2FigureCodePages caused a crash on the mac.
----------------------------
revision 1.917
date: 2005/09/19 14:26:52;  author: pfaedit;  state: Exp;  lines: +3 -3
When loading a type1 font we failed to set the unicode encoding on seac references. This probably broke lots of things, it certainly broke replace with reference.
----------------------------
revision 1.916
date: 2005/09/19 03:36:36;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a DefaultRoundToGrid scripting function to set the Round-to-Grid truetype reference bit (basically set it whenever we have a reference which isn't point matched).
----------------------------
revision 1.915
date: 2005/09/19 03:09:13;  author: pfaedit;  state: Exp;  lines: +3 -3
Add support for truetype point matching in references and anchor points
----------------------------
revision 1.914
date: 2005/09/18 04:09:27;  author: pfaedit;  state: Exp;  lines: +2 -2
Improve the heuristic that notices "code changes" to work better with composites.
----------------------------
revision 1.913
date: 2005/09/18 04:02:17;  author: pfaedit;  state: Exp;  lines: +2 -2
Yesterday's fix for debugging composite characters was simplistic. It made three assumptions:
	1. All references had instructions
	2. The top level had no instructions
	3. No references were themselves composites.
This patch should fix these three problems.
----------------------------
revision 1.912
date: 2005/09/18 03:42:09;  author: pfaedit;  state: Exp;  lines: +2 -2
If I attempted to debug a glyph with no instructions there was a race condition and if the race was won one way, ff would hang.

(this doesn't improve behavior in the debugger where a restart eventually causes gdb to say "couldn't get registers" and stop.)
----------------------------
revision 1.911
date: 2005/09/18 02:37:48;  author: pfaedit;  state: Exp;  lines: +2 -2
We weren't numbering points in a composite. This was only obvious when we did a View->Show Grid Fit on a composite glyph.
----------------------------
revision 1.910
date: 2005/09/18 01:39:30;  author: pfaedit;  state: Exp;  lines: +3 -3
We were always setting _Round_to_Grid in ttf composite output.

Default new references so that round to grid is set.
----------------------------
revision 1.909
date: 2005/09/17 05:05:56;  author: pfaedit;  state: Exp;  lines: +2 -2
When debugging a composite glyph, ff forgot that some references are translated (or scaled or rotated), and failed to display this.
----------------------------
revision 1.908
date: 2005/09/17 05:02:01;  author: pfaedit;  state: Exp;  lines: +2 -2
FF failed to keep track of the truetype "RoundToGrid" bit which applies to references.
----------------------------
revision 1.907
date: 2005/09/16 22:20:38;  author: pfaedit;  state: Exp;  lines: +2 -2
In the Points window of truetype debugging, if the penultimate point of a contour was interpolated, then the contour boundary was drawn in the wrong place.
----------------------------
revision 1.906
date: 2005/09/16 22:08:29;  author: pfaedit;  state: Exp;  lines: +2 -2
Use to store debugging dpi/pointsize in the charview. Werner suggests that it be global (so different glyphs will all share the same defaults).
----------------------------
revision 1.905
date: 2005/09/16 21:25:59;  author: pfaedit;  state: Exp;  lines: +3 -3
Some Unicode code blocks have moved (probably those which only in the pipeline or some such), and some others have been added to the pipeline.
----------------------------
revision 1.904
date: 2005/09/15 16:54:33;  author: pfaedit;  state: Exp;  lines: +2 -2
Can't use a subroutine to refer to a translated glyph which contains flex hints in type1 output.
----------------------------
revision 1.903
date: 2005/09/15 15:26:06;  author: pfaedit;  state: Exp;  lines: +3 -3
Hide another problem with rounding errors in remove overlap.
----------------------------
revision 1.902
date: 2005/09/14 20:33:00;  author: pfaedit;  state: Exp;  lines: +2 -2
Don't produce multiple warnings about the local encoding.
----------------------------
revision 1.901
date: 2005/09/14 19:34:24;  author: pfaedit;  state: Exp;  lines: +2 -2
In quadratic fonts the Remove Overlap menu item is disabled, but if you use the hotkey the command is invoked (with disasterous results).
----------------------------
revision 1.900
date: 2005/09/14 18:19:04;  author: pfaedit;  state: Exp;  lines: +3 -3
Typo in point info code to determine whether a hint mask contains conflicts (matched vertical hints against horizontal ons)
----------------------------
revision 1.899
date: 2005/09/12 14:21:49;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a scripting command: DefaultUseMyMetrics() to set the bit appropriately in legacy fonts.
----------------------------
revision 1.898
date: 2005/09/12 01:04:51;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. I added a "UseMyMetrics" checkbox, but I didn't ever use the result in get info.
----------------------------
revision 1.897
date: 2005/09/11 22:34:14;  author: pfaedit;  state: Exp;  lines: +2 -2
   When ff pastes refs from one font to another it tries to figure out
	the width of a glyph containing references from the width of
	what appears to be the base glyph.
(because if you paste Aacute from one font to another, the size of the "A" glyph may be quite different in the new font. Using the width of the glyph in the original font would be wrong).

There are two problems with this:
	1) It didn't take forward references into account, and would use
		the original width rather than the modified width of the
		reference.
	2) It would (probably) be confused by an Alphatonos where the
		width of Alphatonos is not the same as that of Alpha.

instead figure widths out after all pastes have completed, looking at the use_my_metrics bit to get things right.
----------------------------
revision 1.896
date: 2005/09/11 21:31:04;  author: pfaedit;  state: Exp;  lines: +2 -2
Someone handed me a test case where he copied some glyphs from one font, closed it, opened another, pasted. The result was that the from-sf and the to-sf were the same pointer, even though the from font was long closed.
----------------------------
revision 1.895
date: 2005/09/11 18:56:50;  author: pfaedit;  state: Exp;  lines: +3 -3
Support the ttf "_USE_MY_METRICS" bit on composite glyphs. This entails:
	* Retaining it when reading a truetype font
	* Setting properly when generating one
	* Storing it in sfd files
	* Giving the user a way to set it with the Element->GetInfo command
----------------------------
revision 1.894
date: 2005/09/10 03:44:19;  author: pfaedit;  state: Exp;  lines: +2 -2
The save fontdlg wasn't quite right (with respect to the new bitmap type: PS Type3).
----------------------------
revision 1.893
date: 2005/09/10 03:29:09;  author: pfaedit;  state: Exp;  lines: +2 -2
Normal compilations broke, only multilayered ones worked.
----------------------------
revision 1.892
date: 2005/09/09 21:45:18;  author: pfaedit;  state: Exp;  lines: +2 -2
In order to prevent generating bdf fonts where we have multiple glyphs with the same name, lets do a simple check for possible duplicates in the font, and rename those glyphs.
----------------------------
revision 1.891
date: 2005/09/09 21:43:37;  author: pfaedit;  state: Exp;  lines: +2 -2
If we have a bdf font with two glyphs with the same name, then ff would crash.
----------------------------
revision 1.890
date: 2005/09/09 21:01:03;  author: pfaedit;  state: Exp;  lines: +2 -2
Uninitialized variable in the code which figures out what to enable in the dependants submenu.
----------------------------
revision 1.889
date: 2005/09/09 20:53:52;  author: pfaedit;  state: Exp;  lines: +2 -2
Pasting a reference into a font which did not contain the referred glyph did not give you the option of copying the original outlines any more.
----------------------------
revision 1.888
date: 2005/09/09 18:58:21;  author: pfaedit;  state: Exp;  lines: +2 -2
MergeFonts copies SplineChar structures, and when I added the altuni structure I did not make the copy routine handle them. The result was that two splinechars had the same altuni list and if one were freed... bad things happened.
(this crashed lilypond).
----------------------------
revision 1.887
date: 2005/09/09 18:26:50;  author: pfaedit;  state: Exp;  lines: +3 -3
Couple of tweaks to the warning window.
----------------------------
revision 1.886
date: 2005/09/09 04:21:49;  author: pfaedit;  state: Exp;  lines: +2 -2
I'm very old fashioned. I like having error messages on stderr. But far too many people don't see them there. I guess they invoke fontforge directly from X with stderr directed to some invisible console window. Well create a little window to contain warning messages about font errors (for instance when reading an otf font we might complain about glyphs out of bounds, etc.)
----------------------------
revision 1.885
date: 2005/09/08 22:02:10;  author: pfaedit;  state: Exp;  lines: +3 -3
Add support for postscript bitmap fonts. This means:
  Ability to parse (simple forms of) the imagemask ps operator
  Code to detect that a type3 is a ps bitmap, and convert it into a normal
	bitmap font that people can edit.
  Bitmap output as a ps type3 font (using imagemask)
  Fixing a bug in my output routines which worked fine for images in eps files,
	but failed horribly if that same code was stuffed into a charproc and
	executed on demand.
----------------------------
revision 1.884
date: 2005/09/06 15:24:44;  author: pfaedit;  state: Exp;  lines: +2 -2
ff could not handle an encoding specified as a simple array. (Not allowed in type1 spec, but obvious for a type3)
And ff's handling of any type3s was broken by the encoding patch.
----------------------------
revision 1.883
date: 2005/09/06 14:37:29;  author: pfaedit;  state: Exp;  lines: +3 -3
If a font contained fewer than 256 glyphs, then ff failed to load a format0 cmap subtable properly.
----------------------------
revision 1.882
date: 2005/09/04 22:35:05;  author: pfaedit;  state: Exp;  lines: +3 -3
In fontinfo, changed the tab "TTF Values" to be "OS/2", consolidated the
Panose tab underneath it. Added many more fields, almost all of OS/2.
----------------------------
revision 1.881
date: 2005/09/04 00:12:48;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix a bunch of uninitialized variables. Some real, some products of gcc's imagination.
----------------------------
revision 1.880
date: 2005/09/03 21:04:09;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix some uninitialized values in fontview.
----------------------------
revision 1.879
date: 2005/09/03 20:54:17;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix a couple of uninitialized variables.
----------------------------
revision 1.878
date: 2005/09/03 19:40:50;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops. Unternimated comment masked some code.
----------------------------
revision 1.877
date: 2005/09/02 19:58:08;  author: pfaedit;  state: Exp;  lines: +2 -2
Scripting WorthOutputting command insisted on having an argument, even though it should have accepted no arguments.
----------------------------
revision 1.876
date: 2005/09/02 19:53:51;  author: pfaedit;  state: Exp;  lines: +3 -3
Scripting SetCharCnt command has been broken since the encoding change.
----------------------------
revision 1.875
date: 2005/09/01 15:28:46;  author: pfaedit;  state: Exp;  lines: +3 -3
Fix a buffer overrun. I don't see how it could cause any problems, but it makes some people happier.
----------------------------
revision 1.874
date: 2005/08/31 17:55:56;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops, fix a typo in problems.
----------------------------
revision 1.873
date: 2005/08/31 17:54:01;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops. We were also using obsolete mac function calls inside the library (gdraw), so get rid of them, and while we're at it, use the mac headers directly instead of having our own copy of them.
----------------------------
revision 1.872
date: 2005/08/30 14:27:46;  author: pfaedit;  state: Exp;  lines: +3 -3
The concept of maintaining a "hidden" set of os2 metrics different from the one on display is a really bad one. People can't change them and rightly report that as a bug.
----------------------------
revision 1.871
date: 2005/08/29 20:47:05;  author: pfaedit;  state: Exp;  lines: +3 -3
Importing an eps file (or the X clipboard) into a glyph made use of an uninitialzed variable.
----------------------------
revision 1.870
date: 2005/08/29 03:23:48;  author: pfaedit;  state: Exp;  lines: +3 -3
The "Original" encoding was broken, and reencoding to it gaves us 256 blank glyphs before glyph0. Sigh.
----------------------------
revision 1.869
date: 2005/08/27 14:17:13;  author: pfaedit;  state: Exp;  lines: +2 -2
Cleanup pasting references from one font to another (gave some very strange results when pasting refs with no unicode encodings).
----------------------------
revision 1.868
date: 2005/08/27 03:49:38;  author: pfaedit;  state: Exp;  lines: +3 -3
Do the same thing for create hint that we did for add hint.
----------------------------
revision 1.867
date: 2005/08/25 14:00:25;  author: pfaedit;  state: Exp;  lines: +3 -3
Yesterday's patch to make mac resource files work without FSSpec failed when trying to create a file that already existed.
----------------------------
revision 1.866
date: 2005/08/25 04:34:01;  author: pfaedit;  state: Exp;  lines: +3 -3
Recode the mac resource fork routines so that they no longer use the FSSpec structure. 10.4 complains about it.
----------------------------
revision 1.865
date: 2005/08/22 13:41:32;  author: pfaedit;  state: Exp;  lines: +3 -3
I broke sfddiff again.
----------------------------
revision 1.864
date: 2005/08/22 13:19:54;  author: pfaedit;  state: Exp;  lines: +2 -2
Bug in mm font charstring generation.
----------------------------
revision 1.863
date: 2005/08/22 05:39:03;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix up old multiple master sfd files which didn't always set the orig_pos correctly.
----------------------------
revision 1.862
date: 2005/08/22 03:02:30;  author: pfaedit;  state: Exp;  lines: +2 -2
Fixed an uninitialized variable in the new type1 reference code.
----------------------------
revision 1.861
date: 2005/08/22 03:00:26;  author: pfaedit;  state: Exp;  lines: +2 -2
If a font contained mac feature setting names, then when ff generated it, ff wou
ld produce duplicate entries in the 'name' table for these guys. One for the nam
e in the font itself, and one for the name ff thought that feature setting shoul
d have.
----------------------------
revision 1.860
date: 2005/08/21 16:34:56;  author: pfaedit;  state: Exp;  lines: +2 -2
Nobody else puts apple unicode names into the 'name' table so I probably should not either. Adobe says one should not. Apple's website implies one should -- but Apple doesn't and it's ttf website is not very accurate.
----------------------------
revision 1.859
date: 2005/08/21 16:00:39;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a configure option to allow users to generate mac only fonts (those with version number 'true').
----------------------------
revision 1.858
date: 2005/08/20 20:34:15;  author: pfaedit;  state: Exp;  lines: +3 -3
When ff generated a ttf/otf font with applemode set and opentype off then the font would have version 'true'. Which means windows would reject it. That's probably not a good idea given that this situation is default on the mac -- even if we don't have a GSUB/GPOS table we should at least let the glyphs show on windows.
----------------------------
revision 1.857
date: 2005/08/19 19:52:54;  author: pfaedit;  state: Exp;  lines: +3 -3
ff couldn't undo changing the lig carets (if it weren't compiled for multilayer)
----------------------------
revision 1.856
date: 2005/08/19 04:18:37;  author: pfaedit;  state: Exp;  lines: +3 -3
Copying a pairwise PST left memory in a bad state.
----------------------------
revision 1.855
date: 2005/08/17 21:43:06;  author: pfaedit;  state: Exp;  lines: +2 -2
Alexej Kryukov suggests that instead of making a special case and coalescing all kern lookups into one, I have a more general check which merges any two lookups with the same (tag/sli/flags). The addition of sli means that the sub-tables will not be share with other lookups.
----------------------------
revision 1.854
date: 2005/08/17 20:12:38;  author: pfaedit;  state: Exp;  lines: +2 -2
When rasterizing a multilayer font we would sometimes get warnings from the stroker about how the stroke self-intersected. Get rid of those warnings.
----------------------------
revision 1.853
date: 2005/08/17 20:05:45;  author: pfaedit;  state: Exp;  lines: +2 -2
Pasting from a multilayered font into a normal one:
  1) Crashed
  2) Only showed the last layer.
----------------------------
revision 1.852
date: 2005/08/17 19:56:39;  author: pfaedit;  state: Exp;  lines: +3 -3
If an order2 font were turned into a PS font, then characters with hint conflicts got no hints.
----------------------------
revision 1.851
date: 2005/08/17 02:16:48;  author: pfaedit;  state: Exp;  lines: +2 -2
Makers of fonts on the mac often use out of bound GIDs as flags in contextual substitutions. What I have seen is that one sub-table will insert such a "glyph" when a match is found, and then the next sub table will remove the flag, and perform subsequent transformations. This is important on the mac because there is a limited number of substitutions that can happen once a match is found, but if a match is found at the start (ie. the match being some magic marker glyph) then unlimited substitutions are available.
When ff first stumbled on these fonts it crashed, then it treated a gid>glyph_cnt as an error (and so it ignored the substitution). I've just put in code that creates dummy glyphs for all these bizarre GIDs so (I hope) the font will work after passing through ff (only there will be some real blank glyphs at the end of the font rather than vaper ware glyphs).
----------------------------
revision 1.850
date: 2005/08/16 22:06:40;  author: pfaedit;  state: Exp;  lines: +2 -2
When I did the type1 rework I realized I missed some hints in the type2 rework. Get them in type2 now as well.
----------------------------
revision 1.849
date: 2005/08/16 22:04:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a routine which will allow autohinting of glyphs that only contain references, while leaving others untouched.
----------------------------
revision 1.848
date: 2005/08/16 15:18:50;  author: pfaedit;  state: Exp;  lines: +2 -2
Improve subroutine usage in pfa/b fonts
Get hints right for referenced glyphs.
----------------------------
revision 1.847
date: 2005/08/16 15:02:15;  author: pfaedit;  state: Exp;  lines: +3 -3
When we read a pfb file, and seac-ed glyph will contain no hints. So we should mark it as in need of autohinting.
----------------------------
revision 1.846
date: 2005/08/15 14:03:47;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops, forgot about CID otf.
----------------------------
revision 1.845
date: 2005/08/15 03:24:02;  author: pfaedit;  state: Exp;  lines: +2 -2
The Active Hints pane didn't always work if a glyph had more than one contour.
----------------------------
revision 1.844
date: 2005/08/15 03:19:24;  author: pfaedit;  state: Exp;  lines: +2 -2
The code still didn't do hint substitutions properly for references with hint subs which were output inline.
----------------------------
revision 1.843
date: 2005/08/14 20:55:32;  author: pfaedit;  state: Exp;  lines: +3 -3
Be more canny in the use of subroutines in otf/cff. This patch reduced a cff font by 8% (for a large font with lots of references).
----------------------------
revision 1.842
date: 2005/08/14 20:42:01;  author: pfaedit;  state: Exp;  lines: +3 -3
Only coalesce multiple subtables into one lookup of the feature is kern.
----------------------------
revision 1.841
date: 2005/08/14 20:37:41;  author: pfaedit;  state: Exp;  lines: +2 -2
When generating nested contextual lookups, ff did not reset the lookup count to zero between gpos/gsub. So if there were contextuals in both gpos & gsub, ff got confused when doing gsub.
----------------------------
revision 1.840
date: 2005/08/14 20:21:14;  author: pfaedit;  state: Exp;  lines: +2 -2
ff would occasionally generate a format 4 cmap subtable which mapped glyph 0xffff to an encoding. This is an undocumented ability of the cmap table, so the encodings should work, but ff should not be generating them. This patch gets rid of them.
----------------------------
revision 1.839
date: 2005/08/14 19:54:57;  author: pfaedit;  state: Exp;  lines: +3 -3
When outputting a cff encoding (only important when generating a bare cff file) and there is a duplicate glyph reference in the first 256 chars of the encoding, then we would generate a bad encoding subtable.
----------------------------
revision 1.838
date: 2005/08/13 20:15:50;  author: pfaedit;  state: Exp;  lines: +3 -3
I find the prev control point hard to distinguish against the grey of a back ground image. Make it a bit darker.
----------------------------
revision 1.837
date: 2005/08/11 21:36:17;  author: pfaedit;  state: Exp;  lines: +3 -3
Configure the mac so that the capslock key can be used instead of the alt key (of which there is none) to modify the behavior of various tools. The obvious thing to do would be to use Option or Command, but on most systems clicking the mouse with these down will produce mouse button 2 or 3.
----------------------------
revision 1.836
date: 2005/08/10 13:09:44;  author: pfaedit;  state: Exp;  lines: +2 -2
Actually there is no reason for unencoded glyphs to get slots for their alterate encodings. There won't be any indication in the font that they are different.
----------------------------
revision 1.835
date: 2005/08/10 13:07:40;  author: pfaedit;  state: Exp;  lines: +2 -2
The big5 encoding stopped at 64000, which confused people who expected unencoded glyphs to start at 65536.
We would crash when reencoding a font with enough unencoded alternate unicode code points.
----------------------------
revision 1.834
date: 2005/08/10 13:04:46;  author: pfaedit;  state: Exp;  lines: +2 -2
The code for creating an 8/16 cmap subtable didn't work.
----------------------------
revision 1.833
date: 2005/08/10 12:55:47;  author: pfaedit;  state: Exp;  lines: +2 -2
ff would crash if it had two windows open on the same font and one got reencoded.
----------------------------
revision 1.832
date: 2005/08/10 12:25:16;  author: pfaedit;  state: Exp;  lines: +2 -2
Didn't set the length of the format4 'cmap' sub-table, so the offset to the form
at12 (32bit unicode) table was wrong.
----------------------------
revision 1.831
date: 2005/08/09 15:07:37;  author: pfaedit;  state: Exp;  lines: +3 -3
Oops, I need to set the xim bit for ttf name text fields.
----------------------------
revision 1.830
date: 2005/08/09 04:32:53;  author: pfaedit;  state: Exp;  lines: +2 -2
ttfcopyfile can complain about a ttf table offset being wrong. Give it the info so that it will now tell us which table has the wrong offset. Not much use because we still need to figure out what's going on using a debugger, but it makes the users happy to know.
----------------------------
revision 1.829
date: 2005/08/09 03:59:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Uninitialized variable in metricsview when creating a popup window.
----------------------------
revision 1.828
date: 2005/08/08 21:43:06;  author: pfaedit;  state: Exp;  lines: +3 -3
Redo the ttfnames pane of the font info dlg. Now show the names as an editable list.
----------------------------
revision 1.827
date: 2005/08/07 21:53:19;  author: pfaedit;  state: Exp;  lines: +2 -2
Histogram dlg still used wrong encodings for selected glyphs when historgrams invoked from Hints menu.
----------------------------
revision 1.826
date: 2005/08/07 21:32:24;  author: pfaedit;  state: Exp;  lines: +2 -2
Make the font info dlg respond (a little) to a resize.
----------------------------
revision 1.825
date: 2005/08/07 16:49:26;  author: pfaedit;  state: Exp;  lines: +2 -2
SelectIf failed when passed an encoding which was out of bounds.
----------------------------
revision 1.824
date: 2005/08/07 16:40:52;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a new scripting command: ToString
----------------------------
revision 1.823
date: 2005/08/07 15:25:07;  author: pfaedit;  state: Exp;  lines: +2 -2
Using the X clipboard to paste a glyph into a glyph that contained stuff caused a crash.
----------------------------
revision 1.822
date: 2005/08/07 15:06:52;  author: pfaedit;  state: Exp;  lines: +3 -3
Using the X clipboard to paste a glyph with references or with multilayer did not work.
----------------------------
revision 1.821
date: 2005/08/06 03:55:48;  author: pfaedit;  state: Exp;  lines: +2 -2
None of ttf, otf nor svg got multiply encoded glyphs output properly.
----------------------------
revision 1.820
date: 2005/08/06 03:49:15;  author: pfaedit;  state: Exp;  lines: +2 -2
FF screwed up memory when creating ligatures from an svg font.
----------------------------
revision 1.819
date: 2005/08/06 03:12:54;  author: pfaedit;  state: Exp;  lines: +2 -2
Previous patch for altinate unicode was inelegant.
----------------------------
revision 1.818
date: 2005/08/06 03:07:43;  author: pfaedit;  state: Exp;  lines: +2 -2
Preserve altinate unicode values for multiply encoded glyphs.
----------------------------
revision 1.817
date: 2005/08/05 22:43:40;  author: pfaedit;  state: Exp;  lines: +2 -2
Merge fonts was writing to bad memory.
----------------------------
revision 1.816
date: 2005/08/05 20:42:41;  author: pfaedit;  state: Exp;  lines: +2 -2
sfddiff didn't link.
----------------------------
revision 1.815
date: 2005/08/05 20:33:35;  author: pfaedit;  state: Exp;  lines: +2 -2
FF was confused by an MM font which contained the lines:
/Registry [
	    /WeightVector
	    /NormDesignVector
	    /DesignVector
	] readonly def
It tried to set Weight vector to /NormDesignVector\n\t/DesignVector
----------------------------
revision 1.814
date: 2005/08/05 20:07:50;  author: pfaedit;  state: Exp;  lines: +2 -2
FindExistingSlot should understand altuni.
----------------------------
revision 1.813
date: 2005/08/05 19:58:30;  author: pfaedit;  state: Exp;  lines: +3 -3
Font View didn't display current unicode of multiply encoded glyphs. (same for popups).
----------------------------
revision 1.812
date: 2005/08/05 04:14:28;  author: pfaedit;  state: Exp;  lines: +2 -2
Still having problems generating type1 code for complicated reference glyphs.
----------------------------
revision 1.811
date: 2005/08/05 00:56:44;  author: pfaedit;  state: Exp;  lines: +2 -2
Retain knowlege of multiple unicode encodings for some glyphs. Used when a glyph has multiple encodings and is reencoded.
----------------------------
revision 1.810
date: 2005/08/04 22:11:30;  author: pfaedit;  state: Exp;  lines: +2 -2
Sigh. People prefer Compact encodings to Original.
----------------------------
revision 1.809
date: 2005/08/04 14:58:33;  author: pfaedit;  state: Exp;  lines: +3 -3
Force encoding didn't work if the new encoding had more slots than the old.
----------------------------
revision 1.808
date: 2005/08/03 20:58:17;  author: pfaedit;  state: Exp;  lines: +3 -3
FF failed to parse class based contextual lookups (but handled contextual chaining ok).
----------------------------
revision 1.807
date: 2005/08/03 01:11:00;  author: pfaedit;  state: Exp;  lines: +2 -2
Brr. gb2323pk still broken.
Seems to be a bug in iconv related to CP1258->UCS2. I found some hacks that seem render the bug less severe.
----------------------------
revision 1.806
date: 2005/08/02 23:06:39;  author: pfaedit;  state: Exp;  lines: +2 -2
FF didn't support EUC-CN, ISO-2022-CN, ISO=2022-KR iconv encodings properly.
----------------------------
revision 1.805
date: 2005/08/02 22:08:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Fill in the missing charsets in the OS/2 CodeRanges field:
	Vietnamese
	Traditional Chinese
	Mac Roman
	PC OEM
----------------------------
revision 1.804
date: 2005/08/02 21:50:19;  author: pfaedit;  state: Exp;  lines: +3 -3
I was failing to detect ASCII in the code which generated the OS/2 coderanges. Which meant none of the latin code ranges were set.
----------------------------
revision 1.803
date: 2005/08/01 21:34:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Put some code in to warn users about unknown language/locales in the ttf 'name' table.
----------------------------
revision 1.802
date: 2005/08/01 19:42:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Enter some new language/locale codes for ms.
----------------------------
revision 1.801
date: 2005/08/01 14:45:51;  author: pfaedit;  state: Exp;  lines: +3 -3
Crash when moving the end of an open path in an order2 font.
----------------------------
revision 1.800
date: 2005/08/01 14:12:42;  author: pfaedit;  state: Exp;  lines: +2 -2
If one loaded a Unicode style encoding and then cancelled the dlg which asked for a name for that encoding, then ff would crash.
----------------------------
revision 1.799
date: 2005/08/01 14:08:54;  author: pfaedit;  state: Exp;  lines: +2 -2
Don't use Adobe's glyphnames when they are obviously wrong (use uni???? instead)
----------------------------
revision 1.798
date: 2005/08/01 14:04:00;  author: pfaedit;  state: Exp;  lines: +2 -2
Add support for the new dotlessj
----------------------------
revision 1.797
date: 2005/07/31 20:04:45;  author: pfaedit;  state: Exp;  lines: +2 -2
Put a check into the context chain dlg to make sure that people don't add sequence/lookup pairs where the sequence number is too big.
----------------------------
revision 1.796
date: 2005/07/31 19:23:10;  author: pfaedit;  state: Exp;  lines: +2 -2
Make class be the default format for contextual/chaining substitutions rather than coverage tables.
----------------------------
revision 1.795
date: 2005/07/31 19:13:41;  author: pfaedit;  state: Exp;  lines: +2 -2
Damn. The format of the LineBreak.txt file changed too, so all the line break info is wrong (essentially lines never broke).
----------------------------
revision 1.794
date: 2005/07/31 17:57:46;  author: pfaedit;  state: Exp;  lines: +2 -2
Reference to bad memory when creating a popup in combinations list.
----------------------------
revision 1.793
date: 2005/07/31 17:34:30;  author: pfaedit;  state: Exp;  lines: +2 -2
Indicate which gadget gets focus in kern class dlg when creating a new class.
----------------------------
revision 1.792
date: 2005/07/31 15:56:34;  author: pfaedit;  state: Exp;  lines: +2 -2
More work on the name table. Test for substrings.
----------------------------
revision 1.791
date: 2005/07/31 15:04:39;  author: pfaedit;  state: Exp;  lines: +3 -3
Still problems when Mac & Mac Unicode strings don't match.
----------------------------
revision 1.790
date: 2005/07/30 20:59:56;  author: pfaedit;  state: Exp;  lines: +2 -2
Taking something out of the X clipboard also resulted in a crash.
----------------------------
revision 1.789
date: 2005/07/30 20:47:56;  author: pfaedit;  state: Exp;  lines: +2 -2
Attempting to put a glyph into the X clipboard crashed if MultiLayer was enabled.
----------------------------
revision 1.788
date: 2005/07/30 20:30:44;  author: pfaedit;  state: Exp;  lines: +2 -2
View->Combinations only showed selected combinations (It should show all)
----------------------------
revision 1.787
date: 2005/07/30 20:14:37;  author: pfaedit;  state: Exp;  lines: +2 -2
If neither Apple mode nor OpenType mode were set, then the presence of a kerning class would force a new Apple-style 'kern' table. And it should not have. Instead decompose all kerning classes into kern pairs as we do for AFM files and generate an old style table.
----------------------------
revision 1.786
date: 2005/07/30 19:51:26;  author: pfaedit;  state: Exp;  lines: +3 -3
Scripting didn't have a way to generate a font with neither Apple nor OpenType tables. Add one.
----------------------------
revision 1.785
date: 2005/07/29 21:00:53;  author: pfaedit;  state: Exp;  lines: +2 -2
Oops. wrong default extension for otb fonts from scripts.
----------------------------
revision 1.784
date: 2005/07/29 20:53:59;  author: pfaedit;  state: Exp;  lines: +3 -3
Make sure glyphmax is right. Often we weren't updating it (or even setting it).
----------------------------
revision 1.783
date: 2005/07/28 17:00:12;  author: pfaedit;  state: Exp;  lines: +2 -2
If we create a bitmap strike in an empty font, then change the fontview to look at the strike.
----------------------------
revision 1.782
date: 2005/07/28 16:58:48;  author: pfaedit;  state: Exp;  lines: +2 -2
Do a better job on empty fonts.
----------------------------
revision 1.781
date: 2005/07/28 16:43:42;  author: pfaedit;  state: Exp;  lines: +3 -3
FontView Set Width (and friends) produced a garbage value for the default width if the font had no glyphs.
----------------------------
revision 1.780
date: 2005/07/27 20:39:57;  author: pfaedit;  state: Exp;  lines: +2 -2
Order2 (TrueType) fonts should not have the hinting needed mark set either.
Furthermore we should set reset the mark when we change a font from normal cubic to quadratic or multilayer (and back).
----------------------------
revision 1.779
date: 2005/07/27 20:19:31;  author: pfaedit;  state: Exp;  lines: +3 -3
Fix another encoding related crash.
----------------------------
revision 1.778
date: 2005/07/27 20:16:07;  author: pfaedit;  state: Exp;  lines: +2 -2
Clear Background in fontview would usually crash.
----------------------------
revision 1.777
date: 2005/07/27 20:12:23;  author: pfaedit;  state: Exp;  lines: +2 -2
Don't want the hinting needed bit for multilayer or stroked fonts.
----------------------------
revision 1.776
date: 2005/07/27 01:06:20;  author: pfaedit;  state: Exp;  lines: +2 -2
:-) Generate Multiple gave incorrect filenames if:
	1) The %s was in the middle of the filename (without extension)
	2) The sub-font was identified by a single character.
----------------------------
revision 1.775
date: 2005/07/26 22:18:39;  author: pfaedit;  state: Exp;  lines: +3 -3
MergeFonts sets things in a bad state.
----------------------------
revision 1.774
date: 2005/07/25 04:22:34;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix various annoying bugs with new encoding stuff.
----------------------------
revision 1.773
date: 2005/07/24 23:40:48;  author: pfaedit;  state: Exp;  lines: +2 -2
Adding new glyphs to a font could look at uninitialized values.
----------------------------
revision 1.772
date: 2005/07/24 22:33:44;  author: pfaedit;  state: Exp;  lines: +2 -2
We were getting annoying "No outline" marks for ".notdef".
----------------------------
revision 1.771
date: 2005/07/24 22:21:24;  author: pfaedit;  state: Exp;  lines: +2 -2
The Save command failed to reset the font's title, so it still looked as if the font were modified.
----------------------------
revision 1.770
date: 2005/07/24 22:15:59;  author: pfaedit;  state: Exp;  lines: +2 -2
The Build sub-menu of the fontview wasn't properly enabled when selection was a non-existant glyph.
----------------------------
revision 1.769
date: 2005/07/24 22:11:06;  author: pfaedit;  state: Exp;  lines: +2 -2
FF still didn't let the user create two ligatures for one glyph.
----------------------------
revision 1.768
date: 2005/07/24 21:57:26;  author: pfaedit;  state: Exp;  lines: +2 -2
Next/Prev buttons were working properly in Glyph Info dlg.
----------------------------
revision 1.767
date: 2005/07/24 21:36:31;  author: pfaedit;  state: Exp;  lines: +2 -2
Detach Glyphs was dis/enabled in the menu exactly the wrong times.
----------------------------
revision 1.766
date: 2005/07/24 19:54:01;  author: pfaedit;  state: Exp;  lines: +2 -2
Added a new Scripting function
	GetPosSub(tag,script,lang)
Which expects a single character to be selected, searches through the glyph's list of substitutions/positions checks if there are any matches. If there are it returns an array of arrays. Each sub array corresponds to a feature that matched and contains:
	Feature tag (as a string)
	Script/Lang list (as a string)
	Type (A string, one of Position,Pair,Substitution,AltSubs,MultSubs,Ligature)
The remaining entries depend on the Type
 For Positions
	a list of four numbers (dx,dy,d_hor_advance,d_vert_advance)
 For Pairs
	A string containing the name of the second glyph in the pair
	a list of eight numbers (dx,dy,dha,dva for first glyph, dx,dy,dha,dva for second glyph)
 For Substitutions
	A string containing the name of the glyph to be substituted
 For the others
	A set of glyph names (strings), one for glyph in the substitution.
----------------------------
revision 1.765
date: 2005/07/24 17:55:31;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a "TypeOf" routine to scripting.
----------------------------
revision 1.764
date: 2005/07/23 14:03:48;  author: pfaedit;  state: Exp;  lines: +3 -3
Werner says negative widths should also be set to 0 in tfm files.
----------------------------
revision 1.763
date: 2005/07/23 02:59:34;  author: pfaedit;  state: Exp;  lines: +2 -2
FontForge was generating an incorrect warning message.
If a 'name' table contains a duplicate entry for a given platform/specific/language/id that's an error in the font. But ff conflated mac names with window names and so was only checking language/id. So if the mac windows names were different (which is probably a bad design idea, but not an error) ff said it was wrong.
----------------------------
revision 1.762
date: 2005/07/23 01:47:16;  author: pfaedit;  state: Exp;  lines: +2 -2
Don't set "Hinting needed" flag in bitmap only fonts.
----------------------------
revision 1.761
date: 2005/07/22 21:33:02;  author: pfaedit;  state: Exp;  lines: +2 -2
AutoHint had a crash if there were open contours in a glyph being hinted.
----------------------------
revision 1.760
date: 2005/07/22 20:59:40;  author: pfaedit;  state: Exp;  lines: +3 -3
Add a couple of browsers to the list to check by default.
----------------------------
revision 1.759
date: 2005/07/22 04:39:45;  author: pfaedit;  state: Exp;  lines: +2 -2
Revert Werner's request for special handling of CJK glyphs in tfm files.
----------------------------
revision 1.758
date: 2005/07/21 22:51:25;  author: pfaedit;  state: Exp;  lines: +2 -2
Still haven't gotten bitmap size right.
----------------------------
revision 1.757
date: 2005/07/21 18:07:35;  author: pfaedit;  state: Exp;  lines: +2 -2
Using the kerning pair close up dlg to create a new kerning pair caused a crash eventually.
----------------------------
revision 1.756
date: 2005/07/21 17:24:29;  author: pfaedit;  state: Exp;  lines: +2 -2
Better way to fix bitmap groups.
----------------------------
revision 1.755
date: 2005/07/21 17:21:36;  author: pfaedit;  state: Exp;  lines: +2 -2
When saving a set of bitmap glyphs all of which had approximately the same metrics, ff entered the size per glyph field without checking the depth. So for single bit glyphs the result was 8 times too big.
----------------------------
revision 1.754
date: 2005/07/21 13:18:51;  author: pfaedit;  state: Exp;  lines: +3 -3
kern pairs were not scaled to emsize when loading an afm file.
----------------------------
revision 1.753
date: 2005/07/21 04:29:33;  author: pfaedit;  state: Exp;  lines: +2 -2
Add a series of new selection commands, to the font view and to scripting:
	SelectChangedGlyphs
	SelectHintingNeeded
(just to scripting)
	SelectSingletons
	SelectMoreSingletons
	SelectFewerSingletons
----------------------------
revision 1.752
date: 2005/07/21 03:25:00;  author: pfaedit;  state: Exp;  lines: +2 -2
Revert Glyph didn't work. One bug caused by multilayer, one caused by encoding changes, and one really old one.
----------------------------
revision 1.751
date: 2005/07/20 21:21:21;  author: pfaedit;  state: Exp;  lines: +2 -2
GetFontNames returned an uninitialized value on bad ttf files.
----------------------------
revision 1.750
date: 2005/07/20 20:09:19;  author: pfaedit;  state: Exp;  lines: +2 -2
Add some new scripting commands to access the TeX per-glyph fields
----------------------------
revision 1.749
date: 2005/07/20 19:56:56;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner suggested some improvements to tfm output.
----------------------------
revision 1.748
date: 2005/07/20 18:56:07;  author: pfaedit;  state: Exp;  lines: +3 -3
Cleanup behavior of generating ttf bitmaps in a script.
----------------------------
revision 1.747
date: 2005/07/20 03:05:58;  author: pfaedit;  state: Exp;  lines: +2 -2
I was attaching script/langs to lookups. That wasn't good enough. Each sub-table and have it's own set, so attach script/langs to subtables as well.
Still a bug in that sub-tables could be referenced through severl extension sub-tables or directly and I don't unravel that complexity until too late.
----------------------------
revision 1.746
date: 2005/07/20 03:01:55;  author: pfaedit;  state: Exp;  lines: +2 -2
ATM which handles some kerning for otf fonts for Word, does not handle 'kern' features where the feature contains more than one lookup. So whenever we have a feature with multiple lookups try to compress them into one lookup with multiple sub-tables.
----------------------------
revision 1.745
date: 2005/07/20 02:54:09;  author: pfaedit;  state: Exp;  lines: +2 -2
Transform (in fontview) and Scale To Em do not scale the vertical advance.
----------------------------
revision 1.744
date: 2005/07/19 22:44:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Still problems with detecting where a subroutine begins.
----------------------------
revision 1.743
date: 2005/07/19 21:32:08;  author: pfaedit;  state: Exp;  lines: +2 -2
Remove Undoes was broken by the encoding changes.
----------------------------
revision 1.742
date: 2005/07/19 21:23:05;  author: pfaedit;  state: Exp;  lines: +2 -2
Generating a statemachine from a FPST had problems introduced by the encoding change.
----------------------------
revision 1.741
date: 2005/07/19 13:41:02;  author: pfaedit;  state: Exp;  lines: +3 -3
When saving multiple, make sure the afm,tfm files don't contain kerns to glyphs outside of the subfonts.
----------------------------
revision 1.740
date: 2005/07/19 02:35:06;  author: pfaedit;  state: Exp;  lines: +2 -2
We didn't test the right thing when deciding where a subroutine containing refs began.
----------------------------
revision 1.739
date: 2005/07/18 22:36:12;  author: pfaedit;  state: Exp;  lines: +3 -3
A bit of extranious code snuck in to the kern class dlg in the selection work.
----------------------------
revision 1.738
date: 2005/07/17 20:56:19;  author: pfaedit;  state: Exp;  lines: +2 -2
Make sure the blue lines (marking hints needing to be updated) get cleared properly.
----------------------------
revision 1.737
date: 2005/07/17 20:32:51;  author: pfaedit;  state: Exp;  lines: +2 -2
Some display problems in the SameGlyphAs command.
----------------------------
revision 1.736
date: 2005/07/17 20:17:34;  author: pfaedit;  state: Exp;  lines: +2 -2
Selection of kern classes didn't take into account scrolling.
----------------------------
revision 1.735
date: 2005/07/17 19:59:20;  author: pfaedit;  state: Exp;  lines: +3 -3
The Apply Substitutions code did not consider the possibility of loops:
	a->b->c->d->a
----------------------------
revision 1.734
date: 2005/07/15 20:59:21;  author: pfaedit;  state: Exp;  lines: +3 -3
Context chain dlg had problems with empty patterns (no terminal NUL in empty str
ing used to represent them).
----------------------------
revision 1.733
date: 2005/07/13 23:21:27;  author: pfaedit;  state: Exp;  lines: +2 -2
The [EditData] button in contextual fontinfo pane was disabled due to reasons which were no longer valid.
----------------------------
revision 1.732
date: 2005/07/13 23:12:11;  author: pfaedit;  state: Exp;  lines: +2 -2
Doing a transformation with a negative scale factor screwed up the hints.
----------------------------
revision 1.731
date: 2005/07/13 22:25:13;  author: pfaedit;  state: Exp;  lines: +2 -2
Add move up/down buttons to the kern class dlg
Draw the selection from the class list boxes down in the offsets area.
----------------------------
revision 1.730
date: 2005/07/13 18:56:29;  author: pfaedit;  state: Exp;  lines: +2 -2
Fix yet another crash caused be referencing by encoding rather than gid.
----------------------------
revision 1.729
date: 2005/07/13 18:41:42;  author: pfaedit;  state: Exp;  lines: +3 -3
Fix a crash when generating Apple tables in a font with non-contiguous glyph array (ttc, cid-keyed, font with errors).
----------------------------
revision 1.728
date: 2005/07/12 22:43:22;  author: pfaedit;  state: Exp;  lines: +3 -3
Bad loop bounds check.
----------------------------
revision 1.727
date: 2005/07/12 03:47:20;  author: pfaedit;  state: Exp;  lines: +2 -2
Patch half made as we diverged from DirectEncoding branch. Tfm data were improperly scaled.
----------------------------
revision 1.726
date: 2005/07/12 03:26:58;  author: pfaedit;  state: Exp;  lines: +2 -2
Next/Prev Defined character in the charview didn't skip over .notdef.
----------------------------
revision 1.725
date: 2005/07/11 21:11:22;  author: pfaedit;  state: Exp;  lines: +2 -2
Werner suggests indicating multi-layer in the version string.
----------------------------
revision 1.724
date: 2005/07/11 20:52:37;  author: pfaedit;  state: Exp;  lines: +2 -2
Mark to Mark anchor classes allow each mark glyph also to contain a base mark entry.
